////////////////////////////////////////////////////////////////////////////////
//
// Proyecto Medusa v3.0
//
//////////////////////////////////// INFO //////////////////////////////////////
//
//  Nombre del programa : Medusa.exe
//  Fecha               : Septiembre del 2003.
//  Componentes         : DOA 3.4.6.4, SynEdit 1.1 (CVS).
//  Version compilador  : Delphi 6.0 Enterprise.
//  Descripcin         : Un cliente avanzado de Oracle
//  Autor               : Albert Philippe De La Fuente Vigliotti.
//  Tutor               : Jos Galindo Gmez.
//
////////////////////////////////////////////////////////////////////////////////

program Medusa;

uses
  Forms,
  Dialogs,
  UConfiguracion in 'UConfiguracion.pas' {FrmConfiguracion},
  UPreview in 'UPreview.pas' {FrmPreview},
  UPrincipal in 'UPrincipal.pas' {FrmPrincipal},
  UGlobal in 'UGlobal.pas',
  UAbout in 'UAbout.pas' {FrmAbout},
  UEditor in 'UEditor.pas' {FrmEditor},
  UBuscar in 'UBuscar.pas' {FrmBuscarTexto},
  UConfirmarReemplazar in 'UConfirmarReemplazar.pas' {FrmConfirmarReemplazo},
  UReemplazar in 'UReemplazar.pas' {FrmReemplazarTexto},
  UInformacion in 'UInformacion.pas' {FrmInformacion},
  UReconstruirCreateTable in 'UReconstruirCreateTable.pas' {FrmReconstruirCreateTable},
  UCabecerasPlantillas in 'UCabecerasPlantillas.pas' {FrmCabeceraPlantilla},
  UVisualProcFuncs in 'UVisualProcFuncs.pas' {FrmVisualProcFuncs},
  UVisualTriggers in 'UVisualTriggers.pas' {FrmVisualTriggers},
  USplash in 'USplash.pas' {FrmSplash},
  UPermisos in 'UPermisos.pas' {FrmPermisos},
  UDMGlobal in 'UDMGlobal.pas' {DMGlobal: TDataModule},
  UEstructuraBD in 'UEstructuraBD.pas' {FrmEstructuraBD},
  UBuffer in 'UBuffer.pas' {FrmBuffer},
  UFormatosFecha in 'UFormatosFecha.pas' {FrmFormatoFechas},
  UComentarios in 'UComentarios.pas' {FrmComentarios},
  UVisualPackages in 'UVisualPackages.pas' {FrmVisualPackages},
  UVisualJava in 'UVisualJava.pas' {FrmVisualJava},
  UVisualSeqs in 'UVisualSeqs.pas' {FrmVisualSeqs},
  UVisualSynonyms in 'UVisualSynonyms.pas' {FrmVisualSynonyms},
  UVisualViews in 'UVisualViews.pas' {FrmVisualViews},
  UVisualTablespaces in 'UVisualTablespaces.pas' {FrmVisualTablespaces},
  UVisualProfile in 'UVisualProfile.pas' {FrmVisualProfiles},
  UVisualUsers in 'UVisualUsers.pas' {FrmVisualUsers},
  UVisualIndexes in 'UVisualIndexes.pas' {FrmVisualIndexes};

var
  FrmSplash  : TFrmSplash;
 
{$R *.res}

begin
  Application.Initialize;
  FrmSplash := TFrmSplash.Create(Application);
  FrmSplash.ShowModal;
  FrmSplash.Update;
  Application.CreateForm(TFrmPrincipal, FrmPrincipal);
  Application.CreateForm(TFrmConfiguracion, FrmConfiguracion);
  Application.CreateForm(TFrmPreview, FrmPreview);
  Application.CreateForm(TFrmAbout, FrmAbout);
  Application.CreateForm(TFrmConfirmarReemplazo, FrmConfirmarReemplazo);
  Application.CreateForm(TFrmInformacion, FrmInformacion);
  Application.CreateForm(TFrmReconstruirCreateTable, FrmReconstruirCreateTable);
  Application.CreateForm(TFrmCabeceraPlantilla, FrmCabeceraPlantilla);
  Application.CreateForm(TFrmVisualProcFuncs, FrmVisualProcFuncs);
  Application.CreateForm(TFrmVisualTriggers, FrmVisualTriggers);
  Application.CreateForm(TFrmPermisos, FrmPermisos);
  Application.CreateForm(TDMGlobal, DMGlobal);
  Application.CreateForm(TFrmEstructuraBD, FrmEstructuraBD);
  Application.CreateForm(TFrmBuffer, FrmBuffer);
  Application.CreateForm(TFrmFormatoFechas, FrmFormatoFechas);
  Application.CreateForm(TFrmComentarios, FrmComentarios);
  Application.CreateForm(TFrmVisualPackages, FrmVisualPackages);
  Application.CreateForm(TFrmVisualJava, FrmVisualJava);
  Application.CreateForm(TFrmVisualSeqs, FrmVisualSeqs);
  Application.CreateForm(TFrmVisualSynonyms, FrmVisualSynonyms);
  Application.CreateForm(TFrmVisualViews, FrmVisualViews);
  Application.CreateForm(TFrmVisualTablespaces, FrmVisualTablespaces);
  Application.CreateForm(TFrmVisualProfiles, FrmVisualProfiles);
  Application.CreateForm(TFrmVisualUsers, FrmVisualUsers);
  Application.CreateForm(TFrmVisualIndexes, FrmVisualIndexes);
  FrmSplash.Hide;
  FrmSplash.Free;
  Application.HelpFile := './Help/Medusa.hlp';
  Application.Run;
end.

// 94
