////////////////////////////////////////////////////////////////////////////////
//
// Proyecto Medusa v3.0
//
//////////////////////////////////// INFO //////////////////////////////////////
//
//  Nombre del programa : Medusa.exe
//  Fecha               : Septiembre del 2003.
//  Componentes         : DOA 3.4.6.4, SynEdit 1.1 (CVS).
//  Version compilador  : Delphi 6.0 Enterprise.
//  Descripcin         : Un cliente avanzado de Oracle
//  Autor               : Albert Philippe De La Fuente Vigliotti.
//  Tutor               : Jos Galindo Gmez.
//
////////////////////////////////////////////////////////////////////////////////

unit UAbout;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, MPlayer;

type
  TFrmAbout = class(TForm)
    Label1: TLabel;
    Image1: TImage;
    GroupBox1: TGroupBox;
    LblAutor: TLabel;
    LblEmailAutor: TLabel;
    GroupBox2: TGroupBox;
    Label2: TLabel;
    LblTamanio: TLabel;
    Label14: TLabel;
    Label8: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Image2: TImage;
    GroupBox3: TGroupBox;
    LblTutor: TLabel;
    LblEmailTutor: TLabel;
    Image3: TImage;
    Label3: TLabel;
    LblVersion: TLabel;
    MediaPlayer: TMediaPlayer;
    LblWebAutor: TLabel;
    LblWebTutor: TLabel;
    procedure LblEmailAutorMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure LblEmailAutorMouseLeave(Sender: TObject);
    procedure LblEmailAutorClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure LblTutorClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure LblWebAutorClick(Sender: TObject);
    procedure LblWebTutorClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmAbout: TFrmAbout;

implementation

{$R *.dfm}

uses ShellApi, UGlobal;

procedure TFrmAbout.LblEmailAutorMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  TLabel(Sender).Font.Color := $008080FF;
end;

procedure TFrmAbout.LblEmailAutorMouseLeave(Sender: TObject);
begin
  TLabel(Sender).Font.Color := $00C08000;
end;

procedure TFrmAbout.LblEmailAutorClick(Sender: TObject);
begin
  ShellExecute(GetDesktopWindow(),
               nil,
               pChar('mailto:adlfv@wanadoo.es'),
               nil,
               nil,
               SW_SHOWNORMAL);
end;

procedure TFrmAbout.FormActivate(Sender: TObject);
var
  FHandle: integer;
begin
  try
    MediaPlayer.FileName := ExtractFilePath(ParamStr(0)) + 'Res\' +
                            'Ecstasy Of Gold.mp3';
//    MediaPlayer.Rewind;
    MediaPlayer.Open;
    MediaPlayer.Play;
  except
  end;

  LblVersion.Caption := GetAppInfo(ParamStr(0), 'FileVersion');
  FHandle := FileOpen(ParamStr(0), fmShareDenyNone);
  // NOTA: El flag de apertura del fichero ha de ser fmShareDenyNone, para
  // permitir acceso al ejecutable, puesto que si no se hace de esta forma,
  // no muestra el tamao real porque ya hay una instancia ejecutandose,
  // lo cual no permite saber el tamao.
  try
    LblTamanio.Caption := FormatFloat('#,', GetFileSize(FHandle, nil)) + ' bytes';
  finally
    FileClose(FHandle);
  end;
end;

procedure TFrmAbout.LblTutorClick(Sender: TObject);
begin
  ShellExecute(GetDesktopWindow(),
               nil,
               pChar('mailto:ppgg@lcc.uma.es'),
               nil,
               nil,
               SW_SHOWNORMAL);
end;

procedure TFrmAbout.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  MediaPlayer.Stop;
end;

procedure TFrmAbout.LblWebAutorClick(Sender: TObject);
begin
  ShellExecute(GetDesktopWindow(),
               nil,
               PChar('http://www.albert-ph.tk/index.php'),
               nil,
               nil,
               SW_SHOWNORMAL);
end;

procedure TFrmAbout.LblWebTutorClick(Sender: TObject);
begin
  ShellExecute(GetDesktopWindow(),
               nil,
               PChar('http://www.lcc.uma.es/~ppgg'),
               nil,
               nil,
               SW_SHOWNORMAL);
end;

end.

// 163
