////////////////////////////////////////////////////////////////////////////////
//
// Proyecto Medusa v3.0
//
//////////////////////////////////// INFO //////////////////////////////////////
//
//  Nombre del programa : Medusa.exe
//  Fecha               : Septiembre del 2003.
//  Componentes         : DOA 3.4.6.4, SynEdit 1.1 (CVS).
//  Version compilador  : Delphi 6.0 Enterprise.
//  Descripcin         : Un cliente avanzado de Oracle
//  Autor               : Albert Philippe De La Fuente Vigliotti.
//  Tutor               : Jos Galindo Gmez.
//
////////////////////////////////////////////////////////////////////////////////

unit UBuffer;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, SynEdit, ComCtrls, StdCtrls, Buttons;

type
  TFrmBuffer = class(TForm)
    SynEdit: TSynEdit;
    LstVwSlots: TListView;
    EdtIndice: TEdit;
    Label1: TLabel;
    BitBtnCancelar: TBitBtn;
    BitBtnOk: TBitBtn;
    BitBtnRecuperarNuevaVentana: TBitBtn;
    procedure FormActivate(Sender: TObject);
    procedure LstVwSlotsClick(Sender: TObject);
    procedure BitBtnOkClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtnRecuperarNuevaVentanaClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmBuffer: TFrmBuffer;

implementation

uses UPrincipal, UEditor, UDMGlobal, UConfiguracion, UGlobal;

{$R *.dfm}

procedure TFrmBuffer.FormActivate(Sender: TObject);
var
  i : Integer;
  Reg : PDatosBuffer;
begin
  try
    CargarEstadoForm(Self);   // Esto es por si se ejecuta desde CD...
  except
  end;
  SynEdit.ClearAll;
  LstVwSlots.Clear;
  with TFrmEditor(FrmPrincipal.ActiveMDIChild) do
  begin
    for i := 0 to Buffer.Count - 1 do
    begin
      LstVwSlots.Items.Add;
      LstVwSlots.Items[i].Caption := IntToStr(i + 1);
      Reg := Buffer.Items[i];
      LstVwSlots.Items[i].SubItems.Add(TimeToStr({Format('hh:nn:ss', [}Reg^.Hora{]}));
      if Reg^.Error then
        LstVwSlots.Items[i].SubItems.Add('Si')
      else
        LstVwSlots.Items[i].SubItems.Add('No');
    end;
    EdtIndice.Text := IntToStr(IBuffer + 1) + ' de ' + IntToStr(FrmConfiguracion.SpnEdtBuffer.Value) + ' slots';
  end;
end;

procedure TFrmBuffer.LstVwSlotsClick(Sender: TObject);
begin
  with TFrmEditor(FrmPrincipal.ActiveMDIChild) do
  begin
    if Assigned(LstVwSlots.Selected) then
    begin
      FrmBuffer.SynEdit.Lines.Assign(PDatosBuffer(Buffer.Items[LstVwSlots.Selected.Index])^.Texto);
    end;
  end;
end;

procedure TFrmBuffer.BitBtnOkClick(Sender: TObject);
begin
  with TFrmEditor(FrmPrincipal.ActiveMDIChild) do
  begin
    if Assigned(LstVwSlots.Selected) then
      SynEdit.Lines.Assign(PDatosBuffer(Buffer.Items[LstVwSlots.Selected.Index])^.Texto);
  end;
end;

procedure TFrmBuffer.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  try
    GuardarEstadoForm(Self);
  except
  end;  
end;

procedure TFrmBuffer.BitBtnRecuperarNuevaVentanaClick(Sender: TObject);
var
  EditorActual, EditorNuevo : TFrmEditor;
begin
  EditorActual := TFrmEditor(FrmPrincipal.ActiveMDIChild);
  EditorNuevo  := TFrmEditor.Create(nil);
  if Assigned(LstVwSlots.Selected) then
    EditorNuevo.SynEdit.Lines.Assign(PDatosBuffer(EditorActual.Buffer.Items[LstVwSlots.Selected.Index])^.Texto);
end;

end.

// 122
