////////////////////////////////////////////////////////////////////////////////
//
// Proyecto Medusa v3.0
//
//////////////////////////////////// INFO //////////////////////////////////////
//
//  Nombre del programa : Medusa.exe
//  Fecha               : Septiembre del 2003.
//  Componentes         : DOA 3.4.6.4, SynEdit 1.1 (CVS).
//  Version compilador  : Delphi 6.0 Enterprise.
//  Descripcin         : Un cliente avanzado de Oracle
//  Autor               : Albert Philippe De La Fuente Vigliotti.
//  Tutor               : Jos Galindo Gmez.
//
////////////////////////////////////////////////////////////////////////////////

unit UDMGlobal;

interface

uses
  SysUtils, Classes, Oracle, SynEditHighlighter, SynHighlighterSQL,
  ImgList, Controls, SynEditExport, SynExportHTML, SynCompletionProposal,
  Dialogs, SynHighlighterJava, SynEditAutoComplete, Menus, StdActns,
  ActnList, SynEdit;

type
  TDMGlobal = class(TDataModule)
    OracleLogon: TOracleLogon;
    SynSQLSyn: TSynSQLSyn;
    ImgLstGutter: TImageList;
    SynExporterHTML: TSynExporterHTML;
    ImgLstSynCmplPrpLista: TImageList;
    SynCmplPrpLista: TSynCompletionProposal;
    SynJavaSyn: TSynJavaSyn;
    PpMnuSynEditDefecto: TPopupMenu;
    Copiardeventanaactiva1: TMenuItem;
    N2: TMenuItem;
    Deshacer1: TMenuItem;
    Rehacer1: TMenuItem;
    N1: TMenuItem;
    Cortar1: TMenuItem;
    Copiar1: TMenuItem;
    Pegar1: TMenuItem;
    ActionList1: TActionList;
    ActAbrirPrograma: TFileOpen;
    ActEdicionCortar: TEditCut;
    ActEdicionCopiar: TEditCopy;
    ActEdicionPegar: TEditPaste;
    ActEdicionSeleccionarTodo: TEditSelectAll;
    ActEdicionDeshacer: TEditUndo;
    N3: TMenuItem;
    Seleccionartodo1: TMenuItem;
    ActEdicionRehacer: TAction;
    procedure SynCmplPrpListaExecute(Kind: SynCompletionType;
      Sender: TObject; var CurrentInput: String; var x, y: Integer;
      var CanExecute: Boolean);
    procedure SynCmplPrpListaAfterCodeCompletion(Sender: TObject;
      const Value: String; Shift: TShiftState; Index: Integer;
      EndToken: Char);
    procedure DataModuleCreate(Sender: TObject);
    procedure DataModuleDestroy(Sender: TObject);
    procedure Copiardeventanaactiva1Click(Sender: TObject);
    procedure ActEdicionRehacerExecute(Sender: TObject);
    procedure PpMnuSynEditDefectoPopup(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    SynAutoComplete: SynEditAutoComplete.TSynAutoComplete;
    procedure CargarListaAutocompletado(Fichero: String);
  end;

var
  DMGlobal: TDMGlobal;

implementation

{$R *.dfm}

uses UGlobal, UPrincipal, UEditor, UConfiguracion;

procedure TDMGlobal.CargarListaAutocompletado(Fichero: String);
var
  Funciones      : TStringList;
  i,  Temp       : Integer;
  Str, TipoRutina, Rutina, Argumentos, Devuelve  : String;
begin
  if not FileExists(Fichero) then
    Exit; // Para que no se de cuenta el usuario...
    
  SynCmplPrpLista.ItemList.Clear;
  SynCmplPrpLista.InsertList.Clear;
  Funciones := TStringList.Create;
  Funciones.LoadFromFile(Fichero);
  for i := 0 to Funciones.Count - 1 do
  begin
    // Obtenemos el tipo de rutina (PROCEDURE o FUNCTION)
    TipoRutina := GetToken(Funciones[i], ' ', 0);

    // Si tiene parmetros
    if GetTokenCount(Funciones[i], '(') <> 1 then
    begin
      // Obtenemos el resto de la cadena (sin el tipo de rutina)
      Str := Trim(Copy(Funciones[i], Length(TipoRutina) + 1, Length(Funciones[i])));

      // Obtenemos el nombre de la rutina (ABS, SIN...)
      Rutina := GetToken(Str, '(', 0);
      // Obtenemos los argumentos (Con los parentesis de apertura y cierre incluidos)
      Argumentos := Trim(Copy(Str, Length(Rutina) + 1, Length(Str)));
      // Obtenemos el valor devuelto (es erroneo en caso de procedimiento,
      //                              pero como en este caso no se usa... da igual)
      Devuelve := Trim(GetToken(Argumentos, ':', GetTokenCount(Argumentos, ':')));
    end
    else begin
      // Obtenemos el resto de la cadena (sin el tipo de rutina)
      Str := Trim(Copy(Funciones[i], Length(TipoRutina) + 1, Length(Funciones[i])));

      // Obtenemos el nombre de la rutina (ABS, SIN...)
      Rutina := GetToken(Str, ':', 0);
{      // Obtenemos los argumentos (Con los parentesis de apertura y cierre incluidos)
      Argumentos := Trim(Copy(Str, Length(Rutina) + 1, Length(Str)));
      // Obtenemos el valor devuelto (es erroneo en caso de procedimiento,
      //                              pero como en este caso no se usa... da igual)
      ShowMessage(IntToStr(GetTokenCount(Argumentos, ':')));
      Devuelve := Trim(GetToken(Argumentos, ':', 1));}
    end;
    // Obtenemos los argumentos (Con los parentesis de apertura y cierre incluidos)
    Argumentos := Trim(Copy(Str, Length(Rutina) + 1, Length(Str)));
    // Obtenemos el valor devuelto (es erroneo en caso de procedimiento,
    //                              pero como en este caso no se usa... da igual)
    Devuelve := Trim(GetToken(Argumentos, ':', GetTokenCount(Argumentos, ':')));

    if UpperCase(TipoRutina) = 'FUNCTION' then
    begin
      Temp := Length(GetToken(Argumentos, ':', GetTokenCount(Argumentos, ':')));
      Argumentos := Trim(Copy(Argumentos, 1,
                              Length(Argumentos) -
                              Temp - 1));
      // Ahora creamos la lista con los caracteres de escape...
      //   por ejemplo: \image{1}\column{}ABS\style{-B}(N: NUMBER)
      SynCmplPrpLista.ItemList.Add('\image{1}\column{}' + Rutina + '\style{-B}' + Argumentos + ': ' + Devuelve)
    end
    else if UpperCase(TipoRutina) = 'PROCEDURE' then
    begin
      // Ahora creamos la lista con los caracteres de escape...
      //   por ejemplo: \image{0}\column{}ABS\style{-B}(N: NUMBER)
      SynCmplPrpLista.ItemList.Add('\image{0}\column{}' + Rutina + '\style{-B}' + Argumentos)
    end
    else if UpperCase(TipoRutina) = 'VARIABLE' then
    begin
      SynCmplPrpLista.ItemList.Add('\image{3}\column{}' + Rutina + '\style{-B}')
    end
    else begin
      // Ahora creamos la lista con los caracteres de escape...
      //   por ejemplo: \image{0}\column{}ABS\style{-B}(N: NUMBER)
      SynCmplPrpLista.ItemList.Add('\image{2}\column{}' + Rutina + '\style{-B}')
    end;

    if Argumentos = '' then
    begin
      if (Funciones[i][Length(Funciones[i])] = ';') and (Rutina[Length(Rutina)] <> ';') then
        SynCmplPrpLista.InsertList.Add(Rutina + ';')
      else
        SynCmplPrpLista.InsertList.Add(Rutina)
    end
    else begin
      if Funciones[i][Length(Funciones[i])] = ';' then
        SynCmplPrpLista.InsertList.Add(Rutina + '();')
      else
        SynCmplPrpLista.InsertList.Add(Rutina + '()');
    end;
{  SynCmplPrpLista.InsertList.LoadFromFile(ExtractFilePath(ParamStr(0)) + 'Plantillas\Oracle.i');
  SynCmplPrpLista.ItemList.LoadFromFile(ExtractFilePath(ParamStr(0)) + 'Plantillas\Oracle.lst');}
  end;
  Funciones.Free;
end;

procedure TDMGlobal.SynCmplPrpListaExecute(Kind: SynCompletionType;
  Sender: TObject; var CurrentInput: String; var x, y: Integer;
  var CanExecute: Boolean);
var
  Str : String;
begin
  Str := TSynCompletionProposal(Sender).PreviousToken;
  if Str <> '' then
    CargarListaAutocompletado(ExtractFilePath(ParamStr(0)) + 'Plantillas\' + Str + '.lat')
  else
    CargarListaAutocompletado(ExtractFilePath(ParamStr(0)) + 'Plantillas\' + FichLAT);  
end;

procedure TDMGlobal.SynCmplPrpListaAfterCodeCompletion(Sender: TObject;
  const Value: String; Shift: TShiftState; Index: Integer; EndToken: Char);
var
  Editor  : TFrmEditor;
begin
  Editor := TFrmEditor(FrmPrincipal.ActiveMDIChild);
  if Value[Length(Value) - 1] = ')' then
    Editor.SynEdit.CaretX := Editor.SynEdit.CaretX - 2;
end;

procedure TDMGlobal.DataModuleCreate(Sender: TObject);
begin
  OracleLogon.HistoryIniFile := ExtractFilePath(ParamStr(0)) + 'Logons';
  FrmConfiguracion.CargarConfiguracionSintaxis;
  FrmConfiguracion.AplicarConfiguracionSintaxis;
  SynAutoComplete := SynEditAutoComplete.TSynAutoComplete.Create(nil);
  CargarListaAutocompletado(ExtractFilePath(ParamStr(0)) + 'Plantillas\' + FichLAT);  
end;

procedure TDMGlobal.DataModuleDestroy(Sender: TObject);
begin
  SynAutoComplete.Free;
end;

procedure TDMGlobal.Copiardeventanaactiva1Click(Sender: TObject);
begin
  if Assigned(FrmPrincipal.ActiveMDIChild) then
  begin
{    ShowMessage(Sender.ClassName);
    ShowMessage(Self.Name);
    ShowMessage(Self.ClassName);
    SynEdit.PopupMenu.PopupPoint}
{    TSynEdit(TComponent(PopUpMenu1.PopupComponent)).pas Lines.AddStrings(
      TFrmEditor(FrmPrincipal.ActiveMDIChild).SynEdit.Lines
    );
}
    with TFrmEditor(FrmPrincipal.ActiveMDIChild).SynEdit do
    begin
      SelectAll;
      CopyToClipboard;
      TFrmEditor(FrmPrincipal.ActiveMDIChild).SynEdit.SelEnd := 0;
//      selectiSelectAll;
    end;
    TSynEdit(TComponent(DMGlobal.PpMnuSynEditDefecto.PopupComponent)).PasteFromClipboard;

    if TComponent(DMGlobal.PpMnuSynEditDefecto.PopupComponent).Name = 'SynEdit' then
    begin
      FrmConfiguracion.PageControl.ActivePage := FrmConfiguracion.TbShtFavoritos;
      FrmConfiguracion.SpdBtnAplicarFav.Enabled := true;
    end;
  end;
end;

procedure TDMGlobal.ActEdicionRehacerExecute(Sender: TObject);
begin
  TSynEdit(TComponent(DMGlobal.PpMnuSynEditDefecto.PopupComponent)).Redo;
end;

procedure TDMGlobal.PpMnuSynEditDefectoPopup(Sender: TObject);
begin
  if Assigned(DMGlobal.PpMnuSynEditDefecto.PopupComponent) then
  begin
    ActEdicionDeshacer.Enabled  := TSynEdit(TComponent(DMGlobal.PpMnuSynEditDefecto.PopupComponent)).CanUndo;
    ActEdicionRehacer.Enabled   := TSynEdit(TComponent(DMGlobal.PpMnuSynEditDefecto.PopupComponent)).CanRedo;
  end;
end;

end.

// 261
