////////////////////////////////////////////////////////////////////////////////
//
// Proyecto Medusa v3.0
//
//////////////////////////////////// INFO //////////////////////////////////////
//
//  Nombre del programa : Medusa.exe
//  Fecha               : Septiembre del 2003.
//  Componentes         : DOA 3.4.6.4, SynEdit 1.1 (CVS).
//  Version compilador  : Delphi 6.0 Enterprise.
//  Descripcin         : Un cliente avanzado de Oracle
//  Autor               : Albert Philippe De La Fuente Vigliotti.
//  Tutor               : Jos Galindo Gmez.
//
////////////////////////////////////////////////////////////////////////////////

unit UEditor;

{$I SynEdit.inc}
{$DEFINE Tab}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Grids, DBGrids, ExtCtrls, SynEdit, Menus,
  ActnList, DB, OracleData, Oracle, SynEditExport, SynExportHTML,
  SynEditHighlighter, SynHighlighterSQL, SynEditPrintTypes, StdActns,
  OracleLogon, ImgList, ExtActns, SynEditAutoComplete,
  SynEditKeyCmds, SynCompletionProposal, SynEditMiscClasses, SynEditSearch,
  ShellApi;

(*
  SynEditKeyCmds,
  SynEditAutoComplete, Menus;
*)
type
  TFrmEditor = class(TForm)
    SynEdit: TSynEdit;
    Splitter: TSplitter;
    PageControl: TPageControl;
    TbShtResultados: TTabSheet;
    DBGrid: TDBGrid;
    TbShtMensajes: TTabSheet;
    RchEdtMensajes: TRichEdit;
    TbShtErrores: TTabSheet;
    RchEdtErrores: TRichEdit;
    ActLstArchivo: TActionList;
    OracleSession: TOracleSession;
    OracleScript: TOracleScript;
    OracleDataSet: TOracleDataSet;
    DataSource1: TDataSource;
    PpMnuEditor: TPopupMenu;
    PPMIDeshacer: TMenuItem;
    PPMIRehacer: TMenuItem;
    N10: TMenuItem;
    PPMICortar: TMenuItem;
    PPMICopiar: TMenuItem;
    PPMIPegar: TMenuItem;
    N11: TMenuItem;
    PPMISeleccionarTodo: TMenuItem;
    ActLstEdicion: TActionList;
    ActLstOracle: TActionList;
    ActArchivoGuardar: TAction;
    ActArchivoGuardarComo: TFileSaveAs;
    ActArchivoPrevisualizar: TAction;
    ActArchivoImprimir: TAction;
    ActArchivoExportarHTML: TFileSaveAs;
    ActAsignarDocumentoImpresora: TAction;
    MainMenu1: TMainMenu;
    MIArchivo: TMenuItem;
    MIMRU: TMenuItem;
    MIArchivoCerrar: TMenuItem;
    N1: TMenuItem;
    MIArchivoGuardar: TMenuItem;
    MIArchivoGuardarComo: TMenuItem;
    N2: TMenuItem;
    MIArchivoExportar: TMenuItem;
    MIArchivoExportarHTML: TMenuItem;
    N9: TMenuItem;
    MIArchivoPrevisualizar: TMenuItem;
    MIArchivoConfigurarPagina: TMenuItem;
    MIArchivoImprimir: TMenuItem;
    MIEdicion: TMenuItem;
    MIEdicionDeshacer: TMenuItem;
    MIEdicionRehacer: TMenuItem;
    N3: TMenuItem;
    MIEdicionCortar: TMenuItem;
    MIEdicionCopiar: TMenuItem;
    MIEdicionPegar: TMenuItem;
    N4: TMenuItem;
    MIEdicionSeleccionarTodo: TMenuItem;
    N5: TMenuItem;
    MIEdicionBuscar: TMenuItem;
    MIEdicionReemplazar: TMenuItem;
    MIDD: TMenuItem;
    MIInsertar: TMenuItem;
    CREATETABLE1: TMenuItem;
    CREATETRIGGER1: TMenuItem;
    Crear1: TMenuItem;
    Crearprocedimiento1: TMenuItem;
    Crearfuncin1: TMenuItem;
    Crearpaquete1: TMenuItem;
    EstructuraLOOPencursores1: TMenuItem;
    MIOracle: TMenuItem;
    MIConectarDesconectar: TMenuItem;
    N8: TMenuItem;
    MIEjecutar: TMenuItem;
    N7: TMenuItem;
    MIArchivoSalir: TMenuItem;
    ActArchivoSalir: TFileExit;
    ActArchivoCerrar: TWindowClose;
    ActEdicionDeshacer: TAction;
    ActEdicionRehacer: TAction;
    ActEdicionCortar: TEditCut;
    ActEdicionCopiar: TEditCopy;
    ActEdicionPegar: TEditPaste;
    ActEdicionSeleccionarTodo: TEditSelectAll;
    ActEdicionBuscar: TAction;
    ActEdicionReemplazar: TAction;
    ActOracleEjecutarConsulta: TAction;
    ActOracleEjecutarScript: TAction;
    ActOracleConectarDesconectar: TAction;
    MIArchivoNuevo: TMenuItem;
    ActLstDD: TActionList;
    ActDDUsuarioActual: TAction;
    ActDDUSERTablas: TAction;
    ActDDUSERTriggers: TAction;
    ActDDUSERVistas: TAction;
    ActDDUSERUsuario: TAction;
    ActDDUSERObjetos: TAction;
    ActDDUSERTrabajos: TAction;
    ActDDUSERSinonimos: TAction;
    ActDDUSERIndices: TAction;
    ActDDUSERPrivilegiosTablasCedidos: TAction;
    ActDDUSERPrivilegiosTablasRecibidos: TAction;
    ActDDUSERPrivilegiosColumnasCedidos: TAction;
    ActDDUSERPrivilegiosColumnasRecibidos: TAction;
    ActDDUSERRestriccionesTodas: TAction;
    ActDDUSERRestriccionesColumnas: TAction;
    ActDDUSERComentariosTablas: TAction;
    ActDDUSERComentariosColumnas: TAction;
    ActDDALLTablas: TAction;
    ActDDALLTriggers: TAction;
    ActDDALLVistas: TAction;
    ActDDALLUsuarios: TAction;
    ActDDALLObjetos: TAction;
    ActDDALLTrabajos: TAction;
    ActDDALLSinonimos: TAction;
    ActDDALLIndices: TAction;
    ActDDALLPrivilegiosTablasCedidos: TAction;
    ActDDALLPrivilegiosTablasRecibidos: TAction;
    ActDDALLPrivilegiosColumnasCedidos: TAction;
    ActDDALLPrivilegiosColumnasRecibidos: TAction;
    ActDDALLRestriccionesTodas: TAction;
    ActDDALLRestriccionesColumnas: TAction;
    ActDDALLComentariosTablas: TAction;
    ActDDALLComentariosColumnas: TAction;
    ActDDVIRTBaseDatos: TAction;
    ActDDVIRTFicherosDatos: TAction;
    ActDDVIRTTablasFijas: TAction;
    ActDDVIRTSesiones: TAction;
    ActDDVIRTProcesos: TAction;
    ActDDVIRTFicherosControl: TAction;
    MIDDUsuarioDUAL: TMenuItem;
    MIDDUSER: TMenuItem;
    MIDDUserSubComentarios: TMenuItem;
    MIDDUserSubComentariosColumnas: TMenuItem;
    MIDDUserSubComentariosTablas: TMenuItem;
    MIDDUserSubRestricciones: TMenuItem;
    MIDDUserSubRestriccionesColumnas: TMenuItem;
    MIDDUserSubRestriccionesTodas: TMenuItem;
    MIDDUserSubPrivilegios: TMenuItem;
    MIDDUserSubPrivilegiosSubColumnas: TMenuItem;
    MIDDUserSubPrivilegiosSubColumnasRecibidos: TMenuItem;
    MIDDUserSubPrivilegiosSubColumnasCedidos: TMenuItem;
    MIDDUserSubPrivilegiosSubTablas: TMenuItem;
    MIDDUserSubPrivilegiosSubTablasRecibidos: TMenuItem;
    MIDDUserSubPrivilegiosSubTablasCedidos: TMenuItem;
    MIDDUserIndices: TMenuItem;
    MIDDUserSinonimos: TMenuItem;
    MIDDUserTrabajos: TMenuItem;
    MIDDUserObjetos: TMenuItem;
    MIDDUserUsuario: TMenuItem;
    MIDDUserVistas: TMenuItem;
    MIDDUserTriggers: TMenuItem;
    MIDDUserTablas: TMenuItem;
    MIDDALL: TMenuItem;
    MIDDALLSubComentarios: TMenuItem;
    MIDDALLSubComentariosColumnas: TMenuItem;
    MIDDALLSubComentariosTablas: TMenuItem;
    MIDDALLSubRestricciones: TMenuItem;
    MIDDALLSubRestriccionesColumnas: TMenuItem;
    MIDDALLSubRestriccionesTodas: TMenuItem;
    MIDDALLSubPrivilegios: TMenuItem;
    Columnas6: TMenuItem;
    MIDDALLSubPrivilegiosSubColumnasRecibidos: TMenuItem;
    MIDDALLSubPrivilegiosSubColumnasCedidos: TMenuItem;
    MIDDALLSubPrivilegiosSubTablas: TMenuItem;
    MIDDALLSubPrivilegiosSubTablasRecibidos: TMenuItem;
    MIDDALLSubPrivilegiosSubTablasCedidos: TMenuItem;
    MIDDALLIndices: TMenuItem;
    MIDDALLSinonimos: TMenuItem;
    MIDDALLTrabajos: TMenuItem;
    MIDDALLObjetos: TMenuItem;
    MIDDALLUsuarios: TMenuItem;
    MIDDALLVistas: TMenuItem;
    MIDDALLTriggers: TMenuItem;
    MIDDALLTablas: TMenuItem;
    MIDDVSSYS: TMenuItem;
    MIDDVSSYSFicherosControl: TMenuItem;
    MIDDVSSYSProcesos: TMenuItem;
    MIDDVSSYSSesiones: TMenuItem;
    MIDDVSSYSTablasVistas: TMenuItem;
    MIDDVSSYSFicherosDatos: TMenuItem;
    MIDDVSSYSBaseDatos: TMenuItem;
    PpMnuEjecutar: TPopupMenu;
    MIEjecutarConsulta: TMenuItem;
    MIEjecutarScript: TMenuItem;
    ActEdicionBuscarSiguiente: TAction;
    ActEdicionBuscarAnterior: TAction;
    MIArchivoAbrir: TMenuItem;
    N6: TMenuItem;
    MIVentanas: TMenuItem;
    ActLstVentanas: TActionList;
    ActVentanaCascada: TWindowCascade;
    ActVentanaArregloHorizontal: TWindowTileHorizontal;
    ActVentanaArregloVertical: TWindowTileVertical;
    ActVentanaMinimizarTodo: TWindowMinimizeAll;
    ActVentanaArregloAutomatico: TWindowArrange;
    ActVentanaAnterior: TPreviousTab;
    ActVentanaSiguiente: TNextTab;
    Close1: TMenuItem;
    Cascada1: TMenuItem;
    ArregloHorizontal1: TMenuItem;
    ArregloVertical1: TMenuItem;
    Minimizartodo1: TMenuItem;
    Arregloautomtico1: TMenuItem;
    Previous1: TMenuItem;
    Next1: TMenuItem;
    Conmutarmarcasdelnea1: TMenuItem;
    Iramarcadelnea1: TMenuItem;
    MIConmutarMarca0: TMenuItem;
    MIConmutarMarca1: TMenuItem;
    MIConmutarMarca2: TMenuItem;
    MIConmutarMarca3: TMenuItem;
    MIConmutarMarca4: TMenuItem;
    MIConmutarMarca5: TMenuItem;
    MIConmutarMarca6: TMenuItem;
    MIConmutarMarca7: TMenuItem;
    MIConmutarMarca8: TMenuItem;
    MIConmutarMarca9: TMenuItem;
    MIGotoMarca0: TMenuItem;
    MIGotoMarca1: TMenuItem;
    MIGotoMarca2: TMenuItem;
    MIGotoMarca3: TMenuItem;
    MIGotoMarca4: TMenuItem;
    MIGotoMarca5: TMenuItem;
    MIGotoMarca6: TMenuItem;
    MIGotoMarca7: TMenuItem;
    MIGotoMarca8: TMenuItem;
    MIGotoMarca9: TMenuItem;
    N12: TMenuItem;
    MILimpiarMarcas: TMenuItem;
    N13: TMenuItem;
    ActLstInsertar: TActionList;
    ActInsertarCrearTabla: TAction;
    ActInsertarCrearTrigger: TAction;
    ActInsertarBloquePLSQL: TAction;
    ActInsertarProcedimiento: TAction;
    ActInsertarFuncion: TAction;
    ActInsertarPaqueteDefinicion: TAction;
    ActInsertarPaqueteCuerpo: TAction;
    ActInsertarLOOPCursores: TAction;
    Paquetecuerpo1: TMenuItem;
    N14: TMenuItem;
    MIInformacionSesion: TMenuItem;
    MIReconstruirCreateTable: TMenuItem;
    ActVentanaMaximizarTodo: TAction;
    MIVisualProcFuncs: TMenuItem;
    MIVisualTriggers: TMenuItem;
    N15: TMenuItem;
    MIGestionPermisos: TMenuItem;
    MIEstructuraBD: TMenuItem;
    ActArchivoExportarTXT: TFileSaveAs;
    ExportaraTXT1: TMenuItem;
    ActEdicionBuffer: TAction;
    N16: TMenuItem;
    Buffer1: TMenuItem;
    N17: TMenuItem;
    MIFormatoFechas: TMenuItem;
    N18: TMenuItem;
    MIVentanasActivas: TMenuItem;
    MIComentarios: TMenuItem;
    MIVisualPackages: TMenuItem;
    SynEditSearch1: TSynEditSearch;
    MIVisualJava: TMenuItem;
    N19: TMenuItem;
    MIAgregarFavoritos: TMenuItem;
    MIVisualSeqs: TMenuItem;
    Resaltadordesintaxis1: TMenuItem;
    MIResaltadoSQL: TMenuItem;
    MIResaltadoJava: TMenuItem;
    MIVisualSynonyms: TMenuItem;
    MITamanioFuente: TMenuItem;
    MIFuenteEditorTam8: TMenuItem;
    N91: TMenuItem;
    N101: TMenuItem;
    N111: TMenuItem;
    N121: TMenuItem;
    N141: TMenuItem;
    N161: TMenuItem;
    N181: TMenuItem;
    N201: TMenuItem;
    N221: TMenuItem;
    N241: TMenuItem;
    N261: TMenuItem;
    N281: TMenuItem;
    N361: TMenuItem;
    N481: TMenuItem;
    N721: TMenuItem;
    PpMnuGrid: TPopupMenu;
    MenuItem37: TMenuItem;
    MIFuenteGridTam8: TMenuItem;
    MenuItem39: TMenuItem;
    MenuItem40: TMenuItem;
    MenuItem41: TMenuItem;
    MenuItem42: TMenuItem;
    MenuItem43: TMenuItem;
    MenuItem44: TMenuItem;
    MenuItem45: TMenuItem;
    MenuItem46: TMenuItem;
    MenuItem47: TMenuItem;
    MenuItem48: TMenuItem;
    MenuItem49: TMenuItem;
    MenuItem50: TMenuItem;
    MenuItem51: TMenuItem;
    MenuItem52: TMenuItem;
    MenuItem53: TMenuItem;
    Ajustarcolumnas1: TMenuItem;
    MIDDDBA: TMenuItem;
    MIDDDBASubComentarios: TMenuItem;
    MIDDDBASubComentariosColumnas: TMenuItem;
    MIDDDBASubComentariosTablas: TMenuItem;
    MIDDDBASubRestricciones: TMenuItem;
    MIDDDBASubRestriccionesColumnas: TMenuItem;
    MIDDDBASubRestriccionesTodas: TMenuItem;
    MIDDDBASubPrivilegios: TMenuItem;
    MIDDDBASubPrivilegiosSubColumnas: TMenuItem;
    MIDDDBASubPrivilegiosSubColumnasRecibidos: TMenuItem;
    MIDDDBASubPrivilegiosSubColumnasCedidos: TMenuItem;
    MIDDDBASubPrivilegiosSubTablas: TMenuItem;
    MIDDDBASubPrivilegiosSubTablasRecibidos: TMenuItem;
    MIDDDBASubPrivilegiosSubTablasCedidos: TMenuItem;
    MIDDDBAIndices: TMenuItem;
    MIDDDBASinonimos: TMenuItem;
    MIDDDBATrabajos: TMenuItem;
    MIDDDBAObjetos: TMenuItem;
    MIDDDBAUsuarios: TMenuItem;
    MIDDDBAVistas: TMenuItem;
    MIDDDBATriggers: TMenuItem;
    MIDDDBATablas: TMenuItem;
    MIVisualViews: TMenuItem;
    MIVisualTablespaces: TMenuItem;
    MIVisualProfiles: TMenuItem;
    MIVisualUsers: TMenuItem;
    MIVisualIndexes: TMenuItem;
    N20: TMenuItem;
    MIAutocompletadoCodigo: TMenuItem;
    MIListaAutcompletado: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure OracleSessionAfterLogOn(Sender: TOracleSession);
    procedure OracleDataSetTranslateMessage(Sender: TOracleDataSet;
      ErrorCode: Integer; const ConstraintName: String; Action: Char;
      var Msg: String);
    procedure OracleScriptError(Sender: TOracleScript);
    procedure OracleScriptOutput(Sender: TOracleScript; const Msg: String);
    procedure FormActivate(Sender: TObject);
    procedure ActArchivoGuardarExecute(Sender: TObject);
    procedure ActArchivoGuardarComoBeforeExecute(Sender: TObject);
    procedure ActArchivoPrevisualizarExecute(Sender: TObject);
    procedure ActArchivoConfigurarImpresoraExecute(Sender: TObject);
    procedure ActArchivoImprimirExecute(Sender: TObject);
    procedure ActArchivoExportarHTMLBeforeExecute(Sender: TObject);
    procedure ActAsignarDocumentoImpresoraExecute(Sender: TObject);
    procedure SynEditChange(Sender: TObject);
    procedure ActArchivoExportarHTMLAccept(Sender: TObject);
    procedure ActEdicionDeshacerExecute(Sender: TObject);
    procedure ActEdicionRehacerExecute(Sender: TObject);
    procedure ActOracleEjecutarConsultaExecute(Sender: TObject);
    procedure ActOracleEjecutarScriptExecute(Sender: TObject);
    procedure ActOracleConectarDesconectarExecute(Sender: TObject);
    procedure DBGridCellClick(Column: TColumn);
    procedure DBGridKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SynEditStatusChange(Sender: TObject;
      Changes: TSynStatusChanges);
    procedure SynEditDropFiles(Sender: TObject; X, Y: Integer;
      AFiles: TStrings);
    procedure ActDDUsuarioActualExecute(Sender: TObject);
    procedure ActDDALLTablasExecute(Sender: TObject);
    procedure ActDDALLTriggersExecute(Sender: TObject);
    procedure ActDDALLVistasExecute(Sender: TObject);
    procedure ActDDALLUsuariosExecute(Sender: TObject);
    procedure ActDDALLObjetosExecute(Sender: TObject);
    procedure ActDDALLTrabajosExecute(Sender: TObject);
    procedure ActDDALLSinonimosExecute(Sender: TObject);
    procedure ActDDALLIndicesExecute(Sender: TObject);
    procedure ActDDALLPrivilegiosTablasCedidosExecute(Sender: TObject);
    procedure ActDDALLPrivilegiosTablasRecibidosExecute(Sender: TObject);
    procedure ActDDALLPrivilegiosColumnasCedidosExecute(Sender: TObject);
    procedure ActDDALLPrivilegiosColumnasRecibidosExecute(Sender: TObject);
    procedure ActDDALLRestriccionesTodasExecute(Sender: TObject);
    procedure ActDDALLRestriccionesColumnasExecute(Sender: TObject);
    procedure ActDDALLComentariosTablasExecute(Sender: TObject);
    procedure ActDDALLComentariosColumnasExecute(Sender: TObject);
    procedure ActDDUSERTablasExecute(Sender: TObject);
    procedure ActDDUSERTriggersExecute(Sender: TObject);
    procedure ActDDUSERVistasExecute(Sender: TObject);
    procedure ActDDUSERUsuarioExecute(Sender: TObject);
    procedure ActDDUSERObjetosExecute(Sender: TObject);
    procedure ActDDUSERTrabajosExecute(Sender: TObject);
    procedure ActDDUSERSinonimosExecute(Sender: TObject);
    procedure ActDDUSERIndicesExecute(Sender: TObject);
    procedure ActDDUSERPrivilegiosTablasCedidosExecute(Sender: TObject);
    procedure ActDDUSERPrivilegiosTablasRecibidosExecute(Sender: TObject);
    procedure ActDDUSERPrivilegiosColumnasCedidosExecute(Sender: TObject);
    procedure ActDDUSERPrivilegiosColumnasRecibidosExecute(
      Sender: TObject);
    procedure ActDDUSERRestriccionesTodasExecute(Sender: TObject);
    procedure ActDDUSERRestriccionesColumnasExecute(Sender: TObject);
    procedure ActDDUSERComentariosTablasExecute(Sender: TObject);
    procedure ActDDUSERComentariosColumnasExecute(Sender: TObject);
    procedure ActDDVIRTBaseDatosExecute(Sender: TObject);
    procedure ActDDVIRTFicherosDatosExecute(Sender: TObject);
    procedure ActDDVIRTTablasFijasExecute(Sender: TObject);
    procedure ActDDVIRTSesionesExecute(Sender: TObject);
    procedure ActDDVIRTProcesosExecute(Sender: TObject);
    procedure ActDDVIRTFicherosControlExecute(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure ActArchivoGuardarComoAccept(Sender: TObject);
    procedure ActEdicionBuscarExecute(Sender: TObject);
    procedure ActEdicionReemplazarExecute(Sender: TObject);
    procedure SynEditReplaceText(Sender: TObject; const ASearch,
      AReplace: String; Line, Column: Integer;
      var Action: TSynReplaceAction);
    procedure ActArchivoGuardarUpdate(Sender: TObject);
    procedure ActEdicionDeshacerUpdate(Sender: TObject);
    procedure ActEdicionRehacerUpdate(Sender: TObject);
    procedure ActEdicionBuscarSiguienteExecute(Sender: TObject);
    procedure ActEdicionBuscarAnteriorExecute(Sender: TObject);
    procedure MIConmutarMarca0Click(Sender: TObject);
    procedure MIGotoMarca0Click(Sender: TObject);
    procedure SynEditClearBookmark(Sender: TObject;
      var Mark: TSynEditMark);
    procedure SynEditPlaceBookmark(Sender: TObject;
      var Mark: TSynEditMark);
    procedure MILimpiarMarcasClick(Sender: TObject);
    procedure ActInsertarCrearTablaExecute(Sender: TObject);
    procedure ActInsertarCrearTriggerExecute(Sender: TObject);
    procedure MIInformacionSesionClick(Sender: TObject);
    procedure MIReconstruirCreateTableClick(Sender: TObject);
    procedure ActVentanaMaximizarTodoExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MIVisualProcFuncsClick(Sender: TObject);
    procedure MIVisualTriggersClick(Sender: TObject);
    procedure MIGestionPermisosClick(Sender: TObject);
    procedure MIEstructuraBDClick(Sender: TObject);
    procedure ActArchivoExportarTXTBeforeExecute(Sender: TObject);
    procedure ActArchivoExportarTXTAccept(Sender: TObject);
    procedure ActEdicionBufferExecute(Sender: TObject);
    procedure SynEditGutterClick(Sender: TObject; Button: TMouseButton; X,
      Y, Line: Integer; Mark: TSynEditMark);
    procedure MIFormatoFechasClick(Sender: TObject);
    procedure MIComentariosClick(Sender: TObject);
    procedure MIVisualPackagesClick(Sender: TObject);
    procedure MIVisualJavaClick(Sender: TObject);
    procedure MIAgregarFavoritosClick(Sender: TObject);
    procedure SynEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MIVisualSeqsClick(Sender: TObject);
    procedure MIResaltadoSQLClick(Sender: TObject);
    procedure MIResaltadoJavaClick(Sender: TObject);
    procedure MIVisualSynonymsClick(Sender: TObject);
    procedure MIFuenteEditorTam8Click(Sender: TObject);
    procedure MIFuenteGridTam8Click(Sender: TObject);
    procedure Ajustarcolumnas1Click(Sender: TObject);
    procedure MIDDDBATablasClick(Sender: TObject);
    procedure MIDDDBATriggersClick(Sender: TObject);
    procedure MIDDDBAVistasClick(Sender: TObject);
    procedure MIDDDBAUsuariosClick(Sender: TObject);
    procedure MIDDDBAObjetosClick(Sender: TObject);
    procedure MIDDDBATrabajosClick(Sender: TObject);
    procedure MIDDDBASinonimosClick(Sender: TObject);
    procedure MIDDDBAIndicesClick(Sender: TObject);
    procedure MIDDDBASubPrivilegiosSubTablasCedidosClick(Sender: TObject);
    procedure MIDDDBASubPrivilegiosSubTablasRecibidosClick(
      Sender: TObject);
    procedure MIDDDBASubPrivilegiosSubColumnasCedidosClick(Sender: TObject);
    procedure MIDDDBASubPrivilegiosSubColumnasRecibidosClick(Sender: TObject);
    procedure MIDDDBASubRestriccionesTodasClick(Sender: TObject);
    procedure MIDDDBASubRestriccionesColumnasClick(Sender: TObject);
    procedure MIDDDBASubComentariosTablasClick(Sender: TObject);
    procedure MIDDDBASubComentariosColumnasClick(Sender: TObject);
    procedure OracleSessionChange(Sender: TOracleSession);
    procedure MIVisualViewsClick(Sender: TObject);
    procedure MIVisualTablespacesClick(Sender: TObject);
    procedure MIVisualProfilesClick(Sender: TObject);
    procedure MIVisualUsersClick(Sender: TObject);
    procedure MIVisualIndexesClick(Sender: TObject);
    procedure MIListaAutcompletadoClick(Sender: TObject);
    procedure MIAutocompletadoCodigoClick(Sender: TObject);
  private
    { Private declarations }
    FConectarDefecto  : Boolean;    // Al desconectar, debo conectar por defecto
    FVentanaAnterior  : Integer;
    FSimularFormShow  : Boolean;
    FIndice           : Integer;    // Indice de la ventana
    FTabMDI           : TTabSheet;  // El TabSheet
    CaretInicial      : TPoint;     // El caret inicial (para implementar la bsqueda circular)
    BusquedaCiclica   : Boolean;
  public
    { Public declarations }
    FFichero          : string;     // Campo que indica el nombre del fichero cargado
    Buffer            : TList;
    IBuffer           : Integer;
    procedure CreateBuffer;
    procedure AddBuffer(Error: Boolean);
    procedure FreeBuffer;

    procedure SetTitulo;
    procedure InitStatusBar;
    procedure SetPosCaret;
    procedure SetOffset;
    procedure SetEstadoTeclado;
    procedure SetEstadoEditor;
    procedure SetToolBar;
    procedure SetUsuario;
    procedure SetTuplas;

    procedure AbrirFichero(Str: String);
    procedure GuardarFichero;
    procedure CargarPlantillaTexto(Fichero: String);

    procedure ConstruirConsulta(Tabla: String);
    procedure ConsultaDD(Tabla: String);
//    procedure HabilitarToolBarMDI(valor: Boolean);
    procedure ActualizarEstadoMDI(Valor: Boolean);
    procedure MostrarTabMDI(Sender: TObject);

    procedure VerSiHaModificado;
    procedure MarcarError(Linea: Integer);
    function  ObtenerErrorVerdadero(Linea: Integer): Integer;
    function  BuscarMarca(Marca: Integer; var IdMarca: Integer): Integer;
    procedure LimpiarMarca(Tipo: Integer);
    procedure MostrarDialogoBuscarReemplazar(Reemplazar: boolean);
    procedure BuscarReemplazarTexto(Reemplazar: boolean; HaciaAtras: boolean);
  end;

  PDatosBuffer = ^TDatosBuffer;
  TDatosBuffer =  record
                    Hora  : TTime;
                    Texto : Pointer;
                    Error : Boolean;
                  end;

var
  FrmEditor: TFrmEditor;

implementation

uses UGlobal, UPrincipal, UPreview, UConfiguracion, UConfirmarReemplazar,
  UBuscar, UReemplazar, UInformacion, UReconstruirCreateTable, UVisualProcFuncs,
  UVisualTriggers, UPermisos, UDMGlobal, UEstructuraBD, UBuffer, SynEditTypes,
  UFormatosFecha, UComentarios, UVisualPackages, UVisualJava,
  UVisualSeqs, UVisualSynonyms, UVisualViews, UVisualTablespaces,
  UVisualProfile, UVisualUsers, UVisualIndexes;

{$R *.dfm}




////////////////////////////////////////////////////////////////////////////////
// RUTINAS DE ACTUALIZACIN DEL ESTADO DEL ENTORNO                           //
//////////////////////////////////////////////////////////////////////////////




(*
 * Rutina       : SetTitulo
 * Argumentos   : -
 * Devuelve     : -
 * Objetivos    : Actualizar el ttulo de una ventana hija
 * Descripcion  : Si se ha modificado, se antepone un *
 *)
procedure TFrmEditor.SetTitulo;
var
  Estado  : string;
begin
  Estado := '';
  if SynEdit.Modified then
    Estado := '*';
   //Estado := '(Modificado)';
   
  if FFichero = SNuevo then
  begin
    if not OracleSession.Connected then
    begin
      Caption := Format('%d - %s%d%s', [FIndice, ExtractFileName(FFichero), FIndice, Estado]);
      FTabMDI.Caption := Format('%d - %s%d%s', [FIndice, ExtractFileName(FFichero), FIndice, Estado]);
    end
    else begin
      Caption := Format('%d - %s%d%s@%s', [FIndice, ExtractFileName(FFichero), FIndice, Estado, OracleSession.LogonUsername]);
      FTabMDI.Caption := Format('%d - %s%d%s@%s', [FIndice, ExtractFileName(FFichero), FIndice, Estado, OracleSession.LogonUsername]);
    end;
  end
  else begin
    if not OracleSession.Connected then
    begin
      Caption := Format('%d - %s%s', [FIndice, ExtractFileName(FFichero), Estado]);
      FTabMDI.Caption := Format('%d - %s%s', [FIndice, ExtractFileName(FFichero), Estado]);
    end
    else begin
      Caption := Format('%d - %s%s@%s', [FIndice, ExtractFileName(FFichero), Estado, OracleSession.LogonUsername]);
      FTabMDI.Caption := Format('%d - %s%s@%s', [FIndice, ExtractFileName(FFichero), Estado, OracleSession.LogonUsername]);
    end;
  end;
//  PostMessage(FTabMDI.Handle, $0409, 0, clRed);
//  MDITab.Font.Color := clRed;
end;


(*
 * Rutina       : InitStatusBar
 * Argumentos   : -
 * Devuelve     : -
 * Objetivos    : Inicializa la status bar (como si no hubiesen ventanas hijas).
 * Descripcion  :
 *)
procedure TFrmEditor.InitStatusBar;
begin
  with FrmPrincipal do
  begin
    StatusBar.Panels[0].Text := '';
    StatusBar.Panels[1].Text := '';
    StatusBar.Panels[2].Text := '';
    StatusBar.Panels[3].Text := ' @';
    StatusBar.Panels[4].Text := '';
  end;
end;


(*
 * Rutina       : SetPosCaret
 * Argumentos   : -
 * Devuelve     : -
 * Objetivos    : Actualiza la posicion del caret (cursor) en la status bar.
 * Descripcion  :
 *)
procedure TFrmEditor.SetPosCaret;
begin
  if Assigned(FrmPrincipal.ActiveMDIChild) then
    FrmPrincipal.StatusBar.Panels[0].Text := Format(SInfoFilaColumna, [SynEdit.CaretY, SynEdit.CaretX])
  else
    FrmPrincipal.StatusBar.Panels[0].Text := '';  
end;


(*
 * Rutina       : SetOffset
 * Argumentos   : -
 * Devuelve     : -
 * Objetivos    : Actualiza la posicion del offset en la status bar.
 * Descripcion  : Solo se actualiza si hay marca de offset
 *)
procedure TFrmEditor.SetOffset;
var
  i : Integer;
begin
  if Assigned(FrmPrincipal.ActiveMDIChild) then
  begin
    if BuscarMarca(MarcaOffset, i) = -1 then
      FrmPrincipal.StatusBar.Panels[1].Text := '' //Format('Offset: %d', [SynEdit.CaretY])
    else
      if BuscarMarca(MarcaOffset, i) <= SynEdit.CaretY then
        FrmPrincipal.StatusBar.Panels[1].Text := Format('Offset: %d', [SynEdit.CaretY - BuscarMarca(MarcaOffset, i) + 1])
      else
        FrmPrincipal.StatusBar.Panels[1].Text := '';
  end
  else
    FrmPrincipal.StatusBar.Panels[1].Text := '';    
end;


(*
 * Rutina       : SetEstadoTeclado
 * Argumentos   : -
 * Devuelve     : -
 * Objetivos    : Actualiza el estado del teclado en la status bar.
 * Descripcion  :
 *)
procedure TFrmEditor.SetEstadoTeclado;
var
  Editor  : TFrmEditor;
begin
  if Assigned(FrmPrincipal.ActiveMDIChild) then
  begin
    Editor := TFrmEditor(FrmPrincipal.ActiveMDIChild);
    if Editor.SynEdit.ReadOnly then
      FrmPrincipal.StatusBar.Panels[2].Text := 'Solo lectura'
    else if Editor.SynEdit.InsertMode then
      FrmPrincipal.StatusBar.Panels[2].Text := 'Insercin'
    else
      FrmPrincipal.StatusBar.Panels[2].Text := 'Reescritura';
  end
  else
    FrmPrincipal.StatusBar.Panels[2].Text := '';
end;


(*
 * Rutina       : SetEstadoEditor
 * Argumentos   : -
 * Devuelve     : -
 * Objetivos    : Actualiza el estado del fichero en la status bar.
 * Descripcion  :
 *)
procedure TFrmEditor.SetEstadoEditor;
begin
{  if Assigned(FrmPrincipal.ActiveMDIChild) then
  begin
    if TFrmEditor(FrmPrincipal.ActiveMDIChild).SynEdit.Modified then
      FrmPrincipal.StatusBar.Panels[1].Text := '[Modificado]'
    else
      FrmPrincipal.StatusBar.Panels[1].Text := '';
  end
  else
    FrmPrincipal.StatusBar.Panels[1].Text := '';}  
end;


(*
 * Rutina       : ActualizarEstadoMDI
 * Argumentos   : -
 * Devuelve     : -
 * Objetivos    : Habilitar o deshabilitar los botones que utilizan las acciones
 *                definidas en el formulario MDI
 * Descripcion  : Se modifican las acciones y el estado.
 * Nota         : Creo que esto se puede hacer de otra forma "mejor", pero no
 *              : se como
 *)
procedure TFrmEditor.ActualizarEstadoMDI(Valor: Boolean);
var
  Editor  : TFrmEditor;
begin
  with FrmPrincipal do
    if not Valor then
    begin
      TlBtnGuardar.Action         := nil;
      TlBtnExportarHTML.Action    := nil;
      TlBtnPrevisualizar.Action   := nil;
      TlBtnDeshacer.Action        := nil;
      TlBtnRehacer.Action         := nil;
      TlBtnCortar.Action          := nil;
      TlBtnCopiar.Action          := nil;
      TlBtnPegar.Action           := nil;
      TlBtnBuscar.Action          := nil;
      TlBtnBuscarSiguiente.Action := nil;
      TlBtnBuscarAnterior.Action  := nil;
      TlBtnReemplazar.Action      := nil;
      TlBtnConectarDesconectar.Action := nil;
      TlBtnEjecutar.Action        := nil;      
      TlBtnGuardar.Enabled        := false;
      TlBtnExportarHTML.Enabled   := false;
      TlBtnPrevisualizar.Enabled  := false;
      TlBtnDeshacer.Enabled       := false;
      TlBtnRehacer.Enabled        := false;
      TlBtnCortar.Enabled         := false;
      TlBtnCopiar.Enabled         := false;
      TlBtnPegar.Enabled          := false;
      TlBtnBuscar.Enabled         := false;
      TlBtnBuscarSiguiente.Enabled:= false;
      TlBtnBuscarAnterior.Enabled := false;
      TlBtnReemplazar.Enabled     := false;
      TlBtnConectarDesconectar.Enabled := false;
      TlBtnEjecutar.Enabled       := false;
//      MIMostrarBarraEditor.Enabled := false;
    end
    else begin
      TlBtnGuardar.Action         := ActArchivoGuardar;
      TlBtnExportarHTML.Action    := ActArchivoExportarHTML;
      TlBtnPrevisualizar.Action   := ActArchivoPrevisualizar;
      TlBtnDeshacer.Action        := ActEdicionDeshacer;
      TlBtnRehacer.Action         := ActEdicionRehacer;
      TlBtnCortar.Action          := ActEdicionCortar;
      TlBtnCopiar.Action          := ActEdicionCopiar;
      TlBtnPegar.Action           := ActEdicionPegar;
      TlBtnBuscar.Action          := ActEdicionBuscar;
      TlBtnBuscarSiguiente.Action := ActEdicionBuscarSiguiente;
      TlBtnBuscarAnterior.Action  := ActEdicionBuscarAnterior;
      TlBtnReemplazar.Action      := ActEdicionReemplazar;
      TlBtnConectarDesconectar.Action := ActOracleConectarDesconectar;
//      TlBtnEjecutar.Action        := ActOracleEjecutarConsulta;
      TlBtnGuardar.Enabled        := SynEdit.Modified;
      TlBtnExportarHTML.Enabled   := true;
      TlBtnPrevisualizar.Enabled  := true;
//      TlBtnDeshacer.Enabled       := true;
//      TlBtnRehacer.Enabled        := true;
      TlBtnCortar.Enabled         := true;
      TlBtnCopiar.Enabled         := true;
      TlBtnPegar.Enabled          := true;
      TlBtnBuscar.Enabled         := true;
      TlBtnBuscarSiguiente.Enabled:= gsSearchText <> '';
      TlBtnBuscarAnterior.Enabled := gsSearchText <> '';
      TlBtnReemplazar.Enabled     := not SynEdit.ReadOnly;

      TlBtnConectarDesconectar.Enabled := true;
      TlBtnConectarDesconectar.Down := ActOracleConectarDesconectar.Checked;

      Editor := TFrmEditor(FrmPrincipal.ActiveMDIChild);

      if Assigned(Editor) then
      begin
        TlBtnEjecutar.Enabled       := true;
        if Editor.MIEjecutarScript.Tag = 1 then
          TlBtnEjecutar.Action := ActOracleEjecutarScript
        else
          TlBtnEjecutar.Action := ActOracleEjecutarConsulta;
      end;

      if Assigned(Editor) then
      begin
        MIMostrarGutter.Enabled := true;
        MIMostrarGutter.Checked := TFrmEditor(FrmPrincipal.ActiveMDIChild).SynEdit.Gutter.Visible;
      end
      else begin
        MIMostrarGutter.Enabled := false;
      end;

      if (Assigned(FrmPrincipal.ActiveMDIChild)) and
         (TFrmEditor(FrmPrincipal.ActiveMDIChild).OracleSession.Connected) then
      begin
        MIInformacionSesion.Enabled       := true;
        MIEstructuraBD.Enabled            := true;
        MIReconstruirCreateTable.Enabled  := true;
        MIGestionPermisos.Enabled         := true;
        MIComentarios.Enabled             := true;
        MIVisualUsers.Enabled             := true;
        MIVisualIndexes.Enabled           := true;
      end
      else begin
        MIInformacionSesion.Enabled       := false;
        MIEstructuraBD.Enabled            := false;
        MIReconstruirCreateTable.Enabled  := false;
        MIGestionPermisos.Enabled         := false;
        MIComentarios.Enabled             := false;
        MIVisualUsers.Enabled             := false;
        MIVisualIndexes.Enabled           := false;        
      end;
    end;
end;


(*
 * Rutina       : SetToolBar
 * Argumentos   : -
 * Devuelve     : -
 * Objetivos    : Actualiza de la barra de herramientas sii hay ventana(s) hija(s)
 * Descripcion  :
 *)
procedure TFrmEditor.SetToolBar;
begin
  // Si hay al menos una ventana hija, activamos las acciones, menus...
  // Si no, desactivamos todo.
  ActualizarEstadoMDI(FrmPrincipal.MDIChildCount >= 1);
//  HabilitarToolBarMDI(FrmPrincipal.MDIChildCount >= 1);
end;


(*
 * Rutina       : SetUsuario
 * Argumentos   : -
 * Devuelve     : -
 * Objetivos    : Actualiza el campo usuario de la status bar
 * Descripcion  :
 *)
procedure TFrmEditor.SetUsuario;
begin
  if OracleSession.Connected then
    FrmPrincipal.StatusBar.Panels[3].Text := OracleSession.LogonUsername + '@' + OracleSession.LogonDatabase
  else
    FrmPrincipal.StatusBar.Panels[3].Text := ' @';
end;


(*
 * Rutina       : SetTuplas
 * Argumentos   : -
 * Devuelve     : -
 * Objetivos    : Actualiza el campo tuplas de la status bar
 * Descripcion  :
 *)
procedure TFrmEditor.SetTuplas;
begin
  if {OracleSession.Connected and} OracleDataSet.Active then
    FrmPrincipal.StatusBar.Panels[4].Text := IntToStr(OracleDataSet.RecordCount) + ' filas'
  else
    FrmPrincipal.StatusBar.Panels[4].Text := '';
end;


(*
 * Rutina       : MostrarTabMDI
 * Argumentos   : -
 * Devuelve     : -
 * Objetivos    : Actualiza la pestaa de la ventana MDI
 * Descripcion  :
 *)
procedure TFrmEditor.MostrarTabMDI(Sender: TObject);
begin
  BringToFront;
end;




////////////////////////////////////////////////////////////////////////////////
// RUTINAS PARA EL MENEJO DE FICHEROS                                        //
//////////////////////////////////////////////////////////////////////////////


(*
 * Rutina       : AbrirFichero
 * Argumentos   : Str (Fichero a abrir, con path incluido)
 * Devuelve     : -
 * Objetivos    : Abrir el fichero y actualizar el entorno con su nombre
 * Descripcion  :
 *)
procedure TFrmEditor.AbrirFichero(Str: String);
begin
  SynEdit.Lines.LoadFromFile(Str);
  FFichero := Str; //FrmPrincipal.ActArchivoAbrir.Dialog.FileName;
  SynEdit.ReadOnly := GetFileAttributes(PChar(Str)) = FILE_ATTRIBUTE_READONLY;
  if not SynEdit.ReadOnly then
    ActArchivoGuardar.Enabled := false;
  FTabMDI.Caption := Format('%d - %s', [FIndice, UpperCase(ExtractFileName(FFichero)), FIndice]);
  Caption := FTabMDI.Caption;
  FrmPrincipal.UpdateMRU(MIMRU, Str);
end;


(*
 * Rutina       : GuardarFichero
 * Argumentos   : -
 * Devuelve     : -
 * Objetivos    : Guarda el fichero que se esta editando actualmente
 * Descripcion  :
 *)
// TODO: mmmm? revisar
procedure TFrmEditor.GuardarFichero;
begin
  SynEdit.Lines.SaveToFile(FFichero);
  SynEdit.Modified := false;
  ActArchivoGuardar.Enabled := false;
  SetTitulo;
  FTabMDI.ImageIndex := 91;
end;

(*
 * Rutina       : VerSiHaModificado
 * Argumentos   : -
 * Devuelve     : -
 * Objetivos    : Preguntar si desea guardar los cambios y guardarlos (actualmente no se usa)
 * Descripcion  :
 *)
procedure TFrmEditor.VerSiHaModificado;
var
  Respuesta: Integer;
begin
  if not SynEdit.Modified then
    Exit;
  Respuesta := MessageDlg(Format('Deseas guardar los cambios a %s?', [FFichero]),
                          mtConfirmation, mbYesNoCancel, 0);
  case Respuesta of
    idYes     : ActArchivoGuardarExecute(Self);
    idNo      : {Nada};
    idCancel  : Abort;
  end;
end;




////////////////////////////////////////////////////////////////////////////////
// RUTINAS PARA LA MANIPULACIN DE MARCAS EN EL GUTTER                       //
//////////////////////////////////////////////////////////////////////////////


(*
 * Rutina       : LimpiarMarca
 * Argumentos   : Tipo (Tipo de marca a limpiar)
 * Devuelve     : -
 * Objetivos    : Quitar las marcas de ndice "Tipo", del gutter del editor
 * Descripcion  :
 *)
procedure TFrmEditor.LimpiarMarca(Tipo: Integer);
var
  i : Integer;
begin
  with TFrmEditor(FrmPrincipal.ActiveMDIChild).SynEdit do
  begin
    i := 0;
    while (i <= Marks.Count-1) do
    begin
      if Marks[i].ImageIndex = Tipo then
        Marks.Delete(i);
      inc(i);
    end;
  end;
end;


(*
 * Rutina       : BuscarMarca
 * Argumentos   : Marca (Tipo de la marca a buscar)
 *                IdMarca (Parametro de salida. Indice efectivo de la marca)
 * Devuelve     : El ndice de la marca
 * Objetivos    : Busca en el gutter si hay una marca y devuelve EL NUMERO de marca
 *                (NO LA LINEA).
 * Descripcion  :
 * Nota         : Solo se usa para la primera marca
 *)
function TFrmEditor.BuscarMarca(Marca: Integer; var IdMarca: Integer): Integer;
var
  Encontrada  : Boolean;
begin
  if Assigned(FrmPrincipal.ActiveMDIChild) then
    with TFrmEditor(FrmPrincipal.ActiveMDIChild).SynEdit do
    begin
      Result := 0;
      Encontrada := false;
      while (Result <= Marks.Count-1) and (not Encontrada) do
      begin
        Encontrada := Marks[Result].ImageIndex = Marca;
        if not Encontrada then
          inc(Result);
      end;
      if not Encontrada then
      begin
        IdMarca := -1;
        Result  := -1;
      end
      else begin
        IdMarca := Result;
        Result := Marks[Result].Line;
      end;
    end;
end;


(*
 * Rutina       : MarcarError
 * Argumentos   : Linea (Nmero de lnea donde se pondr la marca)
 * Devuelve     : -
 * Objetivos    : Pone una marca de alerta en la lnea "Linea"
 * Descripcion  :
 *)
procedure TFrmEditor.MarcarError(Linea: Integer);
var
  Marca: TSynEditMark;
begin
  with TFrmEditor(FrmPrincipal.ActiveMDIChild).SynEdit do
  begin
    Marks.ClearLine(Linea);
    Marca := TSynEditMark.Create(SynEdit);
    with Marca do begin
      Line    := Linea;
      Column  := 0;
      ImageIndex := MarcaWarning;
      Visible := true;
    end;
    Marks.Place(Marca);
  end;
end;


(*
 * Rutina       : ObtenerErrorVerdadero
 * Argumentos   : Linea (Nmero de lnea donde est el error "falso")
 * Devuelve     : La lnea del error "verdadero"
 * Objetivos    : Encontrar el error "verdadero" saltandose hacia abajo
 *                los comentarios ("--" y "/*") y saltos de lnea
 * Descripcion  :
 * Bugs         : No est implementado aun el tipo de comentario multilinea
 *)
function TFrmEditor.ObtenerErrorVerdadero(Linea: Integer): Integer;
var
  Salir : Boolean;
begin
  Salir := false;
  Result := Linea;

  while not Salir do
  begin
    Salir := (Copy(SynEdit.Lines[Result], 1, 2) <> '--')
              and (SynEdit.Lines[Result] <> '');
    if not Salir then
      Result := Result + 1;
  end;
end;

(*
 * Rutina       : CreateBuffer
 * Argumentos   : -
 * Devuelve     : -
 * Objetivos    : Crea el buffer, e inicializa los atributos correspondientes
 * Descripcion  :
 *)
procedure TFrmEditor.CreateBuffer;
begin
  Buffer  := TList.Create;
  IBuffer := -1;
end;


(*
 * Rutina       : AddBuffer
 * Argumentos   : Error, indica si ha habido error o no, para mostrarlo.
 * Devuelve     : -
 * Objetivos    : Aade el texto del editor al buffer.
 * Descripcion  :
 *)
procedure TFrmEditor.AddBuffer(Error: Boolean);
var
  Texto : TStringList;
  Reg   : PDatosBuffer;
begin
  Texto := TStringList.Create;
  Texto.Assign(TFrmEditor(FrmPrincipal.ActiveMDIChild).SynEdit.Lines);
  New(Reg);
  Reg^.Hora := now;
  Reg^.Error := Error;
  Reg^.Texto := Texto;
  IBuffer := IBuffer + 1; // No se porque pero si se pone en una lnea no funciona...
  IBuffer := IBuffer mod (FrmConfiguracion.SpnEdtBuffer.Value);
  if IBuffer <= Buffer.Count - 1 then
  begin
    Buffer.Delete(IBuffer);
    Buffer.Insert(IBuffer, Reg);
  end
  else
    Buffer.Insert(IBuffer {- 1}, Reg);
end;


(*
 * Rutina       : SetTuplas
 * Argumentos   : -
 * Devuelve     : -
 * Objetivos    : Actualiza el campo tuplas de la status bar
 * Descripcion  :
 *)
procedure TFrmEditor.FreeBuffer;
var
  i : Integer;
begin
  for i := 0 to Buffer.Count - 1 do
  begin
    Dispose(PDatosBuffer(Buffer.Items[i]).Texto);
    Dispose(Buffer.Items[i]);
  end;
  Buffer.Clear;  
end;


////////////////////////////////////////////////////////////////////////////////
//                                        //
//////////////////////////////////////////////////////////////////////////////


(*
 * Funcion     : FormClose
 * Objetivos   : Liberar todos los recursos.
 *)
procedure TFrmEditor.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
  if FrmPrincipal.MDIChildCount = 1 then
  begin
    InitStatusBar;
    FrmPrincipal.TlBtnConectarDesconectar.Down := false;
    if OracleSession.Connected then
      ActOracleConectarDesconectar.Execute;
    FrmPrincipal.NumVentanas := 0;
  end;
  ActualizarEstadoMDI(FrmPrincipal.MDIChildCount > 1);
  FreeBuffer;
{$IFDEF Tab}
  FTabMDI.Free;
{$ENDIF}
end;


(*
 * Funcion     :
 * Objetivos   :
 *)
procedure TFrmEditor.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
//  VerSiHaModificado;
{  if FrmPrincipal.MDIChildCount = 1 then    // Solo queda este formulario
    ActualizarEstadoMDI(false)}
//    HabilitarToolBarMDI(false); // y ser destruido
end;


(*
 * Funcion     : FormCreate
 * Objetivos   : Inicializar una ventana hija ya creada (incluyendo ttulo)
 * Descripcion : Se inicializan los atributos de sta.
 *               Tambin los mens que le afectan.
 *)
procedure TFrmEditor.FormCreate(Sender: TObject);
begin
{$IFDEF Tab}
  FTabMDI := TTabSheet.Create(nil);
  with FTabMDI do
  begin
    PageControl := FrmPrincipal.PageControl1;
    ImageIndex  := 91;
//  FrmEditor.Parent := MDITab;
    Caption := '';
    OnShow := MostrarTabMDI;
  end;
{$ENDIF}

  FConectarDefecto := false;
  if not Assigned(FrmPrincipal.ActiveMDIChild) then
    FVentanaAnterior := -1
  else
    FVentanaAnterior := FrmPrincipal.MDIChildCount - 1;
  inc(FrmPrincipal.NumVentanas);
  FFichero := SNuevo;
  FIndice := FrmPrincipal.NumVentanas;
  SetTitulo;
  ActArchivoGuardar.Enabled := false;


  ////////////////////////////
  // CONFIGURACION SYNEDIT //
  //////////////////////////

  with TFrmEditor(Sender).SynEdit do
  begin
    SynEdit.Lines.Clear;
    SynEdit.Modified := false;
    // Gutter
{    BookMarkOptions.BookmarkImages := ImgLstGutter;
    BookMarkOptions.LeftMargin := 0;
    BookMarkOptions.Xoffset := 0;}
    // para poder tabular y no pasar a otro control
    WantTabs := true;
  end;
  // TODO: Maximizar la ventana hija

// frmTinnMain.UpdateCursorPos(synEditor);
// synEditor.Font.Name := frmTinnMain.FontName;
// synEditor.Font.Size := frmTinnMain.FontSize;

//  DMGlobal.SynAutoComplete.AddEditor(TFrmEditor(FrmPrincipal.ActiveMDIChild).SynEdit);
//  SynAutoComplete := SynEditAutoComplete.TSynAutoComplete.Create(Self);
//  SynAutoComplete.Editor := TFrmEditor(FrmPrincipal.ActiveMDIChild).SynEdit;
//  SynAutoComplete.AutoCompleteList.LoadFromFile('Delphi32.dci');
//  SynEdit1.AddKey(ecAutoCompletion, word('J'), [ssCtrl], 0, []);
  CreateBuffer;
end;



////////////////////////////////////////////////////////////////////////////////
// EVENTOS RELACIONADOS CON LA COMUNICACIN CON ORACLE                       //
//////////////////////////////////////////////////////////////////////////////

(*
 * Funcion     : OracleSessionAfterLogOn
 * Objetivos   : Actualizar los mens, barras, y status bar
 *)
procedure TFrmEditor.OracleSessionAfterLogOn(Sender: TOracleSession);
begin
//  ShowMessage('MONID' + IntToSTr(OracleSession.MonID));
//  OracleSession
  ActOracleConectarDesconectar.Checked := true;
  MIConectarDesconectar.Checked := true;
  FrmPrincipal.TlBtnConectarDesconectar.Down := true;
  SetUsuario;
  SetTitulo;
end;


(*
 * Funcion     : OracleDataSetTranslateMessage
 * Objetivos   :
 *)
procedure TFrmEditor.OracleDataSetTranslateMessage(Sender: TOracleDataSet;
  ErrorCode: Integer; const ConstraintName: String; Action: Char;
  var Msg: String);
begin
//  RchEdtMensajes.Lines.Add('Mensaje: ' + Msg);
end;


(*
 * Funcion     : OracleScriptError
 * Objetivos   : Mostrar los mensajes de error al ejecutar en modo script
 *               (tambin marca los errores en el gutter del editor) 
 *)
procedure TFrmEditor.OracleScriptError(Sender: TOracleScript);
var
  Error : Integer;
begin
//  OracleScript.CurrentCommand.
//  if PageControl.ActivePage <> TbShtErrores then
    PageControl.ActivePage := TbShtErrores;

  Error := OracleScript.CurrentCommand.ScriptLine;

  Error := ObtenerErrorVerdadero(Error) + 1;

  RchEdtErrores.Lines.Add(Format(SInfoLineaWarning,
    [Error, Trim(OracleScript.CurrentCommand.ErrorMessage)]));

  MarcarError(Error);
//  MarcarError(5);
end;


(*
 * Funcion     : OracleScriptOutput
 * Objetivos   :
 *)
procedure TFrmEditor.OracleScriptOutput(Sender: TOracleScript;
  const Msg: String);
begin
{  if Msg <> '' then
    RchEdtMensajes.Lines.Add(Format(SInfoLineaWarning,
      [OracleScript.CurrentCommand.ScriptLine + 1, Msg]))
  else
    RchEdtMensajes.Lines.Add('');}
end;


(*
 * Funcion     : FormActivate
 * Objetivos   : Aplicar la configuracin al editor y actualizar la status bar
 *)
procedure TFrmEditor.FormActivate(Sender: TObject);
var
  Editor  : TFrmEditor;
begin
  FrmConfiguracion.AplicarConfiguracionEditor;
  FrmConfiguracion.AplicarConfiguracionSintaxis;
  FrmConfiguracion.AplicarConfiguracionOracle;
  ActualizarEstadoMDI(true);

  if Assigned(FrmPrincipal.ActiveMDIChild) then
  begin
    Editor := TFrmEditor(FrmPrincipal.ActiveMDIChild);

    Editor.SynEdit.BookMarkOptions.BookmarkImages := DMGlobal.ImgLstGutter;
    Editor.SynEdit.BookMarkOptions.LeftMargin := 0;
    Editor.SynEdit.BookMarkOptions.Xoffset := 0;

    // Actualizamos la status bar
    Editor.SetPosCaret;
    Editor.SetOffset;
    Editor.SetEstadoTeclado;
    Editor.SetUsuario;
    Editor.SetTuplas;

{    Editor.SynAutoComplete.AutoCompleteList.LoadFromFile(
      ExtractFilePath(ParamStr(0)) + '\Plantillas\' + FichDCI);}
    Editor.SynEdit.AddKey(ecAutoCompletion, word('J'), [ssCtrl], 0, []); // 16458
    FrmConfiguracion.CargarConfiguracionPlantillas;    
    DMGlobal.SynAutoComplete.AddEditor(Editor.SynEdit);
    DMGlobal.SynCmplPrpLista.AddEditor(Editor.SynEdit);        
//  HabilitarToolBarMDI(true);
  end;
  FrmPrincipal.BuildMRU(MIMRU);
{$IFDEF Tab}
  FTabMDI.Show;
{$ENDIF}

  FrmPrincipal.TlBtnEjecutar.DropdownMenu := Editor.PpMnuEjecutar;
  
  if ((FrmConfiguracion.ChkBxConectarAutomaticamente.Checked) or
     (FrmConfiguracion.ChkBxConectarAutomaticamenteSesion.Checked)) and
     (FSimularFormShow) then
  begin
    ActOracleConectarDesconectar.Execute;
    FSimularFormShow := False;
  end;
end;



////////////////////////////////////////////////////////////////////////////////
// ACCIONES PARA LA MANIPULACIN DE FICHEROS                                 //
//////////////////////////////////////////////////////////////////////////////


(*
 * Funcion     : ActArchivoGuardarComoAccept
 * Objetivos   : Asignar el nombre al caption de la ventana (de forma indirecta)
 *               y guardar el fichero
 *)
procedure TFrmEditor.ActArchivoGuardarComoAccept(Sender: TObject);
begin
  FFichero := ActArchivoGuardarComo.Dialog.FileName;
  GuardarFichero;
end;


(*
 * Funcion     : ActArchivoGuardarExecute
 * Objetivos   : Emplear la opcin "Guardar" o "Guardar como" en funcion
 *               de si el fichero es nuevo o ha sido abierto anteriormente
 *)
procedure TFrmEditor.ActArchivoGuardarExecute(Sender: TObject);
var
  Str1, Str2  : String;
begin
  Str1 := FFichero;
  Str2 := ActArchivoGuardarComo.Dialog.FileName;
  if MatchStrings(Str1, SNuevo + '*') then
  begin
    if (Str2 = '') then                     // GUARDAR COMO
      ActArchivoGuardarComo.Execute         // Fichero nuevo guardado por 1 vez
    else                                    // GUARDAR (Fichero nuevo no guardado)
      FFichero := ActArchivoGuardarComo.Dialog.FileName;
  end;
{  else if Str2 = '' then                  // GUARDAR - ABIERTO (Fichero abierto no guardado)
    FFichero := FrmPrincipal.ActArchivoAbrir.Dialog.FileName;}
  GuardarFichero;
end;


(*
 * Funcion     : ActArchivoGuardarComoBerforeExecute
 * Objetivos   : Inicializar... (bastante obvio)
 *)
procedure TFrmEditor.ActArchivoGuardarComoBeforeExecute(Sender: TObject);
begin
  ActArchivoGuardarComo.Dialog.FileName := '';
end;


(*
 * Funcion     : ActArvhivoPrevisualizarExecute
 * Objetivos   : Asignar el documento y mostrar la previsualizacin
 *)
procedure TFrmEditor.ActArchivoPrevisualizarExecute(Sender: TObject);
begin
  ActAsignarDocumentoImpresora.Execute;
  FrmPreview.ShowModal;
end;


(*
 * Funcion     : ActArchivoConfigurarImpresoraExecute
 * Objetivos   : Mostrar el dialogo de configuracin de la impresora
 *)
procedure TFrmEditor.ActArchivoConfigurarImpresoraExecute(Sender: TObject);
begin
  FrmPreview.PrinterSetupDialog.Execute;
end;


(*
 * Funcion     : ActArchivoImprimirExecute
 * Objetivos   : Imprimir (antes se muestra la previsualizacin)
 *)
procedure TFrmEditor.ActArchivoImprimirExecute(Sender: TObject);
begin
  with FrmPreview do
  begin
    ActAsignarDocumentoImpresora.Execute;
    SynEditPrintPreview.FirstPage;
    SynEditPrintPreview.UpdatePreview;
    FrmPreview.ShowModal;
    ActImprimir.Execute; // Ojo: Accion de FrmPreview
  end;
// Todo: PFC  fPrintOut.WrapLongLines := cbWordWrap.Checked;
end;


(*
 * Funcion     : ActArchivoExportarHTMLBeforeExecute
 * Objetivos   : Inicializar
 *)
procedure TFrmEditor.ActArchivoExportarHTMLBeforeExecute(Sender: TObject);
begin
  ActArchivoExportarHTML.Dialog.FileName := '';
end;


(*
 * Funcion     : ActAsignarDocumentoImpresoraExecute
 * Objetivos   : Asignar el documento a la impresora
 *)
procedure TFrmEditor.ActAsignarDocumentoImpresoraExecute(Sender: TObject);
begin
  with FrmPreview do
  begin
//    SynEditPrint.
    with SynEditPrint.Header do
    begin
//      AFont := TFont.Create;
      Add('PFC - ' + FrmPrincipal.Caption, nil, taLeftJustify, 1);
      if FrmConfiguracion.EdtUsuario.Text <> '' then
        Add('Autor del documento: ' + FrmConfiguracion.EdtUsuario.Text, nil, taLeftJustify, 2);
      Add('Pag: $PAGENUM$ de $PAGECOUNT$', nil, taRightJustify, 1);
//      Add('Hecho por: Albert De La Fuente', nil, taLeftJustify, 2);
//      Add('$TITLE$', nil, taLeftJustify, 2);
//      AFont.Assign(DefaultFont);
//      AFont.Size := 6;
//      Add('Print Date: $DATE$. Time: $TIME$', AFont, taRightJustify, 2);
    end;
    with SynEditPrint.Footer do
    begin
//      AFont.Assign(DefaultFont);
      FrameTypes := [];
      if FrmConfiguracion.ChkBxMostrarPiePagina.Checked then
      begin
        FrameTypes := [ftLine];
        Add('$PAGENUM$/$PAGECOUNT$', nil, taRightJustify, 1);
      end
//      AFont.Size := 6;
//      Add('Printed by John Doe', AFont, taLeftJustify, 1);
    end;
    SynEditPrint.SynEdit  := SynEdit;
    SynEditPrint.Title    := '';
    SynEditPrintPreview.SynEditPrint := SynEditPrint;
  end;
end;


(*
 * Funcion     : SynEditChange
 * Objetivos   : Actualizar el caption de la ventana y la pestaa para reflejar
 *               las modificaciones
 *)
procedure TFrmEditor.SynEditChange(Sender: TObject);
begin
  SetTitulo;
  ActArchivoGuardar.Enabled := true;
//  PageControl := FrmPrincipal.PageControl1;
  FTabMDI.ImageIndex  := 59;//70
//  FModificado := true;
end;


(*
 * Funcion     : ActArchivoExportarHTMLAccept
 * Objetivos   : Exportar el editor + el grid a HTML (adems se aaden algunos
 *               datos como el usuario, la hora...)
 *)
procedure TFrmEditor.ActArchivoExportarHTMLAccept(Sender: TObject);
var
  Stream, Comando : TStringStream;
  i, j, Tope      : Integer;
  Campo           : String;
begin
  if Assigned(FrmPrincipal.ActiveMDIChild) then
  begin
    with TFrmEditor(FrmPrincipal.ActiveMDIChild) do
    begin
//      SynExporterHTML.Title := 'Fichero exportado por Medusa';
      DMGlobal.SynExporterHTML.Highlighter := SynEdit.Highlighter;
      DMGlobal.SynExporterHTML.ExportAsText := true;
      DMGlobal.SynExporterHTML.ExportAll(TFrmEditor(FrmPrincipal.ActiveMDIChild).SynEdit.Lines);
      with ActArchivoExportarHTML.Dialog do
      begin
        if ExtractFileExt(FileName) = '' then
          FileName := FileName + '.html';
//        SynExporterHTML.SaveToFile(FileName);
      end;
      with Stream do
      begin
        // Creamos el stream
        Stream  := TStringStream.Create('');
        Comando := TStringStream.Create('');

        // Y lo inicializamos
        DMGlobal.SynExporterHTML.SaveToStream(Comando);
//        SynExporterHTML.CopyToClipboard;

        // Aadimos la cabecera
        WriteString('<html>'#13#10);
        WriteString('<head>'#13#10);
        WriteString('<title>Fichero exportado por Medusa ' + GetAppInfo(ParamStr(0), 'FileVersion') + ' Editor sql*plus++</title>'#13#10);
        WriteString('</head>'#13#10);
        WriteString('<!-- Fichero generado por Medusa ' + GetAppInfo(ParamStr(0), 'FileVersion') + ' Editor sql*plus++ -->'#13#10);
        WriteString('<pre>'#13#10);

        // Aadimos el nombre del programa (jeje, esto parece shareware...)
        WriteString('<b>Fichero exportado por Medusa ' + GetAppInfo(ParamStr(0), 'FileVersion') + ' Editor sql*plus++ </b>'#13#10);
        WriteString('</pre>'#13#10);

        WriteString('<pre>'#13#10);
        // Aadimos el usuario (slo si est conectado)
        if (OracleSession.Connected) and (OracleDataSet.Active) and
           (OracleDataSet.RecordCount > 0) then
        begin
          WriteString('Usuario      : <b>' + OracleSession.LogonUsername + '@' + OracleSession.LogonDatabase + '</b>'#13#10);
        end;

        // Aadimos la fecha
        WriteString('Fecha y hora : <b>' + FormatDateTime('dddd dd/mm/yy - hh:mm:ss am/pm', now) + '</b>'#13#10#13#10#13#10);
        WriteString('</pre>'#13#10);

        WriteString('<pre>'#13#10);
        // Aadimos la consulta
        WriteString('<b><h3>Sentencia(s):</h3></b>'#13#10);
        WriteString('</pre>'#13#10);        

        Comando.Position := 86; //<html>#13#10<head>#13#10<title></title>#13#10 (33)
                                //</head>#13#10<!-- Generated by SynEdit HTML exporter#13#10 --> (54)
        while Comando.Position < Comando.Size do
        begin
          WriteString(Comando.ReadString(1));
        end;
          
        // Quitamos el fin de formato HTML </body>#13#10</html>
        Position := Position - 16;

//        WriteString('<body>'#13#10);

        if (OracleSession.Connected) and (OracleDataSet.Active) and
           (OracleDataSet.RecordCount > 0) then
        begin
          // Aadimos el nmero de tplas
          WriteString('<pre>'#13#10);
          WriteString('<b><h3>Filas seleccionadas: (' + IntToStr(OracleDataSet.RecordCount) +
                      ' Filas en total)</h3></b>'#13#10);
          WriteString('</pre>'#13#10);

          // y finalmente comenzamos con las tuplas
          WriteString('<table border="1" width="100%">'#13#10);
          OracleDataSet.DisableControls;
          OracleDataSet.First;
          // Escribimos el grid (i son las filas y j son las columnas)
          for i := -1 {Para el encabezado  } to OracleDataSet.RecordCount - 1 do
          begin       {Nombre de la columna}
            WriteString('<tr>'#13#10);
            for j := 0 to OracleDataSet.FieldCount - 1 do
            begin
              if i = -1 then
              begin
                WriteString('<td width="50%"><b>' + OracleDataSet.FieldList[j].FullName + '</b></td>'#13#10);
              end
              else
              begin
                if OracleDataSet.FieldByName(OracleDataSet.FieldList[j].FullName).IsNull then
                  Campo := '&nbsp;'
                else
                  Campo := OracleDataSet.FieldByName(OracleDataSet.FieldList[j].FullName).AsString;
                WriteString('<td width="50%">' + Campo + '</td>'#13#10);
              end;
            end;
            WriteString('</tr>'#13#10);
            OracleDataSet.Next;
          end;
          OracleDataSet.EnableControls;
          WriteString('</table>'#13#10);
//          WriteString(IntToStr(OracleDataSet.RecordCount) + ' Filas seleccionadas'#13#10);          
        end;
        Stream.WriteString(#13#10'</body>'#13#10'</html>');
        TMemoryStream(Stream).SaveToFile(ActArchivoExportarHTML.Dialog.FileName);
        Stream.Free;
        Comando.Free;
      end;
    end;
  end;
end;



////////////////////////////////////////////////////////////////////////////////
// ACCIONES DEL MEN EDICIN                                                 //
//////////////////////////////////////////////////////////////////////////////


(*
 * Funcion     : ActEdicionDeshacerExecute
 * Objetivos   : Deshacer la ltima accin
 *)
procedure TFrmEditor.ActEdicionDeshacerExecute(Sender: TObject);
begin
  SynEdit.Undo;
end;


(*
 * Funcion     : ActEdicinRehacerExecute
 * Objetivos   : Rehacer la ltima accin
 *)
procedure TFrmEditor.ActEdicionRehacerExecute(Sender: TObject);
begin
  SynEdit.Redo;
end;



////////////////////////////////////////////////////////////////////////////////
// ACCIONES DEL MEN ORACLE                                                  //
//////////////////////////////////////////////////////////////////////////////


(*
 * Funcion     : ActOracleEjecutarConsultaExecute
 * Objetivos   : Lanzar la consulta (se actualiza la status bar y se aade
 *               el texto al buffer).
 *)
procedure TFrmEditor.ActOracleEjecutarConsultaExecute(Sender: TObject);
var
  Str     : String;
  Editor  : TFrmEditor;
  Error   : Boolean;
begin
  Editor := TFrmEditor(FrmPrincipal.ActiveMDIChild);

{  if Editor.SynEdit.Lines.Count = 0 then
    Exit;}

  with Editor do
  begin
    // As puedo recordar, que opcin ha escogido
    MIEjecutarConsulta.Tag := 1;
    MIEjecutarScript.Tag := 0;

    Editor.RchEdtMensajes.Clear;
    Editor.RchEdtErrores.Clear;
    LimpiarMarca(MarcaWarning);
    OracleDataSet.SQL.Clear;
    if not OracleSession.Connected then
      ActOracleConectarDesconectar.Execute;
    OracleDataSet.SQL.Assign(SynEdit.Lines);

    // Quito los saltos de lnea
    while (OracleDataSet.SQL[OracleDataSet.SQL.Count - 1] = #13#10) or
          (OracleDataSet.SQL[OracleDataSet.SQL.Count - 1] = '') do
      OracleDataSet.SQL.Delete(OracleDataSet.SQL.Count - 1);

    // Quito el ";" de la consulta (por costumbre del Oracle)
    Str := OracleDataSet.SQL[OracleDataSet.SQL.Count - 1];

    if (Length(Str) <> 0) and (Str[Length(Str)] = ';') then
    begin
      SetLength(Str, Length(Str) -1);
      OracleDataSet.SQL[OracleDataSet.SQL.Count - 1] := Str;
    end;

    Error := False;
    OracleDataSet.Close;
    try
      try
        Screen.Cursor := crSQLWait;
        OracleDataSet.Open;
        Editor.SetTuplas;
        PageControl.ActivePage := TbShtResultados;        
      finally
        Screen.Cursor := crDefault;
      end;
    except
      on E: EOracleError do
      begin
        Error := True;
        RchEdtErrores.Lines.Add(Format(SInfoLineaWarning, [OracleDataSet.ErrorLine, E.Message]));
        MarcarError(OracleDataSet.ErrorLine);
        PageControl.ActivePage := TbShtErrores;
      end;
    end;

    // Aadimos las lneas al buffer
    AddBuffer(Error);

    FrmPrincipal.TlBtnEjecutar.Action := ActOracleEjecutarConsulta;
    MIEjecutar.Action := ActOracleEjecutarConsulta;
  end;
end;


(*
 * Funcion     : ActOracleEjecutarScriptExecute
 * Objetivos   : Ejecutar el script (igual que el caso anterior).
 *)
procedure TFrmEditor.ActOracleEjecutarScriptExecute(Sender: TObject);
var
  Editor  : TFrmEditor;
  Error   : Boolean;
begin
  Editor := TFrmEditor(FrmPrincipal.ActiveMDIChild);
  with Editor do
  begin
    // As puedo recordar, que opcin ha escogido
    MIEjecutarConsulta.Tag := 0;
    MIEjecutarScript.Tag := 1;

    RchEdtMensajes.Clear;
    RchEdtErrores.Clear;
    OracleScript.Output.Clear;    
    LimpiarMarca(MarcaWarning);
    if not OracleSession.Connected then
      ActOracleConectarDesconectar.Execute;

    OracleScript.Lines.Assign(SynEdit.Lines);
    if SynEdit.Lines.Count > 0 then
    begin
      Screen.Cursor := crSQLWait;
      OracleScript.Execute;
      Screen.Cursor := crDefault;
    end;

    // Aadimos el texto al buffer
    Error := (PageControl.ActivePage = TbShtErrores) and (RchEdtErrores.Lines.Count <> 0);
    AddBuffer(Error);

    RchEdtMensajes.Lines.AddStrings(OracleScript.Output);
    if not Error then
      PageControl.ActivePage := TbShtMensajes;
    FrmPrincipal.TlBtnEjecutar.Action := ActOracleEjecutarScript;
    MIEjecutar.Action := ActOracleEjecutarScript;
  end;
end;


(*
 * Funcion     : ActOracleConectarDesconectarExecute
 * Objetivos   : Conecta o desconecta la ventana a Oracle
 *)
procedure TFrmEditor.ActOracleConectarDesconectarExecute(Sender: TObject);
begin
  if not ActOracleConectarDesconectar.Checked then
  begin
    // Con esto se personaliza el dialogo de logon (ver ayuda...)
    ltLogonTitle   := 'Medusa - Login a la BD';
    ltUsername     := 'Usuario';
    ltPassword     := 'Contrasea';
    ltDatabase     := 'BD';
    ltOKButton     := 'Ok';
    ltCancelButton := 'Cancelar';
    ltConnectAs    := 'Conectar como';
    ltHistoryHint  := 'historial de conexiones';

    if not FConectarDefecto then
    begin
      // CONEXIN CON LA VENTANA ACTIVA
      if FrmConfiguracion.RdGrpFormaConexion.ItemIndex = 0 then
      begin
        // Si es la primera ventana
        if (FrmPrincipal.MDIChildCount = 1) {and (FrmConfiguracion.ChkBxConectarAutomaticamente.Checked)} then
        begin
          DMGlobal.OracleLogon.Session := TFrmEditor(FrmPrincipal.ActiveMDIChild).OracleSession;
          DMGlobal.OracleLogon.Execute;
        end
        // Si no
        else //if FrmConfiguracion.ChkBxConectarAutomaticamente.Checked then
        begin
          // FUNCIONA, NO ME LO PUEDO CREER!!!
          OracleSession.LogonUsername := TFrmEditor(FrmPrincipal.MDIChildren[FrmPrincipal.MDIChildCount - FVentanaAnterior]).OracleSession.LogonUsername;
          OracleSession.LogonPassword := TFrmEditor(FrmPrincipal.MDIChildren[FrmPrincipal.MDIChildCount - FVentanaAnterior]).OracleSession.LogonPassword;
          if TFrmEditor(FrmPrincipal.MDIChildren[FrmPrincipal.MDIChildCount - FVentanaAnterior]).OracleSession.Connected then
            OracleSession.LogOn
          else begin
            FConectarDefecto := true;
//            ActOracleConectarDesconectar.Execute;
          end;
        end;
      end
      // CONEXIN FIJA, CON USUARIO "CONECTAR COMO"
      else if FrmConfiguracion.RdGrpFormaConexion.ItemIndex = 2 then
      begin
        if (FrmPrincipal.MDIChildCount = 1) and
           (not FrmConfiguracion.ChkBxGuardarIni.Checked) then
        begin
          DMGlobal.OracleLogon.Session := TFrmEditor(FrmPrincipal.ActiveMDIChild).OracleSession;
          DMGlobal.OracleLogon.Session.LogonUsername := FrmConfiguracion.EdtLogin.Text;
          DMGlobal.OracleLogon.Execute;
        end
        else if FrmConfiguracion.ChkBxGuardarIni.Checked then
          OracleSession.LogonPassword := FrmConfiguracion.EdtPassword.Text
        else if FrmPrincipal.MDIChildCount <> 1 then
          OracleSession.LogonPassword := TFrmEditor(FrmPrincipal.MDIChildren[1]).OracleSession.LogonPassword;

        OracleSession.LogonUsername := FrmConfiguracion.EdtLogin.Text;
        OracleSession.LogOn;
      end;
    end;

    // CONECTAR COMO USUARIO NUEVO (NOTA: EL ORDEN IMPORTA, DEBE IR AQU ABAJO...)
    if (FConectarDefecto) or (FrmConfiguracion.RdGrpFormaConexion.ItemIndex = 1) then
    begin
      DMGlobal.OracleLogon.Session := TFrmEditor(FrmPrincipal.ActiveMDIChild).OracleSession;
      DMGlobal.OracleLogon.Execute;
    end;


    if OracleSession.Connected then
    begin
      ActOracleConectarDesconectar.ImageIndex := ActOracleConectarDesconectar.ImageIndex +1;
      ActOracleConectarDesconectar.Caption := 'Desconectar';
    end
    else begin
      FrmPrincipal.TlBtnConectarDesconectar.Down := false;
//      ActOracleConectarDesconectar.Checked := false
    end
(*    else
      ActOracleConectarDesconectar.Checked := false;*)
  end
  else begin
    if OracleSession.Connected then
    begin
      ActOracleConectarDesconectar.ImageIndex := ActOracleConectarDesconectar.ImageIndex -1;
      ActOracleConectarDesconectar.Caption := 'Conectar';
      TFrmEditor(FrmPrincipal.ActiveMDIChild).SetUsuario;
    end;
    OracleSession.LogOff;
  end;
  ActOracleConectarDesconectar.Checked := FrmPrincipal.TlBtnConectarDesconectar.Down;
  ActualizarEstadoMDI(true);
end;



////////////////////////////////////////////////////////////////////////////////
// RUTINAS DE ACTUALIZACION DE LA STATUS BAR                                 //
//////////////////////////////////////////////////////////////////////////////

(*
 * Funcion     : DBGrdCellClick
 * Objetivos   : Actualiza la status bar, para reflejar el registro seleccionado
 *)
procedure TFrmEditor.DBGridCellClick(Column: TColumn);
begin
  FrmPrincipal.StatusBar.Panels[4].Text := IntToStr(OracleDataSet.RecNo) + '/' + IntToStr(OracleDataSet.RecordCount);
end;


(*
 * Funcion     : DBGridKeyDowd
 * Objetivos   : Exactamente igual que el mtodo anterior
 *)
procedure TFrmEditor.DBGridKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  FrmPrincipal.StatusBar.Panels[4].Text := IntToStr(OracleDataSet.RecNo) + '/' + IntToStr(OracleDataSet.RecordCount);
end;


(*
 * Funcion     : SynEditStatusChange
 * Objetivos   : Actualizar el estado del editor para reflejarlo en el entorno
 *)
procedure TFrmEditor.SynEditStatusChange(Sender: TObject;
  Changes: TSynStatusChanges);
begin
  SetPosCaret;
  SetOffset;
  SetEstadoTeclado;
  SetEstadoEditor;
  SetEstadoTeclado;
  ActEdicionDeshacer.Enabled  := SynEdit.CanUndo;
  ActEdicionRehacer.Enabled   := SynEdit.CanRedo;
end;


(*
 * Funcion     : SynEditDropFiles
 * Objetivos   : Integrar Drag&Drop en Medusa
 *)
// todo: hacer lo del nuevo con el abrir (confirmar si ha modificado)
procedure TFrmEditor.SynEditDropFiles(Sender: TObject; X, Y: Integer;
  AFiles: TStrings);
begin
  TFrmEditor.Create(nil).AbrirFichero(AFiles[0]);
end;



////////////////////////////////////////////////////////////////////////////////
// CONSULTA AL DD                                                            //
//////////////////////////////////////////////////////////////////////////////


(*
 * Funcion     : ConstruirConsulta
 * Objetivos   : Carga una consulta del menu "Diccionario de datos"
 *)
procedure TFrmEditor.ConstruirConsulta(Tabla: String);
begin
  with TFrmEditor(FrmPrincipal.ActiveMDIChild) do
  begin
    with SynEdit.Lines do
    begin
      LoadFromFile(ExtractFilePath(ParamStr(0)) + 'Consultas DD' + PathDelim + Tabla + '.SQL');
{      Add('SELECT *');
      Add('FROM ' + Tabla);}
    end;
{    with OracleDataSet do
    begin
      Close;
      SQL.Clear;
      SQL.Assign(SynEdit.Lines);
      Cursor := crSQLWait;
      Open;
      Cursor := crDefault;
    end;
    PageControl.ActivePage := TbShtResultados;}
  end;
end;


(*
 * Funcion     : ConsultaDD
 * Objetivos   : Construir la consulta e intentar lanzarla 
 *)
procedure TFrmEditor.ConsultaDD(Tabla: String);
begin
  with TFrmEditor.Create(nil) do
  begin
    ConstruirConsulta(Tabla);
    if not OracleSession.Connected then
      ActOracleConectarDesconectar.Execute;
    if OracleSession.Connected then
      ActOracleEjecutarConsulta.Execute;
  end;
end;


// Consulta para ver el usuario
procedure TFrmEditor.ActDDUsuarioActualExecute(Sender: TObject);
begin
  if not OracleSession.Connected then
    ActOracleConectarDesconectar.Execute;
  with OracleDataSet, OracleDataSet.SQL do
  begin
    Close;
    Clear;
    Add('SELECT USER FROM DUAL');
    Open;
  end;
end;

// De aqu en adelante son consultas al diccionario de datos.
// El argumento de la funcin ConsultaDD, indica la vista
// a la que se har la consulta.
procedure TFrmEditor.ActDDALLTablasExecute(Sender: TObject);
begin
  ConsultaDD('ALL_TABLES');
end;

procedure TFrmEditor.ActDDALLTriggersExecute(Sender: TObject);
begin
  ConsultaDD('ALL_TRIGGERS');
end;

procedure TFrmEditor.ActDDALLVistasExecute(Sender: TObject);
begin
  ConsultaDD('ALL_VIEWS');
end;

procedure TFrmEditor.ActDDALLUsuariosExecute(Sender: TObject);
begin
  ConsultaDD('ALL_USERS');
end;

procedure TFrmEditor.ActDDALLObjetosExecute(Sender: TObject);
begin
  ConsultaDD('ALL_OBJECTS');
end;

procedure TFrmEditor.ActDDALLTrabajosExecute(Sender: TObject);
begin
  ConsultaDD('ALL_JOBS');
end;

procedure TFrmEditor.ActDDALLSinonimosExecute(Sender: TObject);
begin
  ConsultaDD('ALL_SYNONYMS');
end;

procedure TFrmEditor.ActDDALLIndicesExecute(Sender: TObject);
begin
  ConsultaDD('ALL_INDEXES');
end;

procedure TFrmEditor.ActDDALLPrivilegiosTablasCedidosExecute(
  Sender: TObject);
begin
  ConsultaDD('ALL_TAB_PRIVS_MADE');
end;

procedure TFrmEditor.ActDDALLPrivilegiosTablasRecibidosExecute(
  Sender: TObject);
begin
  ConsultaDD('ALL_TAB_PRIVS_RECD');
end;

procedure TFrmEditor.ActDDALLPrivilegiosColumnasCedidosExecute(
  Sender: TObject);
begin
  ConsultaDD('ALL_COL_PRIVS_MADE');
end;

procedure TFrmEditor.ActDDALLPrivilegiosColumnasRecibidosExecute(
  Sender: TObject);
begin
  ConsultaDD('ALL_COL_PRIVS_RECD');
end;

procedure TFrmEditor.ActDDALLRestriccionesTodasExecute(Sender: TObject);
begin
  ConsultaDD('ALL_CONSTRAINTS');
end;

procedure TFrmEditor.ActDDALLRestriccionesColumnasExecute(Sender: TObject);
begin
  ConsultaDD('ALL_CONS_COLUMNS');
end;

procedure TFrmEditor.ActDDALLComentariosTablasExecute(Sender: TObject);
begin
  ConsultaDD('ALL_TAB_COMMENTS');
end;

procedure TFrmEditor.ActDDALLComentariosColumnasExecute(Sender: TObject);
begin
  ConsultaDD('ALL_COL_COMMENTS');
end;

procedure TFrmEditor.ActDDUSERTablasExecute(Sender: TObject);
begin
  ConsultaDD('USER_TABLES');
end;

procedure TFrmEditor.ActDDUSERTriggersExecute(Sender: TObject);
begin
  ConsultaDD('USER_TRIGGERS');
end;

procedure TFrmEditor.ActDDUSERVistasExecute(Sender: TObject);
begin
  ConsultaDD('USER_VIEWS');
end;

procedure TFrmEditor.ActDDUSERUsuarioExecute(Sender: TObject);
begin
  ConsultaDD('USER_USERS');
end;

procedure TFrmEditor.ActDDUSERObjetosExecute(Sender: TObject);
begin
  ConsultaDD('USER_OBJECTS');
end;

procedure TFrmEditor.ActDDUSERTrabajosExecute(Sender: TObject);
begin
  ConsultaDD('USER_JOBS');
end;

procedure TFrmEditor.ActDDUSERSinonimosExecute(Sender: TObject);
begin
  ConsultaDD('USER_SYNONYMS');
end;

procedure TFrmEditor.ActDDUSERIndicesExecute(Sender: TObject);
begin
  ConsultaDD('USER_INDEXES');
end;

procedure TFrmEditor.ActDDUSERPrivilegiosTablasCedidosExecute(
  Sender: TObject);
begin
  ConsultaDD('USER_TAB_PRIVS_MADE');
end;

procedure TFrmEditor.ActDDUSERPrivilegiosTablasRecibidosExecute(
  Sender: TObject);
begin
  ConsultaDD('USER_TAB_PRIVS_RECD');
end;

procedure TFrmEditor.ActDDUSERPrivilegiosColumnasCedidosExecute(
  Sender: TObject);
begin
  ConsultaDD('USER_COL_PRIVS_MADE');
end;

procedure TFrmEditor.ActDDUSERPrivilegiosColumnasRecibidosExecute(
  Sender: TObject);
begin
  ConsultaDD('USER_COL_PRIVS_RECD');
end;

procedure TFrmEditor.ActDDUSERRestriccionesTodasExecute(Sender: TObject);
begin
  ConsultaDD('USER_CONSTRAINTS');
end;

procedure TFrmEditor.ActDDUSERRestriccionesColumnasExecute(
  Sender: TObject);
begin
  ConsultaDD('USER_CONS_COLUMNS');
end;

procedure TFrmEditor.ActDDUSERComentariosTablasExecute(Sender: TObject);
begin
  ConsultaDD('USER_TAB_COMMENTS');
end;

procedure TFrmEditor.ActDDUSERComentariosColumnasExecute(Sender: TObject);
begin
  ConsultaDD('USER_COL_COMMENTS');
end;

procedure TFrmEditor.MIDDDBATablasClick(Sender: TObject);
begin
  ConsultaDD('DBA_TABLES');
end;

procedure TFrmEditor.MIDDDBATriggersClick(Sender: TObject);
begin
  ConsultaDD('DBA_TRIGGERS');
end;

procedure TFrmEditor.MIDDDBAVistasClick(Sender: TObject);
begin
  ConsultaDD('DBA_VIEWS');
end;

procedure TFrmEditor.MIDDDBAUsuariosClick(Sender: TObject);
begin
  ConsultaDD('DBA_USERS');
end;

procedure TFrmEditor.MIDDDBAObjetosClick(Sender: TObject);
begin
  ConsultaDD('DBA_OBJECTS');
end;

procedure TFrmEditor.MIDDDBATrabajosClick(Sender: TObject);
begin
  ConsultaDD('DBA_JOBS');
end;

procedure TFrmEditor.MIDDDBASinonimosClick(Sender: TObject);
begin
  ConsultaDD('DBA_SYNONYMS');
end;

procedure TFrmEditor.MIDDDBAIndicesClick(Sender: TObject);
begin
  ConsultaDD('DBA_INDEXES');
end;

procedure TFrmEditor.MIDDDBASubPrivilegiosSubTablasCedidosClick(
  Sender: TObject);
begin
  ConsultaDD('DBA_TAB_PRIVS_MADE');
end;

procedure TFrmEditor.MIDDDBASubPrivilegiosSubTablasRecibidosClick(
  Sender: TObject);
begin
  ConsultaDD('DBA_TAB_PRIVS_RECD');
end;

procedure TFrmEditor.MIDDDBASubPrivilegiosSubColumnasCedidosClick(Sender: TObject);
begin
  ConsultaDD('DBA_COL_PRIVS_MADE');
end;

procedure TFrmEditor.MIDDDBASubPrivilegiosSubColumnasRecibidosClick(Sender: TObject);
begin
  ConsultaDD('DBA_COL_PRIVS_RECD');
end;

procedure TFrmEditor.MIDDDBASubRestriccionesTodasClick(Sender: TObject);
begin
  ConsultaDD('DBA_CONSTRAINTS');
end;

procedure TFrmEditor.MIDDDBASubRestriccionesColumnasClick(Sender: TObject);
begin
  ConsultaDD('DBA_CONS_COLUMNS');
end;

procedure TFrmEditor.MIDDDBASubComentariosTablasClick(Sender: TObject);
begin
  ConsultaDD('DBA_TAB_COMMENTS');
end;

procedure TFrmEditor.MIDDDBASubComentariosColumnasClick(Sender: TObject);
begin
  ConsultaDD('DBA_COL_COMMENTS');
end;

procedure TFrmEditor.ActDDVIRTBaseDatosExecute(Sender: TObject);
begin
  try
    ConsultaDD('V$DATABASE');
  except
    ShowMessage('No dispone de permisos para ver esta tabla (debes ser SYS o DBA)');
  end;
end;

procedure TFrmEditor.ActDDVIRTFicherosDatosExecute(Sender: TObject);
begin
  try
    ConsultaDD('V$DATAFILE');
  except
    ShowMessage('No dispone de permisos para ver esta tabla (debes ser SYS o DBA)');
  end;
end;

procedure TFrmEditor.ActDDVIRTTablasFijasExecute(Sender: TObject);
begin
  try
    ConsultaDD('V$FIXED_TABLE');
  except
    ShowMessage('No dispone de permisos para ver esta tabla (debes ser SYS o DBA)');
  end;
end;

procedure TFrmEditor.ActDDVIRTSesionesExecute(Sender: TObject);
begin
  try
    ConsultaDD('V$SESSION');
  except
    ShowMessage('No dispone de permisos para ver esta tabla (debes ser SYS o DBA)');
  end;
end;

procedure TFrmEditor.ActDDVIRTProcesosExecute(Sender: TObject);
begin
  try
    ConsultaDD('V$PROCESS');
  except
    ShowMessage('No dispone de permisos para ver esta tabla (debes ser SYS o DBA)');
  end;
end;

procedure TFrmEditor.ActDDVIRTFicherosControlExecute(Sender: TObject);
begin
  try
    ConsultaDD('V$CONTROLFILE');
  except
    ShowMessage('No dispone de permisos para ver esta tabla (debes ser SYS o DBA)');
  end;
end;

procedure TFrmEditor.FormDeactivate(Sender: TObject);
begin
{  if (FrmPrincipal.MDIChildCount = 1) and (FrmEditor.Destroying) then
    HabilitarToolBarMDI(false);}
end;


(*
 * Funcion     : MostrarDialogoBuscarReemplazar
 * Objetivos   : Mostrar el dilogo de buscar o reemplazar
 *)
procedure TFrmEditor.MostrarDialogoBuscarReemplazar(Reemplazar: boolean);
var
  dlg: TFrmBuscarTexto;
begin
  FrmPrincipal.StatusBar.Panels[5].Text := '';
  if Reemplazar then
    dlg := TFrmReemplazarTexto.Create(Self)
  else
    dlg := TFrmBuscarTexto.Create(Self);
  with dlg do try
    // asignamos las opciones de bsqueda
    SearchBackwards := gbBuscarAtras;
    SearchCaseSensitive := gbBuscarMayusMinus;
    SearchFromCursor := gbBuscarDesdeCaret;
    SearchInSelectionOnly := gbSearchSelectionOnly;
    // Y buscamos con el ltimo texto
    SearchText := gsSearchText;
    if gbSearchTextAtCaret then begin
      // Si algo est seleccionado, buscamos ese texto
      if SynEdit.SelAvail and (SynEdit.BlockBegin.Y = SynEdit.BlockEnd.Y)
      then
        SearchText := SynEdit.SelText
      else
        SearchText := SynEdit.GetWordAtRowCol(SynEdit.CaretXY);
    end;
    SearchTextHistory := gsSearchTextHistory;
    if Reemplazar then
      with dlg as TFrmReemplazarTexto do
      begin
        ReplaceText := gsReplaceText;
        ReplaceTextHistory := gsReplaceTextHistory;
      end;
    SearchWholeWords := gbSearchWholeWords;
    if ShowModal = mrOK then begin
      gbBuscarAtras := SearchBackwards;
      gbBuscarMayusMinus := SearchCaseSensitive;
      gbBuscarDesdeCaret := SearchFromCursor;
      gbSearchSelectionOnly := SearchInSelectionOnly;
      gbSearchWholeWords := SearchWholeWords;
      gsSearchText := SearchText;
      gsSearchTextHistory := SearchTextHistory;
      if Reemplazar then
        with dlg as TFrmReemplazarTexto do
        begin
          gsReplaceText := ReplaceText;
          gsReplaceTextHistory := ReplaceTextHistory;
        end;
//      gbBuscarDesdeCaret := gbBuscarDesdeCaret;
      if gsSearchText <> '' then
      begin
        BuscarReemplazarTexto(Reemplazar, gbBuscarAtras);
        SearchFromCursor := true;
        gbBuscarDesdeCaret := TRUE;
      end;
    end;
  finally
    dlg.Free;
  end;
end;


(*
 * Funcion     : BuscarReemplazarTexto
 * Objetivos   : Busca o reemplaza el texto, adems puede ser hacia delante o atrs.
 *)
procedure TFrmEditor.BuscarReemplazarTexto(Reemplazar: boolean; HaciaAtras: boolean);
var
  Options: TSynSearchOptions;
begin
  FrmPrincipal.Statusbar.SimpleText := '';
  if Reemplazar then
    Options := [ssoPrompt, ssoReplace, ssoReplaceAll]
  else
    Options := [];
  if HaciaAtras then
    Include(Options, ssoBackwards);
  if gbBuscarMayusMinus then
    Include(Options, ssoMatchCase);
  if not gbBuscarDesdeCaret then
    Include(Options, ssoEntireScope);
  if gbSearchSelectionOnly then
    Include(Options, ssoSelectedOnly);
  if gbSearchWholeWords then
    Include(Options, ssoWholeWord);

  if ((BusquedaCiclica) and not (ssoBackwards in Options) and (SynEdit.CaretY >= CaretInicial.Y))
  or ((BusquedaCiclica) and (ssoBackwards in Options) and (SynEdit.CaretY <= CaretInicial.Y)) then
  begin
    MessageBeep(MB_ICONASTERISK);
    FrmPrincipal.Statusbar.Panels[5].Text := STextoNoEncontrado;
//    MessageDlg('No hay ms apariciones.' + #13 +
    Exit;
  end;

  if SynEdit.SearchReplace(gsSearchText, gsReplaceText, Options) = 0 then
  begin
    MessageBeep(MB_ICONASTERISK);
    FrmPrincipal.Statusbar.Panels[5].Text := STextoNoEncontrado;
    if ssoBackwards in Options then
      SynEdit.BlockEnd := SynEdit.BlockBegin
    else
      SynEdit.BlockBegin := SynEdit.BlockEnd;
    SynEdit.CaretXY := SynEdit.BlockBegin;
    BusquedaCiclica := MessageDlg('No hay ms apariciones.' + #13 +
                                  'Deseas continuar ciclicamente?', mtInformation,
                                  mbOKCancel, 0) = mrOk;
    if BusquedaCiclica then
    begin
      if ssoBackwards in Options then
      begin
        SynEdit.CaretXY := Point(Length(SynEdit.Lines[SynEdit.Lines.Count-1]),
                                 SynEdit.Lines.Count);
//        ShowMessage('X: ' + IntToStr(SynEdit.CaretX) + 'Y: ' + IntToStr(SynEdit.CaretY));
      end
      else
        SynEdit.CaretXY := Point(0, 0);
      BuscarReemplazarTexto(Reemplazar, HaciaAtras);
    end;
  end;

  if FrmConfirmarReemplazo <> nil then
    FrmConfirmarReemplazo.Free;
end;


(*
 * Funcion     : ActEdicionBuscarExecute
 * Objetivos   : Realiza la llamada a las funciones anteriores
 *)
procedure TFrmEditor.ActEdicionBuscarExecute(Sender: TObject);
begin
  BusquedaCiclica := false;
  CaretInicial := SynEdit.CaretXY;
  MostrarDialogoBuscarReemplazar(false);
  ActualizarEstadoMDI(true);
end;


(*
 * Funcion     : ActEdicionReemplazarExecute
 * Objetivos   : Realiza el reemplazo de texto
 *)
procedure TFrmEditor.ActEdicionReemplazarExecute(Sender: TObject);
begin
  BusquedaCiclica := false;
  CaretInicial := SynEdit.CaretXY;
  MostrarDialogoBuscarReemplazar(true);
end;


(*
 * Funcion     : SynEditReplaceText
 * Objetivos   : Marca el texto buscado y pregunta si debe reemplazarlo o no
 *)
procedure TFrmEditor.SynEditReplaceText(Sender: TObject; const ASearch,
  AReplace: String; Line, Column: Integer; var Action: TSynReplaceAction);
var
  APos: TPoint;
  EditRect: TRect;
begin
  if ASearch = AReplace then
    Action := raSkip
  else begin
    APos := Point(Column, Line);
    APos := SynEdit.ClientToScreen(SynEdit.RowColumnToPixels(APos));
    EditRect := ClientRect;
    EditRect.TopLeft := ClientToScreen(EditRect.TopLeft);
    EditRect.BottomRight := ClientToScreen(EditRect.BottomRight);

    if FrmConfirmarReemplazo = nil then
      FrmConfirmarReemplazo := TFrmConfirmarReemplazo.Create(Application);
    FrmConfirmarReemplazo.PrepareShow(EditRect, APos.X, APos.Y,
      APos.Y + SynEdit.LineHeight, ASearch);
    case FrmConfirmarReemplazo.ShowModal of
      mrYes: Action := raReplace;
      mrYesToAll: Action := raReplaceAll;
      mrNo: Action := raSkip;
      else Action := raCancel;
    end;
  end;
end;


(*
 * Funcion     : ActArchivoGuardarUpdate
 * Objetivos   : Actualizar el estado de la accin que llama al mtodo
 *)
procedure TFrmEditor.ActArchivoGuardarUpdate(Sender: TObject);
begin
  (Sender as TAction).Enabled := (SynEdit.Modified);
//    and not SynEditor.ReadOnly;
end;


(*
 * Funcion     : ActEdicionDeshacerUpdate
 * Objetivos   :
 *)
procedure TFrmEditor.ActEdicionDeshacerUpdate(Sender: TObject);
begin
//  TAction(Sender).Enabled := SynEdit.CanUndo;
end;


(*
 * Funcion     : ActEdicionRehacerUpdate
 * Objetivos   :
 *)
procedure TFrmEditor.ActEdicionRehacerUpdate(Sender: TObject);
begin
//  TAction(Sender).Enabled := SynEdit.CanRedo;
end;


(*
 * Funcion     : ActEdicionBuscarSiguienteExecute
 * Objetivos   : Busca la siguiente aparicin del texto
 *)
procedure TFrmEditor.ActEdicionBuscarSiguienteExecute(Sender: TObject);
begin
  BuscarReemplazarTexto(false, false);
end;


(*
 * Funcion     : ActEdicionBuscarAnteriorExecute
 * Objetivos   : Busca la aparicin anterior del texto
 *)
procedure TFrmEditor.ActEdicionBuscarAnteriorExecute(Sender: TObject);
begin
  BuscarReemplazarTexto(false, true);
end;


(*
 * Funcion     : MIConmutarMarca0Click
 * Objetivos   : Se reutiliza para conmutar las 10 marcas del editor.
 *               Se utiliza el campo Tag para saber quien ha llamado al mtodo.
 *)
procedure TFrmEditor.MIConmutarMarca0Click(Sender: TObject);
var
  X, Y  : Integer;
begin
  SynEdit.GetBookMark(TMenuItem(Sender).Tag, X, Y);
  if (X = SynEdit.CaretX) and (Y = SynEdit.CaretY) then
  begin
    SynEdit.ClearBookMark(TMenuItem(Sender).Tag);
    TMenuItem(Sender).Checked := false;
  end
  else begin
    SynEdit.SetBookMark(TMenuItem(Sender).Tag, SynEdit.CaretX, SynEdit.CaretY);
    TMenuItem(Sender).Checked := true;
  end;
end;


(*
 * Funcion     : MIGotoMarca0Click
 * Objetivos   : Igualmente, se reutiliza para ir a la marca indicada
 *)
procedure TFrmEditor.MIGotoMarca0Click(Sender: TObject);
begin
  SynEdit.GotoBookMark(TMenuItem(Sender).Tag);
end;


(*
 * Funcion     : SynEditClearBookmark
 * Objetivos   : Desmarca la bookmark indicada
 *)
procedure TFrmEditor.SynEditClearBookmark(Sender: TObject;
  var Mark: TSynEditMark);
begin
  if Sender is TMenuItem then
    TMenuItem(FindComponent('MIConmutarMarca' + IntToStr(Mark.ImageIndex))).Checked := false;
end;


(*
 * Funcion     : SynEditPlaceBookmark
 * Objetivos   : Pone una marca en el gutter
 *)
procedure TFrmEditor.SynEditPlaceBookmark(Sender: TObject;
  var Mark: TSynEditMark);
begin
  if Sender is TMenuItem then
    TMenuItem(FindComponent('MIConmutarMarca' + IntToStr(Mark.ImageIndex))).Checked := true;
end;


(*
 * Funcion     : MILimpiarMarcasClick
 * Objetivos   : Elimina todas las marcas del editor
 *)
procedure TFrmEditor.MILimpiarMarcasClick(Sender: TObject);
var
  i : Integer;
begin
  for i := 0 to 9 do
    SynEdit.ClearBookMark(i);
end;


(*
 * Funcion     : CargarPlantillaTexto
 * Objetivos   : Carga la plantilla de autocompletado de texto                      
 *)
procedure TFrmEditor.CargarPlantillaTexto(Fichero: String);
begin
  if not FileExists(ExtractFilePath(ParamStr(0)) + '\Plantillas\' + Fichero) then
  begin
    MessageBox(Handle, PChar('La plantilla "' + Fichero + '"'), PChar(Application.Title), MB_OK or MB_ICONERROR or MB_SYSTEMMODAL);
    Exit;
  end;
  
  with TFrmEditor.Create(nil) do
  begin
    SynEdit.Lines.LoadFromFile(ExtractFilePath(ParamStr(0)) + '\Plantillas\' + Fichero);
  end;
end;


(*
 * Funcion     : ActInsertarCrearTablaExecute
 * Objetivos   : (actualmente no usado)
 *)
procedure TFrmEditor.ActInsertarCrearTablaExecute(Sender: TObject);
begin
  CargarPlantillaTexto('CreateTable.plt');
end;


(*
 * Funcion     : ActInsertarCrearTriggerExecute
 * Objetivos   : (actualmente no usado)
 *)
procedure TFrmEditor.ActInsertarCrearTriggerExecute(Sender: TObject);
begin
  CargarPlantillaTexto('CreateTrigger.plt');
end;


(*
 * Funcion     : MIInformacionSesionClick
 * Objetivos   : Muestra el formulario de informacin de la sesin
 *)
procedure TFrmEditor.MIInformacionSesionClick(Sender: TObject);
begin
  FrmInformacion.ShowModal;
end;


(*
 * Funcion     : MIReconstruirCreateTableClick
 * Objetivos   : Mostrar el formulario de reconstruccin de la sentencia CREATE TABLE
 *)
procedure TFrmEditor.MIReconstruirCreateTableClick(
  Sender: TObject);
begin
  FrmReconstruirCreateTable.ShowModal;
end;


(*
 * Funcion     : ActVentanaMaximizarTodoExecute
 * Objetivos   : Maximizar todas las ventanas
 *)
procedure TFrmEditor.ActVentanaMaximizarTodoExecute(Sender: TObject);
var
  i : Integer;
begin
  for i := 0 to FrmPrincipal.MDIChildCount - 1 do
  begin
    TFrmEditor(FrmPrincipal.MDIChildren[i]).WindowState := wsMaximized;
  end;
end;


(*
 * Funcion     : FormShow
 * Objetivos   : Implementar el auto-login (tal vez se pueda meter en el Activate)
 *)
procedure TFrmEditor.FormShow(Sender: TObject);
begin
  FSimularFormShow := True;
  // Todo esto hay que hacerlo para la conexin automtica, no se porque, pero
  // si se pone el cdigo que est debajo entre los comentarios (* y *), hay
  // un error al conectar la primera vez, porque todava no se ha creado la
  // sesin. Repito: No se porqu pasa eso.
  // Esta solucin es "poco elegante", pero no se me ocurre otra forma de hacerlo

(*  if ((FrmConfiguracion.ChkBxConectarAutomaticamente.Checked) or
     (FrmConfiguracion.ChkBxConectarAutomaticamenteSesion.Checked)) //and
{     (Assigned(FrmPrincipal.ActiveMDIChild) and
     TFrmEditor(FrmPrincipal.ActiveMDIChild).OracleSession.Connected)} then
    ActOracleConectarDesconectar.Execute;*)
{
  if Application.MainForm = nil then begin
    fAutoComplete := TSynAutoComplete.Create(Self);
    fAutoComplete.Editor := SynEdit1;
    fAutoComplete.AutoCompleteList.LoadFromFile('Delphi32.dci');
  end else
    Form1.fAutoComplete.AddEditor(SynEdit1);
  SynEdit1.AddKey(ecAutoCompletion, word('J'), [ssCtrl], 0, []);
}
end;


(*
 * Funcion     : MIVisualProcFuncsClick
 * Objetivos   : Mostrar el formulario de construccin de rutinas
 *)
procedure TFrmEditor.MIVisualProcFuncsClick(Sender: TObject);
begin
  FrmVisualProcFuncs.ShowModal;
end;


(*
 * Funcion     : MIVisualTriggersClick
 * Objetivos   : Mostrar el formulario de creacin de disparadores
 *)
procedure TFrmEditor.MIVisualTriggersClick(Sender: TObject);
begin
  FrmVisualTriggers.ShowModal;
end;


(*
 * Funcion     : MIGestionPermisosClick
 * Objetivos   : Mostrar el formulario de gestin de permisos
 *)
procedure TFrmEditor.MIGestionPermisosClick(Sender: TObject);
begin
  FrmPermisos.ShowModal;
end;


(*
 * Funcion     : MIEstructuraBDClick
 * Objetivos   : Mostrar el formulario de estructura de la base de datos
 *)
procedure TFrmEditor.MIEstructuraBDClick(Sender: TObject);
begin
  FrmEstructuraBD.ShowModal;
end;


(*
 * Funcion     : ActArchivoExportarTXTBeforeExecute
 * Objetivos   : Inicializar
 *)
procedure TFrmEditor.ActArchivoExportarTXTBeforeExecute(Sender: TObject);
begin
  ActArchivoExportarTXT.Dialog.FileName := '';
end;


(*
 * Funcion     : LongMaxColumna
 * Objetivos   : Obtener la longitud mxima de la columa (para poder tabular
 *               bien los datos al exportar a texto).
 *               Puede que sea algo ineficiente, pero no se he encontrado
 *               otra forma de hacerlo.
 *)
function LongMaxColumna(Columna: Integer): Integer;
var
  Temp, i   : Integer;
  Str       : String;
  Ventana   : TFrmEditor;
begin
  Ventana := TFrmEditor(FrmPrincipal.ActiveMDIChild);
  Temp := Ventana.OracleDataSet.RecNo;
  Result := Length(Ventana.OracleDataSet.FieldList[Columna].FullName) + 1;
//  Ventana.OracleDataSet.FieldByName(Ventana.OracleDataSet.FieldList[Columna].FullName).
  if Ventana.OracleDataSet.FieldList[Columna].FullName = 'DEGREE' then
    ShowMessage('Ahora');
  Ventana.OracleDataSet.First;
  for i := 0 to Ventana.OracleDataSet.RecordCount do
  begin
    Str := Ventana.OracleDataSet.FieldByName(Ventana.OracleDataSet.FieldList[Columna].FullName).Text;
    if Length(Str) + 1 > Result then
      Result := Length(Str) + 1;
    Ventana.OracleDataSet.Next;
  end;
  Ventana.OracleDataSet.RecNo := Temp;
end;


(*
 * Funcion     : ActArchivoExportarTXTAccept
 * Objetivos   : Exportar a texto
 *)
procedure TFrmEditor.ActArchivoExportarTXTAccept(Sender: TObject);
var
  Stream{, Comando} : TStringStream;
  i, j, Tope      : Integer;
  Campo, Temp     : String;
begin
  if Assigned(FrmPrincipal.ActiveMDIChild) then
  begin
    with TFrmEditor(FrmPrincipal.ActiveMDIChild) do
    begin
{//      SynExporterHTML.Title := 'Fichero exportado por Medusa';
      SynExporterHTML.Highlighter  := SynEdit.Highlighter;
      SynExporterHTML.ExportAsText := true;
      SynExporterHTML.ExportAll(TFrmEditor(FrmPrincipal.ActiveMDIChild).SynEdit.Lines);}
      with ActArchivoExportarHTML.Dialog do
      begin
        if ExtractFileExt(FileName) = '' then
          FileName := FileName + '.txt';
//        SynExporterHTML.SaveToFile(FileName);
      end;
      with Stream do
      begin
        // Creamos el stream
        Stream  := TStringStream.Create('');
//        Comando := TStringStream.Create('');

        // Y lo inicializamos
//        SynExporterHTML.SaveToStream(Comando);

        // Aadimos la cabecera
        WriteString('Fichero exportado por Medusa ' + GetAppInfo(ParamStr(0), 'FileVersion') + ' Editor sql*plus++'#13#10);

        // Aadimos el usuario (slo si est conectado)
        if (OracleSession.Connected) and (OracleDataSet.Active) and
           (OracleDataSet.RecordCount > 0) then
        begin
          WriteString('Usuario      : ' + OracleSession.LogonUsername + '@' + OracleSession.LogonDatabase + #13#10);
        end;

        // Aadimos la fecha
        WriteString('Fecha y hora : ' + FormatDateTime('dddd dd/mm/yy - hh:mm:ss am/pm', now) + #13#10#13#10#13#10);

        // Aadimos la consulta
        WriteString('Consulta SQL:'#13#10);

{        Comando.Position := 86; //<html>#13#10<head>#13#10<title></title>#13#10 (33)
                                //</head>#13#10<!-- Generated by SynEdit HTML exporter#13#10 --> (54)
}
        i := 0;
        for i := 0 to SynEdit.Lines.Count - 1 do
          WriteString(SynEdit.Lines[i] + #13#10);

        // Quitamos el fin de formato HTML </body>#13#10</html>
//        Position := Position - 16;

//        WriteString('<body>'#13#10);

        if (OracleSession.Connected) and (OracleDataSet.Active) and
           (OracleDataSet.RecordCount > 0) then
        begin
          // Aadimos el nmero de tplas
          WriteString(#13#10);
          WriteString('Tuplas seleccionadas: (' + IntToStr(OracleDataSet.RecordCount) +
                      ' Tuplas en total)'#13#10#13#10);

          // y finalmente comenzamos con las tuplas
          OracleDataSet.DisableControls;
          OracleDataSet.First;
          // Escribimos el grid (i son las filas y j son las columnas)
          for i := -1 {Para el encabezado  } to OracleDataSet.RecordCount - 1 do
          begin       {Nombre de la columna}
            for j := 0 to OracleDataSet.FieldCount - 1 do
            begin
              if i = -1 then
              begin
                Campo := StringOfChar(' ', 255);
                StrCopy(PChar(Campo), PChar(OracleDataSet.FieldList[j].FullName));
                SetLength(Campo, LongMaxColumna(j));
                WriteString(Campo);
              end
              else
              begin
                Campo := StringOfChar(' ', 255);
                if OracleDataSet.FieldByName(OracleDataSet.FieldList[j].FullName).IsNull then
                  StrCopy(PChar(Campo), PChar(''))
                else begin
                  Temp := OracleDataSet.FieldByName(OracleDataSet.FieldList[j].FullName).Text;
                  Temp := Trim(Temp);
                  StrCopy(PChar(Campo), PChar(Temp));
                end;
                SetLength(Campo, LongMaxColumna(j));
                WriteString(Campo);
              end;
            end;
            WriteString(#13#10);
            OracleDataSet.Next;
          end;
          OracleDataSet.EnableControls;
          WriteString(#13#10);
        end;
        Stream.WriteString(#13#10#13#10);
        TMemoryStream(Stream).SaveToFile(ActArchivoExportarTXT.Dialog.FileName);
        Stream.Free;
//        Comando.Free;
      end;
    end;
  end;
end;


(*
 * Funcion     : ActEdicionBufferExecute
 * Objetivos   : Mostrar el formulario de gestin del buffer de textos
 *)
procedure TFrmEditor.ActEdicionBufferExecute(Sender: TObject);
begin
  FrmBuffer.ShowModal;
end;


(*
 * Funcion     : SynEditGutterClick
 * Objetivos   : Mostrar la marca o quitar la marca del gutter
 *)
procedure TFrmEditor.SynEditGutterClick(Sender: TObject;
  Button: TMouseButton; X, Y, Line: Integer; Mark: TSynEditMark);
var
  Marca : TSynEditMark;
//  Marcas: TSynEditMarks;
  i     : Integer;
begin
  with TFrmEditor(FrmPrincipal.ActiveMDIChild).SynEdit do
  begin
    BuscarMarca(MarcaOffset, i);
    if i <> -1 then           // Encontrada
    begin
      Marks.Remove(marks[i]);
    end;
{    if i = -1 then            // No encontrada
    begin}
      Marks.ClearLine(CaretY);
      Marca := TSynEditMark.Create(TFrmEditor(FrmPrincipal.ActiveMDIChild).SynEdit);
      with Marca do
      begin
        Line := CaretY;
//        Column := CaretX;
        ImageIndex := 14;
        Visible := true;
      end;
      Marks.Place(Marca);
//    end
  end;
end;


(*
 * Funcion     : MIFormatoFechasClick
 * Objetivos   : Mostrar el formulario de construccin visual de formatos de fechas
 *)
procedure TFrmEditor.MIFormatoFechasClick(Sender: TObject);
begin
  FrmFormatoFechas.ShowModal;
end;


(*
 * Funcion     : MIComentariosClick
 * Objetivos   : Mostrar el formulario de gestin de comentarios de forma visual
 *)
procedure TFrmEditor.MIComentariosClick(Sender: TObject);
begin
  FrmComentarios.ShowModal;
end;


(*
 * Funcion     : MIVisualPackagesClick
 * Objetivos   : Mostrar el formulario de construccin de paquetes
 *)
procedure TFrmEditor.MIVisualPackagesClick(Sender: TObject);
begin
  FrmVisualPackages.ShowModal;
end;


(*
 * Funcion     : MIVisualJavaClick
 * Objetivos   : Mostrar el formulario de construccin de paquetes Java
 *)
procedure TFrmEditor.MIVisualJavaClick(Sender: TObject);
begin
  FrmVisualJava.ShowModal;
end;


(*
 * Funcion     : MIAgregarFavoritosClick
 * Objetivos   : Agrega el texto al men de favoritos
 *)
procedure TFrmEditor.MIAgregarFavoritosClick(Sender: TObject);
begin
  FrmConfiguracion.SynEdit.Lines.Assign(TFrmEditor(FrmPrincipal.ActiveMDIChild).SynEdit.Lines);
  FrmConfiguracion.PageControl.ActivePage := FrmConfiguracion.TbShtFavoritos;
  FrmConfiguracion.ShowModal;
end;


(*
 * Funcion     : SynEditKeyDown
 * Objetivos   : Ver si pulsa F2 para mostrar la documentacin de Oracle
 *)
procedure TFrmEditor.SynEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_F2 then
    if FrmConfiguracion.LblDocumentacion.Caption <> 'Documentacin' then
      ShellExecute(FrmPrincipal.Handle, nil, PChar(FrmConfiguracion.LblDocumentacion.Caption), '', '', SW_SHOWNORMAL);
end;


(*
 * Funcion     : MIVisualSeqsClick
 * Objetivos   : Mostrar el formulario de construccin de secuencias
 *)
procedure TFrmEditor.MIVisualSeqsClick(Sender: TObject);
begin
  FrmVisualSeqs.ShowModal;
end;


(*
 * Funcion     : MIResaltarSQLClick
 * Objetivos   : Resaltar el documento con la sintaxis de SQL (y PL/SQL)
 *)
procedure TFrmEditor.MIResaltadoSQLClick(Sender: TObject);
begin
  if MIResaltadoSQL.Checked then
    TFrmEditor(FrmPrincipal.ActiveMDIChild).SynEdit.Highlighter := DMGlobal.SynSQLSyn
  else
    TFrmEditor(FrmPrincipal.ActiveMDIChild).SynEdit.Highlighter := nil
end;


(*
 * Funcion     : MIResaltadoJavaClick
 * Objetivos   : Mostrar el realzado sintactico de Java
 *)
procedure TFrmEditor.MIResaltadoJavaClick(Sender: TObject);
begin
  if MIResaltadoJava.Checked then
    TFrmEditor(FrmPrincipal.ActiveMDIChild).SynEdit.Highlighter := DMGlobal.SynJavaSyn
  else
    TFrmEditor(FrmPrincipal.ActiveMDIChild).SynEdit.Highlighter := nil  
end;


(*
 * Funcion     : MIVisualSynonymsClick
 * Objetivos   : Mostrar el formulario de creacin visual de sinnimos
 *)
procedure TFrmEditor.MIVisualSynonymsClick(Sender: TObject);
begin
  FrmVisualSynonyms.ShowModal;
end;


(*
 * Funcion     : MIFuenteEditorTam8Click
 * Objetivos   : Cambiar el tamao de la fuente del editor (se utiliza para
 *               todos los tamaos de fuentes).
 *)
procedure TFrmEditor.MIFuenteEditorTam8Click(Sender: TObject);
begin
  TFrmEditor(FrmPrincipal.ActiveMDIChild).SynEdit.Font.Size :=
    StrToInt(TMenuItem(Sender).Caption);
end;


(*
 * Funcion     : MIFuenteGridTam8Click
 * Objetivos   : Igual que el caso anterior, aunque en este caso es para el grid
 *)
procedure TFrmEditor.MIFuenteGridTam8Click(Sender: TObject);
begin
  TFrmEditor(FrmPrincipal.ActiveMDIChild).DBGrid.Font.Size :=
    StrToInt(TMenuItem(Sender).Caption);
end;


(*
 * Funcion     : AjustarColumnas1Click
 * Objetivos   : (actualmente no utilizado)
 *)
procedure TFrmEditor.Ajustarcolumnas1Click(Sender: TObject);
begin
//  TStringGrid(TFrmEditor(FrmPrincipal.ActiveMDIChild).DBGrid).
  TFrmEditor(FrmPrincipal.ActiveMDIChild).DBGrid.Columns.State
end;


(*
 * Funcion     : OracleSessionChange
 * Objetivos   : Ver cuando el usuario cierra la sesin para "conmutar" el modo
 *               de conexin (a partir de ahora se conecta en modo por defecto,
 *               es decir, siempre se pedir el login y el password).
 *)
procedure TFrmEditor.OracleSessionChange(Sender: TOracleSession);
begin
  if not OracleSession.Connected then
  begin
    FConectarDefecto := true;
    Self.SetTitulo;
  end;
end;


(*
 * Funcion     : MIVisualViewsClick
 * Objetivos   : Mostrar el formulario de construccin de vistas
 *)
procedure TFrmEditor.MIVisualViewsClick(Sender: TObject);
begin
  FrmVisualViews.ShowModal;
end;


(*
 * Funcion     : MIVisualTablespacesClick
 * Objetivos   : Mostrar el formulario de construccin de tablespaces
 *)
procedure TFrmEditor.MIVisualTablespacesClick(Sender: TObject);
begin
  FrmVisualTablespaces.ShowModal;
end;


(*
 * Funcion     : MIVisualProfilesClick
 * Objetivos   : Mostrar el formulario de construccin de perfiles
 *)
procedure TFrmEditor.MIVisualProfilesClick(Sender: TObject);
begin
  FrmVisualProfiles.ShowModal;
end;


(*
 * Funcion     : MIVisualUsersClick
 * Objetivos   : Mostrar el formulario de construccin de usuarios
 *)
procedure TFrmEditor.MIVisualUsersClick(Sender: TObject);
begin
  FrmVisualUsers.ShowModal;
end;


(*
 * Funcion     : MIVisualIndexes
 * Objetivos   : Mostrar el formulario de construccin de ndices
 *)
procedure TFrmEditor.MIVisualIndexesClick(Sender: TObject);
begin
  FrmVisualIndexes.ShowModal;
end;

procedure TFrmEditor.MIListaAutcompletadoClick(Sender: TObject);
var
  Editor  : TFrmEditor;
  PixXY   : TPoint;
begin
{  Self.SynEdit.ExecuteCommand();}
  Editor := TFrmEditor(FrmPrincipal.ActiveMDIChild);
  with Editor do
  begin
    PixXY := SynEdit.RowColumnToPixels(SynEdit.CaretXY);
//  Self.SynEdit.CommandProcessor(16458, ' ', nil);
  end;
//  Editor.SynEdit.ExecuteCommand(ecAutoCompletion, ' ', nil);
{  Editor.SynEdit.CommandProcessor(ecAutoCompletion, ' ', nil);}
  //Editor.SynEdit.CommandProcessor(16416 , ' ', nil);
  //Editor.SynEdit.ExecuteCommand(16416, ' ', nil);
  DMGlobal.SynCmplPrpLista.Editor := Editor.SynEdit;
  DMGlobal.SynCmplPrpLista.ActivateCompletion;
//  ShowMessage(IntToStr(DMGlobal.SynCmplPrpLista.ShortCut));
//  DMGlobal.SynCmplPrpLista.Execute('Lista de autocompletado', PixXY.X, PixXY.Y);
end;

procedure TFrmEditor.MIAutocompletadoCodigoClick(Sender: TObject);
begin
  DMGlobal.SynAutoComplete.Execute(Self.SynEdit);
end;

end.

// 3256

// 6553 (hasta aqu)
