////////////////////////////////////////////////////////////////////////////////
//
// Proyecto Medusa v3.0
//
//////////////////////////////////// INFO //////////////////////////////////////
//
//  Nombre del programa : Medusa.exe
//  Fecha               : Septiembre del 2003.
//  Componentes         : DOA 3.4.6.4, SynEdit 1.1 (CVS).
//  Version compilador  : Delphi 6.0 Enterprise.
//  Descripcin         : Un cliente avanzado de Oracle
//  Autor               : Albert Philippe De La Fuente Vigliotti.
//  Tutor               : Jos Galindo Gmez.
//
////////////////////////////////////////////////////////////////////////////////

unit UEstructuraBD;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Oracle;

type
  TFrmEstructuraBD = class(TForm)
    LstBxTablas: TListBox;
    CmBxTablas: TComboBox;
    LblTablas: TLabel;
    OracleQry: TOracleQuery;
    OracleSession: TOracleSession;
    ChkBxInclRef: TCheckBox;
    OracleQryCampos: TOracleQuery;
    BitBtnAgregar: TBitBtn;
    BitBtnOk: TBitBtn;
    BitBtnCancelar: TBitBtn;
    procedure FormActivate(Sender: TObject);
    procedure LstBxTablasKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BitBtnAgregarClick(Sender: TObject);
    procedure BitBtnOkClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmEstructuraBD: TFrmEstructuraBD;

implementation

uses UDMGlobal, UPrincipal, UConfiguracion, UEditor,
     UReconstruirCreateTable, UGlobal;

{$R *.dfm}

procedure TFrmEstructuraBD.LstBxTablasKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if Key = VK_DELETE then
    LstBxTablas.DeleteSelected;
end;

procedure TFrmEstructuraBD.FormActivate(Sender: TObject);
var
  Sesion  : TOracleSession;
begin
  try
    CargarEstadoForm(Self);   // Esto es por si se ejecuta desde CD...
  except
  end;
  LstBxTablas.Clear;
  CmBxTablas.Clear;

  Cursor := crSQLWait;

  with OracleQry, OracleQry.SQL do
  begin
    Close;
    Clear;
    DeleteVariables;

    Sesion := TFrmEditor(FrmPrincipal.ActiveMDIChild).OracleSession;
{    if Sesion.Connected then
    begin}
      OracleQry.Session       := Sesion;
      OracleQryCampos.Session := Sesion;
{    end
    else
      if not OracleSession.Connected then
      begin
        DMGlobal.OracleLogon.Session := OracleSession;
        DMGlobal.OracleLogon.Execute;
//        OracleQryCampos.Session := OracleSession;
      end;}

    // CARGAMOS EL COMBO BOX CON LOS OBJETOS
    Clear;
    Add('SELECT Table_Name');
    Add('FROM ALL_TABLES');
    Execute;
    while not Eof do
    begin
      CmBxTablas.Items.Add(Field('Table_Name'));
      Next;
    end;
    Close;
  end;
  Cursor := crNone;
end;

procedure TFrmEstructuraBD.BitBtnAgregarClick(Sender: TObject);
begin
  LstBxTablas.Items.Add(CmBxTablas.Text);
end;

procedure TFrmEstructuraBD.BitBtnOkClick(Sender: TObject);
var
  Ventana : TFrmEditor;
  i, k, Long, Indice, Maximo2, NumAtrib, Base, Tuplas   : Integer;
  Str, Tabla, NombreRestriccion, RestriccionRef : String;
  Maximo  : Integer;
begin
  with OracleQry do
  begin
    Session := TFrmEditor(FrmPrincipal.ActiveMDIChild).OracleSession;
    OracleQryCampos.Session := TFrmEditor(FrmPrincipal.ActiveMDIChild).OracleSession;
        
    // Limpiamos y definimos las variables
    DeleteVariables;
    DeclareVariable(':TABLA', otString);
    DeclareVariable(':EXISTE', otInteger);

    Ventana := TFrmEditor.Create(nil);

    Ventana.SynEdit.Lines.Add('Fichero generado automticamente por Medusa');
    Ventana.SynEdit.Lines.Add('');

    k := 0;
    while k <= LstBxTablas.Count - 1 do
    begin
      DeleteVariables;
      DeclareVariable(':TABLA', otString);
      DeclareVariable(':EXISTE', otInteger);

      Tabla := LstBxTablas.Items[k];
      // Cerramos (por seguridad)
      Close;
      SQL.Clear;
      SQL.Add('BEGIN');
      SQL.Add('  SELECT COUNT(*)');
      SQL.Add('  INTO :EXISTE');
      SQL.Add('  FROM USER_TABLES');
      SQL.Add('  WHERE UPPER(TABLE_NAME) = UPPER(:TABLA);');
      SQL.Add('END;');
      SetVariable(':TABLA', Tabla);
      Execute;
      Close;
      if GetVariable(':EXISTE') <> '1' then
      begin
        Ventana.SynEdit.Lines.Add('La tabla "' + Tabla + '" no existe');
      end
      else begin                            // EXISTE LA TABLA -> LA RECONSTRUIMOS
        Cursor                := crSQLWait;
        BitBtnAgregar.Cursor  := crSQLWait;
        CmBxTablas.Cursor     := crSQLWait;
        LstBxTablas.Cursor    := crSQLWait;
        FrmPrincipal.Cursor   := crSQLWait;
        BitBtnOk.Cursor       := crSQLWait;

        DeleteVariables;
        DeclareVariable(':TABLA', otString);
        Ventana.SynEdit.Lines.Add(Tabla + ':');
        Ventana.SynEdit.Lines.Add(StringOfChar('-', Length(Tabla + ':')));


////////////////////////////////////////////////////////////////////////////////
// C O L U M N A S    ( N O M B R E S )
////////////////////////////////////////////////////////////////////////////////

        Close;
        SQL.Clear;
        // OBTENEMOS LAS COLUMNAS QUE *SON* CLAVES PRIMARIAS
        SQL.Add('SELECT Enlace.COLUMN_NAME');
        SQL.Add('FROM USER_CONS_COLUMNS Enlace, USER_CONSTRAINTS Restriccion');
        SQL.Add('WHERE (UPPER(Restriccion.TABLE_NAME) = UPPER(:TABLA))');
        SQL.Add('  AND (Enlace.TABLE_NAME = Restriccion.TABLE_NAME)');
        SQL.Add('  AND (Enlace.CONSTRAINT_NAME = Restriccion.CONSTRAINT_NAME)');
        SQL.Add('  AND (CONSTRAINT_TYPE = ''P'')');

//        DeclareVariable(':TABLA', otString);
        SetVariable(':TABLA', Tabla);
        Execute;

        while not Eof do
        begin
          Ventana.SynEdit.Lines.Add('*' + Field('COLUMN_NAME'));
          Next;
        end;

        Close;
        SQL.Clear;
        // OBTENEMOS LAS COLUMNAS QUE *NO* SON REFERENCIAS *NI* CLAVES PRIMARIAS
        SQL.Add('SELECT COLUMN_NAME');
        SQL.Add('FROM USER_TAB_COLUMNS');
        SQL.Add('WHERE UPPER(TABLE_NAME) = UPPER(:TABLA)');
        SQL.Add('MINUS');
        SQL.Add('SELECT Enlace.COLUMN_NAME');
        SQL.Add('FROM USER_CONS_COLUMNS Enlace, USER_CONSTRAINTS Restriccion');
        SQL.Add('WHERE (UPPER(Restriccion.TABLE_NAME) = UPPER(:TABLA))');
        SQL.Add('  AND (Enlace.TABLE_NAME = Restriccion.TABLE_NAME)');
        SQL.Add('  AND (Enlace.CONSTRAINT_NAME = Restriccion.CONSTRAINT_NAME)');
        SQL.Add('  AND ((CONSTRAINT_TYPE = ''R'') OR (CONSTRAINT_TYPE = ''P''))');

//        DeclareVariable(':TABLA', otString);
        SetVariable(':TABLA', Tabla);
        Execute;

//        Indice := Ventana.SynEdit.Lines.Count - 1;
        while not Eof do
        begin
          Ventana.SynEdit.Lines.Add(' ' + Field('COLUMN_NAME'));
          Next;
        end;


////////////////////////////////////////////////////////////////////////////////
// R E S T R I C C I O N E S
////////////////////////////////////////////////////////////////////////////////

        // OBTENEMOS LAS COLUMNAS QUE *SI* SON REFERENCIAS
        Close;
        SQL.Clear;
{        SQL.Add('SELECT COLUMN_NAME');
        SQL.Add('FROM USER_TAB_COLUMNS');
        SQL.Add('WHERE UPPER(TABLE_NAME) = UPPER(:TABLA)');
        SQL.Add('INTERSECT');
        SQL.Add('SELECT Enlace.COLUMN_NAME');
        SQL.Add('FROM USER_CONS_COLUMNS Enlace, USER_CONSTRAINTS Restriccion');
        SQL.Add('WHERE (UPPER(Restriccion.TABLE_NAME) = UPPER(:TABLA))');
        SQL.Add('  AND (Enlace.TABLE_NAME = Restriccion.TABLE_NAME)');
        SQL.Add('  AND (Enlace.CONSTRAINT_NAME = Restriccion.CONSTRAINT_NAME)');
        SQL.Add('  AND (CONSTRAINT_TYPE = ''R'')');}

        // LA CONSULTA!!!
        SQL.Add('SELECT C.R_CONSTRAINT_NAME, C.CONSTRAINT_NAME, RC.COLUMN_NAME');
        SQL.Add('FROM USER_CONS_COLUMNS RC, USER_CONSTRAINTS C');
        SQL.Add('WHERE (RC.CONSTRAINT_NAME = C.CONSTRAINT_NAME)');
        SQL.Add('  AND (RC.TABLE_NAME = UPPER(:TABLA))');
        SQL.Add('  AND (RC.TABLE_NAME = C.TABLE_NAME)');
        SQL.Add('  AND (C.R_CONSTRAINT_NAME IS NOT NULL)');
        SQL.Add('  AND (RC.COLUMN_NAME IN');
        SQL.Add('       (');
        SQL.Add('       SELECT COLUMN_NAME');
        SQL.Add('       FROM USER_TAB_COLUMNS');
        SQL.Add('       WHERE UPPER(TABLE_NAME) = UPPER(:TABLA)');
        SQL.Add('       INTERSECT');
        SQL.Add('       SELECT Enlace.COLUMN_NAME');
        SQL.Add('       FROM USER_CONS_COLUMNS Enlace, USER_CONSTRAINTS Restriccion');
        SQL.Add('       WHERE (UPPER(Restriccion.TABLE_NAME) = UPPER(:TABLA))');
        SQL.Add('         AND (Enlace.TABLE_NAME = Restriccion.TABLE_NAME)');
        SQL.Add('         AND (Enlace.CONSTRAINT_NAME = Restriccion.CONSTRAINT_NAME)');
        SQL.Add('         AND (CONSTRAINT_TYPE = ''R'')');
        SQL.Add('       )');
        SQL.Add('      )');
        SQL.Add('GROUP BY C.R_CONSTRAINT_NAME, C.CONSTRAINT_NAME, RC.COLUMN_NAME');
        Execute;

        Tuplas := 0;
        Maximo := 1; // La utilizo para poner la coma (para no declarar otra variable ms...)
        OracleQryCampos.DeleteVariables;
        OracleQryCampos.DeclareVariable(':RESTRICCION', otString);
        
        // Agrego los nombres de las columnas, separados por comas
        while not Eof do
        begin
          i := 1;
          Ventana.SynEdit.Lines.Add('');
          NombreRestriccion := Field('CONSTRAINT_NAME');
          RestriccionRef := OracleQry.Field('R_CONSTRAINT_NAME');
          while (not Eof) and (NombreRestriccion = Field('CONSTRAINT_NAME')) do
          begin
            if i = 1 then
              Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1] := ' ' + Field('COLUMN_NAME')
            else
              Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1] :=
                Format('%s, %s', [Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1],
                                  Field('COLUMN_NAME')]);
            Next;
            inc(i);
          end;

          Tuplas := Tuplas + i - 1;
          // Todo esto para dejar el cursor donde estaba
          OracleQry.Execute;
          for i := 1 to Tuplas - 1 do
            OracleQry.Next;

          i := 1;
          with OracleQryCampos do
          begin
            // TABLA DE REFERENCIA
            Close;
            OracleQryCampos.DeleteVariables;
            OracleQryCampos.DeclareVariable(':RESTRICCION', otString);
            SQL.Clear;
            SQL.Add('SELECT TABLE_NAME');
            SQL.Add('FROM USER_CONSTRAINTS');
            SQL.Add('WHERE CONSTRAINT_NAME = :RESTRICCION');
            SetVariable(':RESTRICCION', RestriccionRef);
//            SetVariable(':RESTRICCION', OracleQry.Field('CONSTRAINT_NAME'));
            Execute;
{            Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1] :=
              Format('%s ---> %s', [Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1],
                                          Field('TABLE_NAME')]);}
            Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1] :=
              Format('%s ---> %s', [Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1],
                                      Field('TABLE_NAME')]);

            // Si debo incluir las referencias, se incluyen (si no estn ya
            // en la lista, puesto que sino, se puede quedar colgado el
            // algoritmo
            if ChkBxInclRef.Checked then
              if LstBxTablas.Items.IndexOf(Field('TABLE_NAME')) = -1 then
                LstBxTablas.Items.Add(Field('TABLE_NAME'));


            // ATRIBUTOS A LOS QUE SE HACE REFERENCIA
            Close;
            OracleQryCampos.DeleteVariables;
            OracleQryCampos.DeclareVariable(':RESTRICCION', otString);
            SQL.Clear;
            SQL.Add('SELECT COLUMN_NAME');
            SQL.Add('FROM USER_CONS_COLUMNS');
            SQL.Add('WHERE CONSTRAINT_NAME = :RESTRICCION');
            SQL.Add('ORDER BY POSITION');
            SetVariable(':RESTRICCION', RestriccionRef {OracleQry.Field('R_CONSTRAINT_NAME')});
//            SetVariable(':RESTRICCION', OracleQry.Field('CONSTRAINT_NAME'));
            Execute;
            i := 1;
            while not Eof do
            begin
              if i = 1 then
                Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1] :=
                  Format('%s(%s', [Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1],
                                    Field('COLUMN_NAME')])
              else
                Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1] :=
                  Format('%s ,%s', [Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1],
                                    Field('COLUMN_NAME')]);
              Next;
              inc(i);
            end;
            Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1] :=
              Format('%s)', [Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1]]);
//            Ventana.SynEdit.Lines.Add('');
          end; (* WITH *)
          Next;
        end; (* WHILE, aunque parezca mentira ;-) *)
        Ventana.SynEdit.Lines.Add('');
        Ventana.SynEdit.Lines.Add('');

      // Ahora, a la ltima lnea, le quitamos la coma
{      Str := Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1];
      SetLength(Str, Length(Str) - 1);
      Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1] := Str;
}
      // Y cerramos la sentencia CREATE TABLE
//      Ventana.SynEdit.Lines.Add(');');
      end;
      inc(k);
    end;
  end;
  
  Cursor                := crNone;
  BitBtnAgregar.Cursor  := crNone;
  CmBxTablas.Cursor     := crNone;
  LstBxTablas.Cursor    := crNone;
  FrmPrincipal.Cursor   := crNone;
  BitBtnOk.Cursor       := crNone;

  Close;
end;

procedure TFrmEstructuraBD.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
    GuardarEstadoForm(Self);
  except
  end;  
end;

end.

// 379
