////////////////////////////////////////////////////////////////////////////////
//
// Proyecto Medusa v3.0
//
//////////////////////////////////// INFO //////////////////////////////////////
//
//  Nombre del programa : Medusa.exe
//  Fecha               : Septiembre del 2003.
//  Componentes         : DOA 3.4.6.4, SynEdit 1.1 (CVS).
//  Version compilador  : Delphi 6.0 Enterprise.
//  Descripcin         : Un cliente avanzado de Oracle
//  Autor               : Albert Philippe De La Fuente Vigliotti.
//  Tutor               : Jos Galindo Gmez.
//
////////////////////////////////////////////////////////////////////////////////

unit UInformacion;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Oracle, DB, DBCtrls, OracleData, Grids, DBGrids;

type
  TFrmInformacion = class(TForm)
    Label1: TLabel;
    OracleDSVersion: TOracleDataSet;
    DBTxtVersion: TDBText;
    DSVersion: TDataSource;
    OracleDSRoles: TOracleDataSet;
    DSRoles: TDataSource;
    OracleDSInfoUsuario: TOracleDataSet;
    DSInfoUsuario: TDataSource;
    GroupBox1: TGroupBox;
    LblUsuario: TLabel;
    Label3: TLabel;
    LblId: TLabel;
    Label4: TLabel;
    LblTablespaceDef: TLabel;
    Label5: TLabel;
    LblTablespaceTemp: TLabel;
    Label6: TLabel;
    Label2: TLabel;
    LblCreado: TLabel;
    OracleDSSesion: TOracleDataSet;
    DSSesion: TDataSource;
    GrpBxRoles: TGroupBox;
    DBGrdRoles: TDBGrid;
    OracleDSPrivilegios: TOracleDataSet;
    DSPrivilegios: TDataSource;
    GrpBxPrivilegios: TGroupBox;
    DBGrdPrivilegios: TDBGrid;
    DBTxtIdSesion: TDBText;
    Label8: TLabel;
    OracleDSLimitaciones: TOracleDataSet;
    DSLimitaciones: TDataSource;
    GrpBxLimitaciones: TGroupBox;
    DBGrdLimitaciones: TDBGrid;
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmInformacion: TFrmInformacion;

implementation

uses UPrincipal, UEditor, UGlobal;

{$R *.dfm}

procedure TFrmInformacion.FormActivate(Sender: TObject);
begin
  try
    CargarEstadoForm(Self);   // Esto es por si se ejecuta desde CD...
  except
  end;
  if not Assigned(FrmPrincipal.ActiveMDIChild) then
    Exit
  else begin

    with OracleDSVersion do
    begin
      Session := TFrmEditor(FrmPrincipal.ActiveMDIChild).OracleSession;
      DBTxtVersion.DataField := 'VERSION';
      Close;
      Open;
    end;

    with OracleDSInfoUsuario do
    begin
      Session := TFrmEditor(FrmPrincipal.ActiveMDIChild).OracleSession;
      Close;
      Open;
      LblUsuario.Caption := GetVariable(':USUARIO');
      LblId.Caption := GetVariable(':ID_USUARIO');
      LblTablespaceDef.Caption := GetVariable(':TABLESPACE_DEF');
      LblTablespaceTemp.Caption := GetVariable(':TABLESPACE_TEMP');
      LblCreado.Caption := GetVariable(':CREADO');
    end;

    with OracleDSSesion do
    begin
      Session := TFrmEditor(FrmPrincipal.ActiveMDIChild).OracleSession;
      Close;
      Open;
      DBTxtIdSesion.DataField := 'ID_SESION';
    end;

    with OracleDSRoles do
    begin
      Session := TFrmEditor(FrmPrincipal.ActiveMDIChild).OracleSession;
      Close;
      Open;
      GrpBxRoles.Caption := 'Roles ( ' + IntToStr(RecordCount) + ' )'
    end;

    with OracleDSPrivilegios do
    begin
      Session := TFrmEditor(FrmPrincipal.ActiveMDIChild).OracleSession;
      Close;
      Open;
      GrpBxPrivilegios.Caption := 'Privilegios de sesion ( ' + IntToStr(RecordCount) + ' )'
    end;

    with OracleDSLimitaciones do
    begin
      Session := TFrmEditor(FrmPrincipal.ActiveMDIChild).OracleSession;
      Close;
      Open;
      GrpBxLimitaciones.Caption := 'Limitaciones ( ' + IntToStr(RecordCount) + ' )'
    end;
  end;
end;

procedure TFrmInformacion.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
    GuardarEstadoForm(Self);
  except
  end;  
{  OracleDSVersion.Close;
  OracleDSSesion.Close;
  OracleDSInfoUsuario.Close;
  OracleDSRoles.Close;
  OracleDSLimitaciones.Close;
  OracleDSPrivilegios.Close;}
end;

end.

// 158
