////////////////////////////////////////////////////////////////////////////////
//
// Proyecto Medusa v3.0
//
//////////////////////////////////// INFO //////////////////////////////////////
//
//  Nombre del programa : Medusa.exe
//  Fecha               : Septiembre del 2003.
//  Componentes         : DOA 3.4.6.4, SynEdit 1.1 (CVS).
//  Version compilador  : Delphi 6.0 Enterprise.
//  Descripcin         : Un cliente avanzado de Oracle
//  Autor               : Albert Philippe De La Fuente Vigliotti.
//  Tutor               : Jos Galindo Gmez.
//
////////////////////////////////////////////////////////////////////////////////

unit UPreview;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, SynEditPrintPreview, SynEditPrint, ActnList, ImgList, ComCtrls,
  ToolWin, Menus, SynEditHighlighter, SynHighlighterSQL;

type
  TFrmPreview = class(TForm)
    SynEditPrintPreview: TSynEditPrintPreview;
    SynEditPrint: TSynEditPrint;
    ToolBar1: TToolBar;
    TlBrPrimeraPag: TToolButton;
    TlBrPagAnt: TToolButton;
    TlBrPagSig: TToolButton;
    TlBrUltimaPag: TToolButton;
    ToolButton1: TToolButton;
    ToolButton3: TToolButton;
    ToolButton5: TToolButton;
    TlBrImprimir: TToolButton;
    ToolButton4: TToolButton;
    TlBtnSalir: TToolButton;
    ImageList: TImageList;
    ActionList1: TActionList;
    ActPrimeraPagina: TAction;
    ActPaginaAnterior: TAction;
    ActPaginaSiguiente: TAction;
    ActUltimaPagina: TAction;
    ActZoom: TAction;
    ActImprimir: TAction;
    ActSalir: TAction;
    PopupMenu1: TPopupMenu;
    MIPagCompleta: TMenuItem;
    MIAjustarPag: TMenuItem;
    N1: TMenuItem;
    MI25: TMenuItem;
    MI50: TMenuItem;
    MI100: TMenuItem;
    MI200: TMenuItem;
    MI400: TMenuItem;
    PrinterSetupDialog: TPrinterSetupDialog;
    PrintDialog: TPrintDialog;
    procedure MIPagCompletaClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SynEditPrintPreviewMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ActPrimeraPaginaExecute(Sender: TObject);
    procedure ActPaginaAnteriorExecute(Sender: TObject);
    procedure ActPaginaSiguienteExecute(Sender: TObject);
    procedure ActUltimaPaginaExecute(Sender: TObject);
    procedure ActZoomExecute(Sender: TObject);
    procedure ActImprimirExecute(Sender: TObject);
    procedure ActSalirExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmPreview: TFrmPreview;

implementation

{$R *.dfm}

uses IniFiles, UPrincipal, UGlobal;

procedure TFrmPreview.FormActivate(Sender: TObject);
begin
  try
    CargarEstadoForm(Self);
  except
  end;
end;

procedure TFrmPreview.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  try                         // Nota: Esto lo pongo por si estamos en NT, donde
    GuardarEstadoForm(Self);  // hay que tener permisos para escribir en ficheros
  except                      // y pues si no los tengo, por lo menos sigo
    CanClose := true;         // con normalidad, sin que el usuario lo note.
  end;
end;

procedure TFrmPreview.FormShow(Sender: TObject);
begin
  SynEditPrintPreview.UpdatePreview;
  SynEditPrintPreview.FirstPage;
end;

procedure TFrmPreview.MIPagCompletaClick(Sender: TObject);
begin
  case (Sender as TMenuItem).Tag of
    -1: SynEditPrintPreview.ScaleMode := pscWholePage;
    -2: SynEditPrintPreview.ScaleMode := pscPageWidth;
  else
    SynEditPrintPreview.ScalePercent := (Sender as TMenuItem).Tag;
  end;
end;

procedure TFrmPreview.SynEditPrintPreviewMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  FScale: Integer;
begin
  FScale := SynEditPrintPreview.ScalePercent;
  if Button = mbLeft then begin
    if SynEditPrintPreview.ScaleMode = pscWholePage then
      SynEditPrintPreview.ScalePercent := 100
    else begin
      FScale := FScale * 2;
      if FScale > 400 then
        FScale := 400;
      SynEditPrintPreview.ScalePercent := FScale;
    end;
  end
  else begin
    FScale := FScale div 2;
    if FScale < 25 then
      FScale := 25;
    SynEditPrintPreview.ScalePercent := FScale;
  end;
end;

procedure TFrmPreview.ActPrimeraPaginaExecute(Sender: TObject);
begin
  SynEditPrintPreview.FirstPage;
end;

procedure TFrmPreview.ActPaginaAnteriorExecute(Sender: TObject);
begin
  SynEditPrintPreview.PreviousPage;
end;

procedure TFrmPreview.ActPaginaSiguienteExecute(Sender: TObject);
begin
  SynEditPrintPreview.NextPage;
end;

procedure TFrmPreview.ActUltimaPaginaExecute(Sender: TObject);
begin
  SynEditPrintPreview.LastPage;
end;

procedure TFrmPreview.ActZoomExecute(Sender: TObject);
begin
  SynEditPrintPreview.ScaleMode := pscWholePage;
end;

procedure TFrmPreview.ActImprimirExecute(Sender: TObject);
begin
  with PrintDialog do
  begin
    PrintDialog.MinPage   := 1;
    PrintDialog.FromPage  := 1;
    MaxPage               := SynEditPrint.PageCount;
    ToPage                := MaxPage;
    if Execute then
    begin
      SynEditPrint.Copies := Copies;
      case PrintRange of
        prAllPages: SynEditPrint.Print;
        prPageNums: SynEditPrint.PrintRange(FromPage, ToPage);
      end;
    end;
  end;
end;

procedure TFrmPreview.ActSalirExecute(Sender: TObject);
begin
  Close;
end;



end.

// 200
