////////////////////////////////////////////////////////////////////////////////
//
// Proyecto Medusa v3.0
//
//////////////////////////////////// INFO //////////////////////////////////////
//
//  Nombre del programa : Medusa.exe
//  Fecha               : Septiembre del 2003.
//  Componentes         : DOA 3.4.6.4, SynEdit 1.1 (CVS).
//  Version compilador  : Delphi 6.0 Enterprise.
//  Descripcin         : Un cliente avanzado de Oracle
//  Autor               : Albert Philippe De La Fuente Vigliotti.
//  Tutor               : Jos Galindo Gmez.
//
////////////////////////////////////////////////////////////////////////////////

//{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q-,S-,T-,U-,V+,W-,X+,Y+,Z1}
//{$MINSTACKSIZE $00004000}
//{$MAXSTACKSIZE $00100000}
//{$IMAGEBASE $00400000}
//{$APPTYPE GUI}
unit UPrincipal;

// DONE: Hacer un entorno tipo "workbook" (interfaz MDI)
// DONE: Implementacin de dilogos de bsqueda y reemplazo de texto en el documento actual.
// DONE: Implementar una lista configurable con los programas favoritos de usuario.
// DONE: Aadir la lista de ficheros LRU.
// DONE: Implementar motor de auto completado.

// TODO: Incorporar tabla de traduccin de errores.
// TODO: Navegador de ayuda (en formato HTML, de forma que se pueda mantener, aadir enlaces interesantes relacionados con la asignatura).
// TODO: Mejorar el interfaz de configuracin, complementndolo con mas opciones.
// TODO: Posibilidad de trabajo en red.
// DONE: Tener en cuenta la sesin
// TODO: Guardar el ltimo directorio
// DONE: marcar error de consultas
// DONE: quitar bien los saltos de lnea en la consulta

interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ComCtrls,
  StdCtrls, ExtCtrls, Menus, ToolWin, StdActns, ActnList, ImgList,
  SynEdit, SynEditHighlighter, SynHighlighterSQL, SynEditExport, SynExportHTML,
  AppEvnts, DB, OracleData, Oracle, Grids, DBGrids;

type
  TFrmPrincipal = class(TForm)
    MainMenu1: TMainMenu;
    MIArchivo: TMenuItem;
    MINuevo: TMenuItem;
    MIMRU: TMenuItem;
    Ver1: TMenuItem;
    Herramientas1: TMenuItem;
    Opciones1: TMenuItem;
    Ayuda1: TMenuItem;
    Acercade1: TMenuItem;
    ImgLstBarra1: TImageList;
    MIMostrarBarraEditor: TMenuItem;
    N6: TMenuItem;
    MIMostrarGutter: TMenuItem;
    StatusBar: TStatusBar;
    ActionList1: TActionList;
    ActArchivoNuevo: TAction;
    ActArchivoAbrir: TFileOpen;
    ActArchivoSalir: TFileExit;
    MISalir: TMenuItem;
    ImgLstBarra2: TImageList;
    A1: TMenuItem;
    MIAyuda: TMenuItem;
    ActDialogoConfiguracion: TAction;
    MIMostrarBarraOracle: TMenuItem;
    ActArchivoConfigurarImpresora: TAction;
    PpMnuMRU: TPopupMenu;
    N12: TMenuItem;
    MIProgramaFavorito1: TMenuItem;
    MIProgramaFavorito2: TMenuItem;
    MIProgramaFavorito3: TMenuItem;
    MIProgramaFavorito4: TMenuItem;
    MIProgramaFavorito5: TMenuItem;
    PageControl1: TPageControl;
    N1: TMenuItem;
    N2: TMenuItem;
    Configurarimpresora1: TMenuItem;
    ApplicationEvents1: TApplicationEvents;
    ClBrBarraHerramientas: TCoolBar;
    TlBrEditor: TToolBar;
    TlBtnNuevo: TToolButton;
    TlBtnAbrir: TToolButton;
    TlBtnGuardar: TToolButton;
    ToolButton6: TToolButton;
    TlBtnExportarHTML: TToolButton;
    TlBtnPrevisualizar: TToolButton;
    ToolButton9: TToolButton;
    TlBtnDeshacer: TToolButton;
    TlBtnRehacer: TToolButton;
    ToolButton13: TToolButton;
    TlBtnCortar: TToolButton;
    TlBtnCopiar: TToolButton;
    TlBtnPegar: TToolButton;
    ToolButton20: TToolButton;
    TlBtnBuscar: TToolButton;
    TlBtnReemplazar: TToolButton;
    ToolButton25: TToolButton;
    TlBtnConfigurar: TToolButton;
    ToolButton28: TToolButton;
    TlBtnAyuda: TToolButton;
    TlBrOracle: TToolBar;
    TlBtnConectarDesconectar: TToolButton;
    ToolButton31: TToolButton;
    TlBtnEjecutar: TToolButton;
    TlBtnBuscarSiguiente: TToolButton;
    TlBtnBuscarAnterior: TToolButton;
    MIAbrir: TMenuItem;
    N3: TMenuItem;
    PpMnuEditor: TPopupMenu;
    asdf2: TMenuItem;
    Previsualizar1: TMenuItem;
    Cerrar1: TMenuItem;
    VerestadodelBuffer1: TMenuItem;
    ActVentanaMaximizarTodo1: TMenuItem;
    Siguiente1: TMenuItem;
    Anterior1: TMenuItem;
    Ejecutarconsulta1: TMenuItem;
    Ejecutarscript1: TMenuItem;
    N4: TMenuItem;
    MIFavoritos: TMenuItem;
    TmrHora: TTimer;
    MIAyudaOracle: TMenuItem;
    TlBtnAyudaOracle: TToolButton;
    MIContenidoAyuda: TMenuItem;
    MIMostrarBarraEstado: TMenuItem;
    procedure ActArchivoAbrirAccept(Sender: TObject);
    procedure ActArchivoNuevoExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ActArchivoAbrirBeforeExecute(Sender: TObject);
    procedure DBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure ApplicationEvents1Exception(Sender: TObject; E: Exception);
    procedure ActDialogoConfiguracionExecute(Sender: TObject);
    procedure MIMostrarBarraEditorClick(Sender: TObject);
    procedure MIMostrarBarraOracleClick(Sender: TObject);
    procedure Acercade1Click(Sender: TObject);
    procedure MIMostrarGutterClick(Sender: TObject);
    procedure ActArchivoConfigurarImpresoraExecute(Sender: TObject);
    procedure MIProgramaFavorito1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ApplicationEvents1Hint(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TmrHoraTimer(Sender: TObject);
    procedure MIAyudaOracleClick(Sender: TObject);
    procedure MIAyudaClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MIContenidoAyudaClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure MIMostrarBarraEstadoClick(Sender: TObject);
  private
    { Private declarations }
(*    Estado      : string;
    Titulo      : string;*)

{    procedure LimpiarMarca(Tipo: Integer);
    function  BuscarMarca(Marca : Integer; var IdMarca: Integer): Integer;
    procedure MarcarError(Linea: Integer);}
  public
    { Public declarations }
    NumVentanas : Integer;
    MRUMax : Integer;
    MRUList : TStringList;
    procedure CargarConfiguracion;
    procedure GuardarConfiguracion;
    procedure AplicarConfiguracion;
    procedure BuildMRU(var ioMenuItem : TMenuItem);
    procedure UpdateMRU(var ioMenuItem : TMenuItem; iFileName : string);
    procedure RecentFileClick(Sender: TObject);
  end;

var
  FrmPrincipal: TFrmPrincipal;
  Fila        : Integer = 1;    // Variable global para dibujar
                                // las columnas de la consulta de colores
  NumExcep    : Integer = 0;


implementation

{$R *.dfm}

uses SynEditPrintHeaderFooter, SynEditPrintTypes, IniFiles, OracleLogon,
     UEditor, UPreview, UConfiguracion, UGlobal, UAbout, ShellApi;


////////////////////////////////////////////////////////////////////////////////
// ESTADO DEL FORMULARIO PRINCIPAL                                           //
//////////////////////////////////////////////////////////////////////////////

// Carga la configuracin del formulario principal.
procedure TFrmPrincipal.CargarConfiguracion;
var
  Ini : TIniFile;
begin
  try
    Ini := TIniFile.Create(ExtractFilePath(ParamStr(0)) + '\' + FichConfig);
//    SynEdit.Height  := Ini.ReadInteger('FrmPrincipal', 'Splitter', 312);
    MIMostrarGutter.Checked := Ini.ReadBool('FrmPrincipal', 'MostrarGutter?', true);
    MIMostrarBarraEditor.Checked := Ini.ReadBool('FrmPrincipal', 'TlBrEditor?', true);
    MIMostrarBarraOracle.Checked := Ini.ReadBool('FrmPrincipal', 'TlBrOracle?', true);
    MRUmax := Ini.ReadInteger('MRU', 'MaxFiles', 15);
    // Read the list of MRU docs and add them to the menu and the drop down menu
    Ini.ReadSectionValues('MRU', MRUList);
    BuildMRU(MIMRU);
  finally
    Ini.Free;
  end;
end;

// Guarda la configuracin del formulario principal.
procedure TFrmPrincipal.GuardarConfiguracion;
var
  Ini : TIniFile;
  i   : Integer;
begin
  try
    Ini := TIniFile.Create(ExtractFilePath(ParamStr(0)) + '\' + FichConfig);
//    Ini.WriteInteger('FrmPrincipal', 'Splitter', SynEdit.Height);
    Ini.WriteBool('FrmPrincipal', 'MostrarGutter?', MIMostrarGutter.Checked);
    Ini.WriteBool('FrmPrincipal', 'TlBrEditor?', MIMostrarBarraEditor.Checked);
    Ini.WriteBool('FrmPrincipal', 'TlBrOracle?', MIMostrarBarraOracle.Checked);
    i := 0;
    while (MRUList.Count >= 1) and  (i < MRUmax) do
    begin
      Ini.WriteString('MRU', IntToStr(i), MRUList.Values[IntToStr(i)]);
      inc(i);
      MRUList.Delete(0);
    end;
    MRUList.Free;
  finally
    Ini.Free;
  end;
end;

// Aplica la configuracin en el formulario principal.
procedure TFrmPrincipal.AplicarConfiguracion;
begin
//  with ActiveMDIChild as TFrmEditor do
//    SynEdit.Gutter.Visible  := MIMostrarGutter.Checked;
  TlBrEditor.Visible      := MIMostrarBarraEditor.Checked;
//  TlBrOracle.Visible      := MIMostrarBarraOracle.Checked;
end;


////////////////////////////////////////////////////////////////////////////////
// INTERACCION CON DIALOGOS Y ACCIONES CON FICHEROS                          //
//////////////////////////////////////////////////////////////////////////////

procedure TFrmPrincipal.ActArchivoAbrirBeforeExecute(Sender: TObject);
begin
  if ActArchivoAbrir.Dialog.FileName <> '' then    // Si es la primera vez
  begin                                            // que entro, entonces...
    ActArchivoAbrir.Dialog.InitialDir := GetCurrentDir;
    ActArchivoAbrir.Dialog.FileName   := '';
  end;
end;

procedure TFrmPrincipal.ActArchivoAbrirAccept(Sender: TObject);
begin
  if ActArchivoAbrir.Dialog.FileName <> '' then
  begin
    with TFrmEditor.Create(nil) do
      AbrirFichero(ActArchivoAbrir.Dialog.FileName);
  end;
end;

procedure TFrmPrincipal.ActArchivoNuevoExecute(Sender: TObject);
begin
  with TFrmEditor.Create(nil) do
    ActualizarEstadoMDI(true);
//    HabilitarToolBarMDI(true);
  
{
//  FrmEditor.HabilitarToolBarMDI(true);
  with TFrmEditor.Create(Application) do
  begin
        ActArchivoGuardar.Enabled := false;
      FFichero := SNuevo;
//      SetCaption(FFichero);
      SynEdit.Lines.Clear;
      SynEdit.Modified := false;
//      SetModified(False);
  end;
}
end;


////////////////////////////////////////////////////////////////////////////////
// INTERACCION CON ORACLE                                                    //
//////////////////////////////////////////////////////////////////////////////

procedure prueba(DataSet: TDataSet; E: EDatabaseError; var Action: TDataAction);
begin
  with FrmPrincipal.ActiveMDIChild as TFrmEditor do
    RchEdtMensajes.Lines.Add(E.Message)
end;


////////////////////////////////////////////////////////////////////////////////
// EVENTOS DEL FORMULARIO (FrmPrincipal)                                     //
//////////////////////////////////////////////////////////////////////////////

procedure TFrmPrincipal.MIMostrarBarraEditorClick(Sender: TObject);
begin
  TlBrEditor.Visible := MIMostrarBarraEditor.Checked;
end;

procedure TFrmPrincipal.MIMostrarBarraOracleClick(Sender: TObject);
begin
  TlBrOracle.Visible := MIMostrarBarraOracle.Checked;
end;

procedure TFrmPrincipal.MIMostrarBarraEstadoClick(Sender: TObject);
begin
  StatusBar.Visible := MIMostrarBarraEstado.Checked;  
end;

procedure TFrmPrincipal.MIMostrarGutterClick(Sender: TObject);
begin
  // NOTA: Esto realmente es como un interfaz virtual del formulario
  // de configuracin, puesto que lo que hago es asignarle el valor
  // del men al checkbox correspondiente y posteriormente actualizo
  // la configuracion (como si lo hubiese hecho el usuario realmente)
  // pulsando mediante cdigo el botn "Ok"
  FrmConfiguracion.ChkBxGutter.Checked := MIMostrarGutter.Checked;
  FrmConfiguracion.BitBtnOkClick(Sender);
end;

procedure TFrmPrincipal.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var
  i     : Integer;
  Salir : Boolean;
begin
  try
    i := MDIChildCount-1;
    Salir := false;
    while (i >= 0) and (not Salir) do
    begin
      if TFrmEditor(MDIChildren[i]).SynEdit.Modified then
      begin
//      if ActArchivoGuardar.Enabled then
        CanClose := MessageDlg('Hay ficheros modificados.' + #13 +
                               'Estas seguro que deseas salir',
                               mtWarning, mbOKCancel, 0) = mrOk;
        Salir := true;
      end;
      dec(i);
    end;

    if (i = -1) and (not Salir) then
      CanClose := true;

    if not CanClose then
      Abort;

    if CanClose then
    begin
      for i := MDIChildCount-1 downto 0 do
      begin
{        if ActArchivoGuardar.Enabled then
          CanClose := MessageDlg('No has guardado los cambios.' + #13 +
                                 'Estas seguro que deseas salir',
                                 mtWarning, mbOKCancel, 0) = mrOk;}
        with TFrmEditor(MDIChildren[i]) do
        begin
          OracleDataSet.Close;
          OracleSession.LogOff;
        end;
        MDIChildren[i].Close;
      end;
      GuardarEstadoForm(Self);
      GuardarConfiguracion;
    end;
  finally
//    Application.Terminate;
  end;
end;

{
procedure TMDITab.ChildDestroy(Sender: TObject);
var
  i :integer;
begin
  if assigned(sender) then begin
    if (sender is tform) then begin
      for i:=0 to tabs.count-1 do
        if tform(tabs.objects[i])=tform(sender) then
          break;
    end else
      i:=-1;
  end else
    i:=-1;
  if (i>-1) then begin
    if assigned(destroylist[i]) then
      tnotifyevent(destroylist[i]^)(tform(tabs.objects[i]));
    tabs.Delete(i);
    activatelist.delete(i);
    destroylist.delete(i);
    glyphlist.delete(i);
  end;
end;
}

////////////////////////////////////////////////////////////////////////////////
// EVENTOS DE FORMULARIO: FrmConfiguracion                                   //
//////////////////////////////////////////////////////////////////////////////

procedure TFrmPrincipal.ActDialogoConfiguracionExecute(Sender: TObject);
begin
  FrmConfiguracion.ShowModal;
end;


////////////////////////////////////////////////////////////////////////////////
// EVENTOS DE FORMULARIO: FrmPreview                                         //
//////////////////////////////////////////////////////////////////////////////

procedure TFrmPrincipal.ActArchivoConfigurarImpresoraExecute(
  Sender: TObject);
begin
  FrmPreview.PrinterSetupDialog.Execute;
end;


////////////////////////////////////////////////////////////////////////////////
// EVENTOS DE FORMULARIO: FrmAbout                                           //
//////////////////////////////////////////////////////////////////////////////

procedure TFrmPrincipal.Acercade1Click(Sender: TObject);
begin
  FrmAbout.ShowModal;
end;


////////////////////////////////////////////////////////////////////////////////
// EVENTOS DEL SYNEDIT
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// OTROS EVENTOS / ACCIONES NO CLASIFICADOS                                  //
//////////////////////////////////////////////////////////////////////////////

procedure TFrmPrincipal.DBGrid1DrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
const
  clPaleGreen = TColor($CCFFCC);
  clPaleRed =   TColor($CCCCFF);
begin
(*
  // Column.Field.Dataset.FieldbyName('CANTIDAD').AsInteger < 5
//  showMessage(inttostr(Column.Grid.FieldCount));
//  if DataCol = Column.Grid.FieldCount-1 then
  inc(Fila);

{  if Fila div Column.Grid.FieldCount = 2 then
    Fila := 0;}

//  if ((Fila div Column.Grid.FieldCount) mod 2) = 0 then
  if fila mod 2 = 0 then
    if (GDFocused in State) then
      DBGrid1.Canvas.Brush.Color := clBlack
    else
      DBGrid1.Canvas.Brush.Color := clPaleGreen;
  //Esta lnea es nueva
  DBGrid1.DefaultDrawColumnCell(rect,DataCol,Column,State)
*)
end;

procedure TFrmPrincipal.ApplicationEvents1Exception(Sender: TObject;
  E: Exception);
begin
  try
//    ShowMessage('FrmPrincipal.ApplicationEventsOnException: '#13 + E.Message);
    if E is EOutOfResources then
      ShowMessage('Me quedo sin memoria, se recomienda guardar y reiniciar');
  except
  end;
end;


////////////////////////////////////////////////////////////////////////////////
// MENSAJES PFC                                                              //
//////////////////////////////////////////////////////////////////////////////

procedure TFrmPrincipal.MIProgramaFavorito1Click(Sender: TObject);
var
  Programa, Argumentos  : String;
  Salir : Boolean;
begin
  with TMenuItem(Sender) do
  begin
    Programa := TLabel(FrmConfiguracion.FindComponent('LblPrograma' + IntToStr(Tag))).Caption;
    Argumentos := TEdit(FrmConfiguracion.FindComponent('EdtArgs' + IntToStr(Tag))).Text;
    if not FileExists(Programa) then
    begin
      if MessageDlg('El programa ya no existe. Debe configurar nuevamente los mens.' + #13 +
                    'Desea configurar los mens ahora?', mtError, mbOKCancel, 0) = mrOk then
      begin
        FrmConfiguracion.PageControl.ActivePage := FrmConfiguracion.TbShtProgramas;
        FrmConfiguracion.ShowModal;
      end;
    end
    else begin
      if MatchStrings(Argumentos, '*' + StokenFich + '*') and
         Assigned(FrmPrincipal.ActiveMDIChild) then
      begin
        if MatchStrings(TFrmEditor(FrmPrincipal.ActiveMDIChild).Caption , '*' + SNuevo + '*') then
          if MessageDlg('Para ejecutar programas que procesen el fichero, ' + #13 +
                        'primero debes guardarlo.' + #13 + 'Deseas guardarlo?', mtError,
                        mbOKCancel, 0) = mrOk then
          begin
            if TlBtnGuardar.Enabled then
              Salir := not TFrmEditor(FrmPrincipal.ActiveMDIChild).ActArchivoGuardar.Execute
            else
              Salir := not TFrmEditor(FrmPrincipal.ActiveMDIChild).ActArchivoGuardarComo.Execute;
          end
          else
            Salir := true;
        Argumentos := CambiaEn(Argumentos, STokenFich, TFrmEditor(FrmPrincipal.ActiveMDIChild).FFichero);
      end;
      if MatchStrings(Argumentos, '*' + StokenFich + '*') then
      begin
        MessageBox(Application.Handle, PChar('No tienes ningn documento activo'), PChar(Application.Title), MB_OK or MB_ICONEXCLAMATION or MB_APPLMODAL);
//        MessageDlg('No tienes ningn documento activo', mtError, mb, 0);
        Salir := true;
      end;
      if Salir then
        Exit;
//      ShowMessage(Programa + ' ' + Argumentos);        
      WinExec(PChar(Programa + ' ' + Argumentos), 0);
    end;       
  end;
end;

procedure TFrmPrincipal.FormActivate(Sender: TObject);
begin
  Caption := 'Medusa ' + GetAppInfo(ParamStr(0), 'FileVersion') + ' <Editor sql*plus++>';
  NumVentanas := 0;
  CargarEstadoForm(Self);
//  FrmEditor.HabilitarToolBarMDI(false);
  MRUList := TStringList.Create;
  CargarConfiguracion;
  AplicarConfiguracion;
  with FrmConfiguracion do
  begin
    CargarConfiguracionEditor;
    AplicarConfiguracionEditor;

    CargarConfiguracionSintaxis;

    CargarConfiguracionPrevisualizacionImpresion;
    AplicarConfiguracionPrevisualizacionImpresion;

    CargarConfiguracionOracle;

    CargarConfiguracionProgramasFavoritos;
    AplicarConfiguracionProgramasFavoritos;

    CargarConfiguracionMenuFavoritos;
  end;
{  ActArchivoNuevo.Execute;
  ActualizarPosCaret;
  ActualizarEstadoTeclado;
  ActualizarEstadoEditor;}
  TFrmEditor(nil).InitStatusBar; // ES RARO!!!, pero es para reutilizar cdigo
//  FrmEditor.CrearVentana;
end;

procedure TFrmPrincipal.ApplicationEvents1Hint(Sender: TObject);
begin
  StatusBar.Panels[5].Text := Application.Hint;
end;

procedure TFrmPrincipal.BuildMRU(var ioMenuItem : TMenuItem);
var
 i : integer;
 MRUItem : TMenuItem;
begin
 PpMnuMRU.Items.Clear;
// ioMenuItem.Clear;
  i := 2;
  while i <= ioMenuItem.Count -1 do
    ioMenuItem.Delete(2);
  if MRUList.Count > 0 then
  begin
    for i := 0 to MRUList.Count -1  do
    begin
      if i < MRUmax then
      begin
        MRUItem := newItem(
              IntToStr(i) + ' > ' + MRUList.Values[IntToStr(i)],
              0, false, true, RecentFileClick, 0,
              format('MIMRUFich%d', [i]));
        MRUItem.Tag := i;
        ioMenuItem.Add(MRUItem);
        MRUItem := newItem(
               IntToStr(i) + ' > ' + MRUList.Values[IntToStr(i)],
               0, false, true, RecentFileClick, 0,
               format('MIMRUFich%d', [i]));
        PpMnuMRU.Items.Add(MRUItem);
      end;
    end;
  end;
end;

procedure TFrmPrincipal.UpdateMRU(var ioMenuItem : TMenuItem; iFileName : string);
var
 i, j : integer;
 tmplst : TStringList;
begin
 tmplst := TStringList.create;
 //Put the opened file in at the top of the list
 if FileExists(iFileName) then
 begin
   tmplst.Insert(0, '0=' + iFileName);
   j := 1;
 end
 else
   j := 0;
 //Store Data and remove from menu
 for i := 0 to MRUList.Count - 1 do
 begin
   if (iFileName <>  MRUList.Values[IntToStr(i)]) then
   begin
     tmplst.Add(IntToStr(j) + '=' + MRUList.Values[IntToStr(i)]);
     inc(j);
   end;
 end;
 MRUList.Text := tmplst.Text;
 BuildMRU(ioMenuItem);
 tmplst.free;
end;

procedure TFrmPrincipal.RecentFileClick(Sender: TObject);
var
 tmpstr : string;
begin
 tmpstr := StringReplace(TMenuItem(Sender).Caption, '&', '', [rfReplaceAll]);
{ i := FindWindowByName(tmpstr);
 if i > -1 then // if the file is already open, reload it and bring it to the front
 begin
   if Self.MDIChildren[i].WindowState = wsMinimized then
     Self.MDIChildren[i].WindowState := wsNormal
   else
     Self.MDIChildren[i].Show;
   Self.MDIChildren[i].SetFocus;
   (Self.MDIChildren[i].Components[0] as TSynEdit).Lines.LoadFromFile(tmpstr);
   (Self.MDIChildren[i] as TfrmEditor).SetHighlighterFromFileExt(ExtractFileExt(tmpstr));
   UpdateMRU(miRecentFile1,tmpstr);
 end
 else}
  with TFrmEditor.Create(nil) do
  begin
    AbrirFichero(Trim(GetToken(tmpstr, '>', 2)));  
  end;
end;


procedure TFrmPrincipal.ToolButton1Click(Sender: TObject);
begin
  ShowMessage(GetAppInfo(ParamStr(0), 'FileVersion'));
end;

procedure TFrmPrincipal.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
    GuardarEstadoForm(Self);
  except
  end;
  Application.HelpCommand(HELP_QUIT, 0);
  // Cierra el fichero de ayuda si est abierto
end;

procedure TFrmPrincipal.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
{  if Key = VK_F2 then
    if FrmConfiguracion.LblDocumentacion.Caption <> 'Documentacin' then
      ShellExecute(FrmPrincipal.Handle, nil, PChar(FrmConfiguracion.LblDocumentacion.Caption), '', '', SW_SHOWNORMAL);}
end;

procedure TFrmPrincipal.TmrHoraTimer(Sender: TObject);
begin
  StatusBar.Panels[6].Text := FormatDateTime('dd/mm/yy - hh:mm:ss', now)
end;

procedure TFrmPrincipal.MIAyudaOracleClick(Sender: TObject);
begin
  if FrmConfiguracion.LblDocumentacion.Caption <> 'Documentacin' then
    ShellExecute(FrmPrincipal.Handle, nil, PChar(FrmConfiguracion.LblDocumentacion.Caption), '', '', SW_SHOWNORMAL);
end;

procedure TFrmPrincipal.FormCreate(Sender: TObject);
var
  Path : String;
begin
  Path := ExtractFilePath(ParamStr(0)) + 'Help\Medusa.hlp';
  if FileExists(Path) then
    Application.HelpFile := Path
  else begin
    // Puede ser til para informar al usuario, en caso de
    // que el fichero de ayuda no existe y poder deshabilitar
    // los mens de ayuda
  end;
end;

procedure TFrmPrincipal.MIAyudaClick(Sender: TObject);
begin
  // Para mostrar la pgina por defecto (usamos F1 como
  // tecla rpida, para este elemento de men):
  Application.HelpCommand(HELP_CONTENTS, 0);
  // La pgina por defecto, se define en el fichero hpj
  // como 'CONTENTS=SHM_contentsXXXX' (sea la pgina
  // inicial, o la pgina 1).
  // Microsoft dice, que este mtodo es antiguo y nos
  // recomienda usar HELP_FINDER en su lugar (ver
  // siguiente). De ese modo, mostramos la ventana de
  // contenido.
end;

procedure TFrmPrincipal.MIContenidoAyudaClick(Sender: TObject);
begin
  Application.HelpCommand(HELP_FINDER, 0);
  // Muestra la ventana de contenido

//  Application.HelpCommand(15, -2);
  // Muestra la pestaa ndice
end;

{ TODO: Topicos de ayuda
  // Utilizando una constante de pgina (recomendado)
  Application.Helpcontext(hlp_QuickStartPleaseRead);
  // Muestra la pgina QuickStartPleaseRead (sea cual sea
  // su nmero de identificacin)
}

procedure TFrmPrincipal.FormHide(Sender: TObject);
begin
//  Application.
end;


end.

// 759
