////////////////////////////////////////////////////////////////////////////////
//
// Proyecto Medusa v3.0
//
//////////////////////////////////// INFO //////////////////////////////////////
//
//  Nombre del programa : Medusa.exe
//  Fecha               : Septiembre del 2003.
//  Componentes         : DOA 3.4.6.4, SynEdit 1.1 (CVS).
//  Version compilador  : Delphi 6.0 Enterprise.
//  Descripcin         : Un cliente avanzado de Oracle
//  Autor               : Albert Philippe De La Fuente Vigliotti.
//  Tutor               : Jos Galindo Gmez.
//
////////////////////////////////////////////////////////////////////////////////

unit UReconstruirCreateTable;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Oracle;

type
  TFrmReconstruirCreateTable = class(TForm)
    EdtTabla: TEdit;
    OracleQry: TOracleQuery;
    OracleQryCampos: TOracleQuery;
    Label1: TLabel;
    BitBtnReconstruir: TBitBtn;
    OracleQryComentarios: TOracleQuery;
    procedure FormActivate(Sender: TObject);
    procedure BitBtnReconstruirClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmReconstruirCreateTable: TFrmReconstruirCreateTable;

implementation

uses UEditor, UPrincipal, UConfiguracion, UGlobal;

{$R *.dfm}

procedure TFrmReconstruirCreateTable.FormActivate(Sender: TObject);
begin
  try
    CargarEstadoForm(Self);   // Esto es por si se ejecuta desde CD...
  except
  end;
  EdtTabla.Clear;
end;

procedure TFrmReconstruirCreateTable.BitBtnReconstruirClick(
  Sender: TObject);
var
  Ventana        : TFrmEditor;
  LongConstraint : Integer;
  Str            : String;
  i, Long, Maximo, Maximo2, NumAtrib, Base  : Integer;
begin
  with OracleQry do
  begin
    Session := TFrmEditor(FrmPrincipal.ActiveMDIChild).OracleSession;
//    ShowMessage(BoolToStr(Session.Connected));
    OracleQryCampos.Session := TFrmEditor(FrmPrincipal.ActiveMDIChild).OracleSession;
//    ShowMessage(BoolToStr(OracleQryCampos.Session.Connected));
    OracleQryComentarios.Session := TFrmEditor(FrmPrincipal.ActiveMDIChild).OracleSession;
//    ShowMessage(BoolToStr(OracleQryComentarios.Session.Connected));
//    OracleQryCampos.Session := TFrmEditor(FrmPrincipal.ActiveMDIChild).OracleSession;

    // Limpiamos y definimos las variables
    DeleteVariables;
    DeclareVariable(':TABLA', otString);
    DeclareVariable(':EXISTE', otInteger);
    // Cerramos (por seguridad)
    Close;
    SQL.Clear;
    SQL.Add('BEGIN');
    SQL.Add('  SELECT COUNT(*)');
    SQL.Add('  INTO :EXISTE');
    SQL.Add('  FROM ALL_TABLES');
    SQL.Add('  WHERE UPPER(TABLE_NAME) = UPPER(:TABLA);');
    SQL.Add('END;');
    SetVariable(':TABLA', EdtTabla.Text);
    Execute;
    Close;
    if GetVariable(':EXISTE') <> '1' then
    begin
      ShowMessage('La tabla no existe');
    end
    else begin                            // EXISTE LA TABLA -> LA RECONSTRUIMOS
      Cursor := crSQLWait;
      BitBtnReconstruir.Cursor := crSQLWait;
      EdtTabla.Cursor := crSQLWait;
      FrmPrincipal.Cursor := crSQLWait;

      Ventana := TFrmEditor.Create(nil);

      Ventana.SynEdit.Lines.Add('-- Tabla generada automticamente por Medusa');
      Ventana.SynEdit.Lines.Add('');
      Ventana.SynEdit.Lines.Add('');


////////////////////////////////////////////////////////////////////////////////
// C O M E N T A R I O S   D E   T A B L A S
////////////////////////////////////////////////////////////////////////////////

      with OracleQryCampos do
      begin
        Close;
        SQL.Clear;
        SQL.Add('SELECT *');
        SQL.Add('FROM ALL_TAB_COMMENTS');
        SQL.Add('WHERE UPPER(TABLE_NAME) = UPPER(:TABLA)');
        DeleteVariables;
        DeclareVariable(':TABLA', otString);
        SetVariable(':TABLA', EdtTabla.Text);
        Execute;

        Str := '';
        if not FieldIsNull('COMMENTS') then
        begin
          Ventana.SynEdit.Lines.Add(Format('-- %s', [Field('COMMENTS')]))
        end;
      end; // with


////////////////////////////////////////////////////////////////////////////////
// C A B E C E R A   D E   L A   T A B L A
////////////////////////////////////////////////////////////////////////////////

      Base := Ventana.SynEdit.Lines.Add('CREATE TABLE ' + UpperCase(Session.LogonUsername) +
                                        '.' + UpperCase(EdtTabla.Text) + ' (');

      DeleteVariables;
      DeclareVariable(':TABLA', otString);



////////////////////////////////////////////////////////////////////////////////
// C O L U M N A S
////////////////////////////////////////////////////////////////////////////////

      Close;
      SQL.Clear;
      SQL.Add('SELECT *');
      SQL.Add('FROM ALL_TAB_COLUMNS');
      SQL.Add('WHERE UPPER(TABLE_NAME) = UPPER(:TABLA)');
      SetVariable(':TABLA', EdtTabla.Text);
      Execute;

      // NOMBRES DE COLUMNAS ///////////////////////////////////////////////////
      Maximo := 0;
      while not Eof do
      begin
        Str := StringOfChar(' ', FrmConfiguracion.SpnEdtTab.Value) + Field('COLUMN_NAME');

        i := Ventana.SynEdit.Lines.Add(Str);

        if Length(Str) > Maximo then
          Maximo := Length(Str);

        Next;
      end;
      NumAtrib := i + 1;

      // TIPOS /////////////////////////////////////////////////////////////////
      Close;
      Execute;
      i := Base + 1;
      Maximo2 := 0;
      while not Eof do
      begin
        Str := UpperCase(Field('DATA_TYPE'));
        if Str = 'NUMBER' then
          Str := Format('%s(%s, %s)', [Field('DATA_TYPE'), Field('DATA_PRECISION'),
                                       Field('DATA_SCALE')])
        else if (Str = 'VARCHAR2') or (Str = 'NVARCHAR2') or (Str = 'RAW') or
                (Str = 'UROWID') or (Str = 'CHAR') or (Str = 'NCHAR') then
          Str := Format('%s(%s)', [Field('DATA_TYPE'), Field('DATA_LENGTH')])
        else
          Str := Format('%s', [Field('DATA_TYPE')]);

        // Preconcateno los espacios
        Str := StringOfChar(' ', Maximo - Length(Ventana.SynEdit.Lines[i]) + 1) + Str;

        Ventana.SynEdit.Lines[i] := Ventana.SynEdit.Lines[i] + Str;

        if Length(Ventana.SynEdit.Lines[i]) > Maximo2 then
          Maximo2 := Length(Ventana.SynEdit.Lines[i]);

        inc(i);
        Next;
      end;

      // DEFAULTS //////////////////////////////////////////////////////////////
      Close;
      Execute;
      Maximo := 0;
      i := Base + 1;
      Str := '';
      while not Eof do
      begin
        Str := '';
        if not FieldIsNull('DATA_DEFAULT') then
          Str := Format(' DEFAULT %s', [Field('DATA_DEFAULT')]);

        // Preconcateno los espacios y las comas correspondientes
        Str := StringOfChar(' ', Maximo2 - Length(Ventana.SynEdit.Lines[i])) + Str;
        if NumAtrib > 1 then
          Str := Str + ',';

        Ventana.SynEdit.Lines[i] := Ventana.SynEdit.Lines[i] + Str;

        if Length(Ventana.SynEdit.Lines[i]) > Maximo then
          Maximo := Length(Ventana.SynEdit.Lines[i]);

        inc(i);
        Next;
      end;


////////////////////////////////////////////////////////////////////////////////
// C O M E N T A R I O S   D E   C O L U M N A S
////////////////////////////////////////////////////////////////////////////////

      with OracleQryComentarios do
      begin
        with OracleQryCampos do
        begin
          Close;
          SQL.Clear;
          SQL.Add('SELECT *');
          SQL.Add('FROM ALL_TAB_COLUMNS');
          SQL.Add('WHERE UPPER(TABLE_NAME) = UPPER(:TABLA)');
          DeleteVariables;
          DeclareVariable(':TABLA', otString);
          SetVariable(':TABLA', EdtTabla.Text);          
          Execute;
        end;

        i := 1; // No es 0 porque la primera lnea es la cabecera (CREATE TABLE...)
        while not OracleQryCampos.Eof do
        begin
          Close;
          SQL.Clear;
          SQL.Add('SELECT *');
          SQL.Add('FROM ALL_COL_COMMENTS');
          SQL.Add('WHERE UPPER(TABLE_NAME) = UPPER(:TABLA)');
          SQL.Add('  AND UPPER(COLUMN_NAME) = UPPER(:COLUMNA)');
          DeleteVariables;
          DeclareVariable(':TABLA', otString);
          DeclareVariable(':COLUMNA', otString);
          SetVariable(':TABLA', EdtTabla.Text);
          SetVariable(':COLUMNA', OracleQryCampos.Field('COLUMN_NAME'));
          Execute;

          Str := '';
          if not FieldIsNull('COMMENTS') then
          begin
            Str := Format(' -- %s', [Field('COMMENTS')]);

            // Preconcateno los espacios
//            Str := StringOfChar(' ', Maximo - Length(Ventana.SynEdit.Lines[i])) + Str;
            Ventana.SynEdit.Lines[Base + i] := Ventana.SynEdit.Lines[Base + i] + Str;
          end; // if
          inc(i);
          OracleQryCampos.Next;
        end; // while
      end; // with



////////////////////////////////////////////////////////////////////////////////
// R E S T R I C C I O N E S
////////////////////////////////////////////////////////////////////////////////

      // ATRIBUTOS CLAVE PRIMARIA (PRIMARY KEY) ////////////////////////////////
      Close;
      SQL.Clear;
      SQL.Add('SELECT CONSTRAINT_NAME');
      SQL.Add('FROM ALL_CONSTRAINTS');
      SQL.Add('WHERE (UPPER(TABLE_NAME) = UPPER(:TABLA))');
      SQL.Add('  AND (CONSTRAINT_TYPE = ''P'')');
//      SetVariable(':TABLA', EdtTabla.Text);
      Execute;

      Maximo := 0;
      OracleQryCampos.DeleteVariables;
      OracleQryCampos.DeclareVariable(':RESTRICCION', otString);
//      OracleQryCampos.Session := TFrmEditor(FrmPrincipal.ActiveMDIChild).OracleSession;
      while not Eof do
      begin
        i := 1;
        with OracleQryCampos do
        begin
          Close;
          SQL.Clear;
          SQL.Add('SELECT COLUMN_NAME');
          SQL.Add('FROM ALL_CONS_COLUMNS');
          SQL.Add('WHERE CONSTRAINT_NAME = :RESTRICCION');
          SetVariable(':RESTRICCION', OracleQry.Field('CONSTRAINT_NAME'));
          Execute;

          while not Eof do
          begin
            if i = 1 then
            begin
              Str := Format('%sCONSTRAINT %s PRIMARY KEY (%s',
              [StringOfChar(' ', FrmConfiguracion.SpnEdtTab.Value),
               OracleQry.Field('CONSTRAINT_NAME'),
               Field('COLUMN_NAME')]);
              Ventana.SynEdit.Lines.Add(Str);
            end
            else
              Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1] :=
                Format('%s, %s', [Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1],
                                  Field('COLUMN_NAME')]);
            Next;
            inc(i);
          end;
          Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1] :=
            Format('%s),', [Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1]]);
        end;
        Next;
      end;

      // ATRIBUTOS NICOS (UNIQUE) /////////////////////////////////////////////
      Close;
      SQL.Clear;
      SQL.Add('SELECT CONSTRAINT_NAME');
      SQL.Add('FROM ALL_CONSTRAINTS');
      SQL.Add('WHERE (UPPER(TABLE_NAME) = UPPER(:TABLA))');
      SQL.Add('  AND (CONSTRAINT_TYPE = ''U'')');
//      SetVariable(':TABLA', EdtTabla.Text);
      Execute;

      Maximo := 0;
      OracleQryCampos.DeleteVariables;
      OracleQryCampos.DeclareVariable(':RESTRICCION', otString);
//      OracleQryCampos.Session := TFrmEditor(FrmPrincipal.ActiveMDIChild).OracleSession;
      while not Eof do
      begin
        i := 1;
        with OracleQryCampos do
        begin
          Close;
          SQL.Clear;
          SQL.Add('SELECT COLUMN_NAME');
          SQL.Add('FROM ALL_CONS_COLUMNS');
          SQL.Add('WHERE CONSTRAINT_NAME = :RESTRICCION');
          SetVariable(':RESTRICCION', OracleQry.Field('CONSTRAINT_NAME'));
          Execute;

          while not Eof do
          begin
            if i = 1 then
            begin
              Str := Format('%sCONSTRAINT %s UNIQUE (%s',
                [StringOfChar(' ', FrmConfiguracion.SpnEdtTab.Value),
                 OracleQry.Field('CONSTRAINT_NAME'),
                 Field('COLUMN_NAME')]);
              Ventana.SynEdit.Lines.Add(Str);
            end
            else
              Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1] :=
                Format('%s, %s', [Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1],
                                  Field('COLUMN_NAME')]);
            Next;
            inc(i);
          end;
          Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1] :=
            Format('%s),', [Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1]]);
        end;
        Next;
      end;

      // ATRIBUTOS CON CONDICIONES (CHECK) /////////////////////////////////////
      Close;
      SQL.Clear;
      SQL.Add('SELECT SEARCH_CONDITION, CONSTRAINT_NAME');
      SQL.Add('FROM ALL_CONSTRAINTS');
      SQL.Add('WHERE UPPER(TABLE_NAME) = UPPER(:TABLA)');
      SQL.Add('  AND CONSTRAINT_TYPE = ''C''');
//      SetVariable(':RESTRICCION', OracleQry.Field('CONSTRAINT_NAME'));
      Execute;
      Str := '';
      while not Eof do
      begin
        Str := Format('%sCONSTRAINT %s CHECK (%s),', [StringOfChar(' ', FrmConfiguracion.SpnEdtTab.Value),
                                                      Field('CONSTRAINT_NAME'),
                                                      Field('SEARCH_CONDITION')]);
        Ventana.SynEdit.Lines.Add(Str);
        Next;
      end;

      // ATRIBUTOS CLAVE FORANEA (FOREIGN KEY) /////////////////////////////////
      Close;
      SQL.Clear;
      SQL.Add('SELECT CONSTRAINT_NAME, R_CONSTRAINT_NAME');
      SQL.Add('FROM ALL_CONSTRAINTS');
      SQL.Add('WHERE (UPPER(TABLE_NAME) = UPPER(:TABLA))');
      SQL.Add('  AND (CONSTRAINT_TYPE = ''R'')');
//      SetVariable(':TABLA', EdtTabla.Text);
      Execute;

      Maximo := 1; // La utilizo para poner la coma (para no declarar otra variable ms...)
      OracleQryCampos.DeleteVariables;
      OracleQryCampos.DeclareVariable(':RESTRICCION', otString);
//      OracleQryCampos.Session := TFrmEditor(FrmPrincipal.ActiveMDIChild).OracleSession;
      while not Eof do
      begin
        i := 1;
        with OracleQryCampos do
        begin
          Close;
          SQL.Clear;
          SQL.Add('SELECT COLUMN_NAME');
          SQL.Add('FROM ALL_CONS_COLUMNS');
          SQL.Add('WHERE CONSTRAINT_NAME = :RESTRICCION');
          SQL.Add('ORDER BY POSITION');
          SetVariable(':RESTRICCION', OracleQry.Field('CONSTRAINT_NAME'));
          Execute;

          while not Eof do
          begin
            if i = 1 then
            begin
              if RowsProcessed = 1 then
                Str := Format('%sCONSTRAINT %s FOREIGN KEY %s',
                  [StringOfChar(' ', FrmConfiguracion.SpnEdtTab.Value),
                   OracleQry.Field('CONSTRAINT_NAME'),
                   Field('COLUMN_NAME')])
              else
                Str := Format('%sCONSTRAINT %s FOREIGN KEY (%s',
                  [StringOfChar(' ', FrmConfiguracion.SpnEdtTab.Value),
                   OracleQry.Field('CONSTRAINT_NAME'),
                   Field('COLUMN_NAME')]);
                   
              LongConstraint := Length(Format('%sCONSTRAINT %s',
                [StringOfChar(' ', FrmConfiguracion.SpnEdtTab.Value),
                 OracleQry.Field('CONSTRAINT_NAME')]));
              Ventana.SynEdit.Lines.Add(Str);
            end
            else
              Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1] :=
                Format('%s, %s', [Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1],
                                  Field('COLUMN_NAME')]);
            Next;
            inc(i);
          end;

          if RowsProcessed > 1 then
            Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1] :=
              Format('%s)', [Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1]]);

          // TABLA DE REFERENCIA
          Close;
          OracleQryCampos.DeleteVariables;
          OracleQryCampos.DeclareVariable(':RESTRICCION', otString);
          SQL.Clear;
          SQL.Add('SELECT TABLE_NAME');
          SQL.Add('FROM ALL_CONSTRAINTS');
          SQL.Add('WHERE CONSTRAINT_NAME = :RESTRICCION');
          SetVariable(':RESTRICCION', OracleQry.Field('R_CONSTRAINT_NAME'));
//          SetVariable(':RESTRICCION', OracleQry.Field('CONSTRAINT_NAME'));
          Execute;
          Ventana.SynEdit.Lines.Add(
            Format('%s REFERENCES %s',
              [StringOfChar(' ', LongConstraint),
               Field('TABLE_NAME')]));

{          Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1] :=
            Format('%s REFERENCES %s', [Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1],
                                        Field('TABLE_NAME')]);}

          // ATRIBUTOS A LOS QUE SE HACE REFERENCIA
          Close;
          OracleQryCampos.DeleteVariables;
          OracleQryCampos.DeclareVariable(':RESTRICCION', otString);
          SQL.Clear;
          SQL.Add('SELECT COLUMN_NAME');
          SQL.Add('FROM ALL_CONS_COLUMNS');
          SQL.Add('WHERE CONSTRAINT_NAME = :RESTRICCION');
          SQL.Add('ORDER BY POSITION');
          SetVariable(':RESTRICCION', OracleQry.Field('R_CONSTRAINT_NAME'));
//          SetVariable(':RESTRICCION', OracleQry.Field('CONSTRAINT_NAME'));
          Execute;
          i := 1;
          while not Eof do
          begin
            if i = 1 then
              Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1] :=
                Format('%s(%s', [Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1],
                                  Field('COLUMN_NAME')])
            else
              Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1] :=
                Format('%s ,%s', [Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1],
                                  Field('COLUMN_NAME')]);
            Next;
            inc(i);
          end;
          Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1] :=
            Format('%s),', [Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1]]);
        end; (* WITH *)
        Next;
      end; (* WHILE, aunque parezca mentira ;-) *)

      // Ahora, a la ltima lnea, le quitamos la coma
      Str := Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1];
      SetLength(Str, Length(Str) - 1);
      Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1] := Str;

      // Y cerramos la sentencia CREATE TABLE      
      Ventana.SynEdit.Lines.Add(');');

      Cursor := crNone;
      BitBtnReconstruir.Cursor := crNone;
      EdtTabla.Cursor := crNone;
      FrmPrincipal.Cursor := crNone;

      FrmReconstruirCreateTable.Close;
    end;
  end;
end;

procedure TFrmReconstruirCreateTable.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
    GuardarEstadoForm(Self);
  except
  end;
end;

end.

// 524
