////////////////////////////////////////////////////////////////////////////////
//
// Proyecto Medusa v3.0
//
//////////////////////////////////// INFO //////////////////////////////////////
//
//  Nombre del programa : Medusa.exe
//  Fecha               : Septiembre del 2003.
//  Componentes         : DOA 3.4.6.4, SynEdit 1.1 (CVS).
//  Version compilador  : Delphi 6.0 Enterprise.
//  Descripcin         : Un cliente avanzado de Oracle
//  Autor               : Albert Philippe De La Fuente Vigliotti.
//  Tutor               : Jos Galindo Gmez.
//
////////////////////////////////////////////////////////////////////////////////

unit UVisualIndexes;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, Oracle;

type
  TFrmVisualIndexes = class(TForm)
    LstColumnas: TListBox;
    BitBtnAgregar: TBitBtn;
    BitBtnQuitar: TBitBtn;
    CmBxTablas: TComboBox;
    RdGrpIndice: TRadioGroup;
    LstICols: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    BitBtnOk: TBitBtn;
    BitBtnCancelar: TBitBtn;
    OracleQry: TOracleQuery;
    EdtNombre: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    BitBtnSubir: TBitBtn;
    BitBtnBajar: TBitBtn;
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CmBxTablasSelect(Sender: TObject);
    procedure BitBtnAgregarClick(Sender: TObject);
    procedure LstColumnasClick(Sender: TObject);
    procedure LstIColsClick(Sender: TObject);
    procedure BitBtnQuitarClick(Sender: TObject);
    procedure BitBtnSubirClick(Sender: TObject);
    procedure BitBtnBajarClick(Sender: TObject);
    procedure BitBtnOkClick(Sender: TObject);
    procedure LstColumnasDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmVisualIndexes: TFrmVisualIndexes;

implementation

uses UGlobal, UPrincipal, UEditor, UConfiguracion;

{$R *.dfm}

procedure TFrmVisualIndexes.FormActivate(Sender: TObject);
begin
  try
    CargarEstadoForm(Self);
  except
  end;
  RdGrpIndice.ItemIndex := 0;
  EdtNombre.Clear;
  CmBxTablas.Clear;
  LstColumnas.Clear;
  LstICols.Clear;

  OracleQry.Session := TFrmEditor(FrmPrincipal.ActiveMDIChild).OracleSession;
  with OracleQry, OracleQry.SQL do
  begin
    // CARGO LAS TABLAS
    Clear;
    Close;
    Add('SELECT TABLE_NAME');
    Add('FROM USER_TABLES');
    Execute;
    while not Eof do
    begin
      CmBxTablas.Items.Add(Field('TABLE_NAME'));
      OracleQry.Next;
    end;
  end;
end;

procedure TFrmVisualIndexes.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
    GuardarEstadoForm(Self);
  except
  end;
end;

procedure TFrmVisualIndexes.CmBxTablasSelect(Sender: TObject);
begin
  LstICols.Clear;
  with OracleQry, OracleQry.SQL do
  begin
    // CARGO LAS TABLAS
    Clear;
    Close;
    Add('SELECT COLUMN_NAME');
    Add('FROM USER_TAB_COLUMNS');
    Add('WHERE UPPER(TABLE_NAME) = ''' + UpperCase(CmBxTablas.Text) + '''');
    Execute;
    while not Eof do
    begin
      LstColumnas.Items.Add(Field('COLUMN_NAME'));
      OracleQry.Next;
    end;
  end;
end;

procedure TFrmVisualIndexes.LstColumnasClick(Sender: TObject);
begin
  BitBtnAgregar.Enabled := true;
end;

procedure TFrmVisualIndexes.LstIColsClick(Sender: TObject);
begin
  BitBtnQuitar.Enabled := true;
end;

procedure TFrmVisualIndexes.BitBtnAgregarClick(Sender: TObject);
var
  i : Integer;
begin
  for i := 0 to LstColumnas.Items.Count - 1 do
    if LstColumnas.Selected[i] then
      LstICols.Items.Add(LstColumnas.Items[i]);
  LstColumnas.DeleteSelected;
end;

procedure TFrmVisualIndexes.BitBtnQuitarClick(Sender: TObject);
var
  i : Integer;
begin
  for i := 0 to LstICols.Items.Count - 1 do
    if LstICols.Selected[i] then
      LstColumnas.Items.Add(LstICols.Items[i]);
  LstICols.DeleteSelected;
end;

procedure TFrmVisualIndexes.BitBtnSubirClick(Sender: TObject);
var
  i             : Integer;
  Temp1, Temp2  : String;
  Salir         : Boolean;
begin
  i := 0;
  Salir := false;
  while (i <= LstICols.Items.Count - 1) and (not Salir) do
  begin
    Salir := (i = 0) and (LstICols.Selected[i]);
    if (LstICols.Selected[i]) and (not Salir) then
    begin
      Temp1 := LstICols.Items[i - 1];
      Temp2 := LstICols.Items[i];
      LstICols.Items[i - 1]    := Temp2;
      LstICols.Items[i]        := Temp1;
      LstICols.Selected[i - 1] := true;
    end;
    inc(i);
  end;
  ActiveControl := LstICols;
end;

procedure TFrmVisualIndexes.BitBtnBajarClick(Sender: TObject);
var
  i             : Integer;
  Temp1, Temp2  : String;
  Salir         : Boolean;
begin
  i := LstICols.Items.Count - 1;
  Salir := false;
  while (i >= 0) and (not Salir) do
  begin
    Salir := (i = LstICols.Items.Count - 1) and (LstICols.Selected[i]);
    if (LstICols.Selected[i]) and (not Salir) then
    begin
      Temp1 := LstICols.Items[i];
      Temp2 := LstICols.Items[i + 1];
      LstICols.Items[i]        := Temp2;
      LstICols.Items[i + 1]    := Temp1;
      LstICols.Selected[i + 1] := true;
    end;
    dec(i);
  end;
  ActiveControl := LstICols;

(*  i := 0;
  Salir := false;
  while (i <= LstICols.Items.Count - 1) and (not Salir) do
  begin
    Salir := (LstICols.Selected[LstICols.Items.Count - 1]) and (i = LstICols.Items.Count - 1);
    if (LstICols.Selected[i]) and (not Salir) then
    begin
      Temp1 := LstICols.Items[i];
      Temp2 := LstICols.Items[i + 1];
      LstICols.Items[i]     := Temp2;
      LstICols.Items[i + 1] := Temp1;
      LstICols.Selected[i]  := true;
    end;
    inc(i);
  end;
  ActiveControl := LstICols;*)
end;

procedure TFrmVisualIndexes.BitBtnOkClick(Sender: TObject);
var
  Str : String;
  Tab : String;
  i   : Integer;
  Editor  : TFrmEditor;
begin
  if EdtNombre.Text = '' then
    ShowMessage('Debe ingresar un nombre para el ndice')
  else if CmBxTablas.Text = '' then
    ShowMessage('Debe seleccionar una tabla')
  else if LstICols.Items.Count = 0 then
    ShowMessage('Debe haber al menos una columna en el ndice')
  else begin
    Editor := TFrmEditor.Create(nil);
    with Editor.SynEdit, Editor.SynEdit.Lines do
    begin
      Add('-- ndice generado automticamente por Medusa');
      Add('');
      Tab := StringOfChar(' ', FrmConfiguracion.SpnEdtTab.Value);

      if RdGrpIndice.ItemIndex in [0, 1] then
        Str := 'CREATE INDEX ' + EdtNombre.Text
      else if RdGrpIndice.ItemIndex = 3 then
        Str := 'CREATE BITMAP INDEX ' + EdtNombre.Text;

      // Aado la cabecera
      Add(Str);

      // En Str dejo el formato de las columnas del ndice
      Str := '(';
      for i := 0 to LstICols.Items.Count - 1 do
        Str := Str + LstICols.Items[i] + ', ';
      Str := Copy(Str, 1, Length(Str) - 2);
      Str := Str + ')';

      // Termino de aadir el resto de la sentencia
      Add(Tab + 'ON ' + CmBxTablas.Text + ' ' + Str);
      if RdGrpIndice.ItemIndex = 1 then
        Add(Tab + 'REVERSE');

      // Pongo el punto y coma
      Lines[Lines.Count - 1] := Lines[Lines.Count - 1] + ';';
    end;
    Close;
  end;
end;

procedure TFrmVisualIndexes.LstColumnasDblClick(Sender: TObject);
begin
  // JEJEJEJE, lo acabo de descubrir ahora... pudiendolo haber usado antes...
  // siempre reinventando la rueda!!!
  LstColumnas.MoveSelection(LstICols);
end;

end.

// 279
