////////////////////////////////////////////////////////////////////////////////
//
// Proyecto Medusa v3.0
//
//////////////////////////////////// INFO //////////////////////////////////////
//
//  Nombre del programa : Medusa.exe
//  Fecha               : Septiembre del 2003.
//  Componentes         : DOA 3.4.6.4, SynEdit 1.1 (CVS).
//  Version compilador  : Delphi 6.0 Enterprise.
//  Descripcin         : Un cliente avanzado de Oracle
//  Autor               : Albert Philippe De La Fuente Vigliotti.
//  Tutor               : Jos Galindo Gmez.
//
////////////////////////////////////////////////////////////////////////////////

unit UVisualJava;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons;

type
  TFrmVisualJava = class(TForm)
    EdtNombre: TEdit;
    EdtClase: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    BitBtnCancelar: TBitBtn;
    BitBtnOk: TBitBtn;
    MmoComentario: TMemo;
    Label3: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtnOkClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmVisualJava: TFrmVisualJava;

implementation

uses UConfiguracion, UGlobal, UEditor, UDMGlobal;

{$R *.dfm}

procedure TFrmVisualJava.FormActivate(Sender: TObject);
begin
  try
    CargarEstadoForm(Self);
  except
  end;
  EdtNombre.Clear;
  EdtClase.Clear;
  MmoComentario.Clear;
end;

procedure TFrmVisualJava.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
    GuardarEstadoForm(Self);
  except
  end;
end;

procedure TFrmVisualJava.BitBtnOkClick(Sender: TObject);
var
  Tab     : String;
  Editor  : TFrmEditor;
  i       : Integer;
begin
  if EdtNombre.Text = '' then
    ShowMessage('Debe ingresar un nombre')
  else if EdtClase.Text = '' then
    ShowMessage('Debe ingresar una clase')
  else begin
    Editor := TFrmEditor.Create(nil);
    with Editor.SynEdit.Lines do
    begin
      Tab := StringOfChar(' ', FrmConfiguracion.SpnEdtTab.Value);
      Add('-- Bloque Java generado automticamente por Medusa');
      Add('');
      for i := 0 to MmoComentario.Lines.Count -1 do
        Editor.SynEdit.Lines.Add('-- ' + MmoComentario.Lines[i]);
      Add('');
      Add('CREATE OR REPLACE AND COMPILE JAVA SOURCE NAMED ' + EdtNombre.Text + ' AS');
      Add('public class ' + EdtClase.Text);
      Add('{');
      Add(Tab + 'public static void entry()');
      Add(Tab + '{');
      Add(Tab + '}');
      Add('}');
      Editor.SynEdit.Highlighter := DMGlobal.SynJavaSyn;
    end; // with
    Close;
  end; // else
end;

end.

// 108
