////////////////////////////////////////////////////////////////////////////////
//
// Proyecto Medusa v3.0
//
//////////////////////////////////// INFO //////////////////////////////////////
//
//  Nombre del programa : Medusa.exe
//  Fecha               : Septiembre del 2003.
//  Componentes         : DOA 3.4.6.4, SynEdit 1.1 (CVS).
//  Version compilador  : Delphi 6.0 Enterprise.
//  Descripcin         : Un cliente avanzado de Oracle
//  Autor               : Albert Philippe De La Fuente Vigliotti.
//  Tutor               : Jos Galindo Gmez.
//
////////////////////////////////////////////////////////////////////////////////

unit UVisualPackages;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons;

type
  TFrmVisualPackages = class(TForm)
    EdtNombre: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    BitBtnCancelar: TBitBtn;
    BitBtnOk: TBitBtn;
    MmoComentario: TMemo;
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtnOkClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmVisualPackages: TFrmVisualPackages;

implementation

uses UGlobal, UEditor, UConfiguracion;

{$R *.dfm}

//TODO: NO Aadido a la memoria 

procedure TFrmVisualPackages.FormActivate(Sender: TObject);
begin
  try
    CargarEstadoForm(Self);
  except
  end;
  EdtNombre.Clear;
  MmoComentario.Clear;
end;

procedure TFrmVisualPackages.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
    GuardarEstadoForm(Self);
  except
  end;
end;

procedure TFrmVisualPackages.BitBtnOkClick(Sender: TObject);
var
  Tab : String;
  i   : Integer;
begin
  if EdtNombre.Text = '' then
    ShowMessage('Debe ingresar un nombre')
  else begin
    Tab := StringOfChar(' ', FrmConfiguracion.SpnEdtTab.Value);

    // Creamos la definicin del paquete
    with TFrmEditor.Create(nil).SynEdit.Lines do
    begin
      Add('-- Paquete generado automticamente por Medusa');
      Add('');
      Add('CREATE OR REPLACE PACKAGE ' + EdtNombre.Text + ' IS');
      Add('');
      Add(Tab + '-- Autor      : ' + FrmConfiguracion.EdtUsuario.Text);
      Add(Tab + '-- Creado     : ' + DateTimeToStr(now));
      if MmoComentario.Lines.Count <> 0 then
      begin
        Add(Tab + '-- Comentario : ');
        for i := 0 to MmoComentario.Lines.Count -1 do
          Add(Tab + '-- ' + MmoComentario.Lines[i]);
      end;
      Add('');
      Add(Tab + '-- Declaraciones de tipo pblicas');
      Add(Tab + 'TYPE <NombreTipo> IS <TipoDatos>;');
      Add('');
      Add(Tab + '-- Declaraciones de constantes pblicas');
      Add(Tab + '<NombreConstante> CONSTANT <TipoDatos> := <Valor>;');
      Add('');
      Add(Tab + '-- Declaraciones de variables pblicas');
      Add(Tab + '<NombreVariable> <TipoDatos>;');
      Add('');
      Add(Tab + '-- Declaraciones de funciones y procedimientos pblicas');
      Add(Tab + 'FUNCTION <NombreFuncion>(<Parametro> <TipoDatos>) RETURN <TipoDatos>;');
      Add('');
      Add('END ' + EdtNombre.Text + ';');
      Add('/');
      Add('');
      Add('');
      Add('');
{    end;

    // Creamos el cuerpo del paquete
    with TFrmEditor.Create(nil).SynEdit.Lines do
    begin}
      Add('-- Cuerpo del paquete');
      Add('CREATE OR REPLACE PACKAGE BODY ' + EdtNombre.Text + ' IS');
      Add('');
      Add(Tab + '-- Autor      : ' + FrmConfiguracion.EdtUsuario.Text);
      Add(Tab + '-- Creado     : ' + DateTimeToStr(now));
      if MmoComentario.Lines.Count <> 0 then
      begin
        Add(Tab + '-- Comentario : ');
        for i := 0 to MmoComentario.Lines.Count -1 do
          Add(Tab + '-- ' + MmoComentario.Lines[i]);
      end;
      Add('');
      Add(Tab + '-- Declaraciones de tipo privadas');
      Add(Tab + 'TYPE <NombreTipo> IS <TipoDatos>;');
      Add('');
      Add(Tab + '-- Declaraciones de constantes privadas');
      Add(Tab + '<NombreConstante> CONSTANT <TipoDatos> := <Valor>;');
      Add('');
      Add(Tab + '-- Declaraciones de variables privadas');
      Add(Tab + '<NombreVariable> <TipoDatos>;');
      Add('');
      Add(Tab + '-- Implementacin de funciones y procedimientos');
      Add(Tab + 'FUNCTION <NombreFuncion>(<Parametro> <TipoDatos>) RETURN <TipoDatos> IS');
      Add(Tab + Tab + '<VariableLocal> <TipoDatos>;');
      Add(Tab + 'BEGIN');
      Add(Tab + Tab + '<Sentencias>;');
      Add(Tab + Tab + 'RETURN(<Result>);');
      Add(Tab + 'END;');
      Add('');
      Add('BEGIN');
      Add(Tab + '-- Inicializacin');
      Add(Tab + '<Sentencias>;');
      Add('');
      Add('END ' + EdtNombre.Text + ';');
      Add('/');
    end; // with
    Close;
  end; // else
end;

end.

// 162
