////////////////////////////////////////////////////////////////////////////////
//
// Proyecto Medusa v3.0
//
//////////////////////////////////// INFO //////////////////////////////////////
//
//  Nombre del programa : Medusa.exe
//  Fecha               : Septiembre del 2003.
//  Componentes         : DOA 3.4.6.4, SynEdit 1.1 (CVS).
//  Version compilador  : Delphi 6.0 Enterprise.
//  Descripcin         : Un cliente avanzado de Oracle
//  Autor               : Albert Philippe De La Fuente Vigliotti.
//  Tutor               : Jos Galindo Gmez.
//
////////////////////////////////////////////////////////////////////////////////

unit UVisualProcFuncs;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Buttons;

type
  TFrmVisualProcFuncs = class(TForm)
    GrpBxArgumentos: TGroupBox;
    LstVwArgumentos: TListView;
    GrpBxCabecera: TGroupBox;
    MmoComentario: TMemo;
    Label1: TLabel;
    RdGrpTipo: TRadioGroup;
    EdtNombre: TEdit;
    Label2: TLabel;
    CmBxESArg: TComboBox;
    CmBxTipoArg: TComboBox;
    CmBxTipoDevuelto: TComboBox;
    SpdBtnAniadir: TSpeedButton;
    SpdBtnEliminar: TSpeedButton;
    EdtNombreArg: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    BitBtnCancelar: TBitBtn;
    BitBtnOk: TBitBtn;
    procedure RdGrpTipoClick(Sender: TObject);
    procedure SpdBtnAniadirClick(Sender: TObject);
    procedure LstVwArgumentosSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure CmBxESArgSelect(Sender: TObject);
    procedure SpdBtnEliminarClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure EdtNombreArgChange(Sender: TObject);
    procedure BitBtnOkClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    ModalResult : Integer;
    { Public declarations }
  end;

var
  FrmVisualProcFuncs: TFrmVisualProcFuncs;

implementation

uses UGlobal, UConfiguracion, UEditor;

{$R *.dfm}

procedure TFrmVisualProcFuncs.RdGrpTipoClick(Sender: TObject);
begin
  CmBxTipoDevuelto.Enabled := RdGrpTipo.ItemIndex = 1;
end;

procedure TFrmVisualProcFuncs.SpdBtnAniadirClick(Sender: TObject);
var
  Item  : TListItem;
begin
  CmBxESArg.Text := 'Seleccionar...';
  CmBxTipoArg.Text := 'Seleccionar...';
  Item := LstVwArgumentos.Items.Add;
  Item.SubItems.Add('');
  Item.SubItems.Add('');
  Item.SubItems.Add('');
  LstVwArgumentos.Selected := LstVwArgumentos.Items[LstVwArgumentos.Items.Count - 1];
  LstVwArgumentos.Selected.Caption := IntToStr(LstVwArgumentos.Selected.Index + 1);
  EdtNombreArg.Clear;
end;

procedure TFrmVisualProcFuncs.LstVwArgumentosSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
{  if Item.SubItems.Count <> 0 then
  begin}
  if Selected then
  begin
    EdtNombreArg.OnChange     := nil;
    CmBxESArg.OnChange        := nil;
    CmBxTipoDevuelto.OnChange := nil;
    EdtNombreArg.Text := Item.SubItems[0];
    CmBxESArg.Text    := Item.SubItems[1];
    CmBxTipoArg.Text  := Item.SubItems[2];
    EdtNombreArg.OnChange     := EdtNombreArgChange;
    CmBxESArg.OnChange        := EdtNombreArgChange;
    CmBxTipoDevuelto.OnChange := EdtNombreArgChange;
  end;
    if Item.SubItems[0] = '' then
      EdtNombreArg.Text := '';
    if Item.SubItems[1] = '' then
      CmBxESArg.Text := 'Seleccionar...';
    if Item.SubItems[2] = '' then
      CmBxTipoArg.Text := 'Seleccionar...';
//  end;
  SpdBtnEliminar.Enabled := true;
//  end;
end;

procedure TFrmVisualProcFuncs.CmBxESArgSelect(Sender: TObject);
begin
  EdtNombreArgChange(nil);
end;

procedure TFrmVisualProcFuncs.SpdBtnEliminarClick(Sender: TObject);
var
  i : Integer;
begin
  if Assigned(LstVwArgumentos.Selected) then
  begin
    LstVwArgumentos.Selected.Delete;
    for i := 0 to LstVwArgumentos.Items.Count - 1 do
      LstVwArgumentos.Items[i].Caption := IntToStr(i + 1);
  end;
end;

procedure TFrmVisualProcFuncs.FormActivate(Sender: TObject);
begin
  try
    CargarEstadoForm(Self);   // Esto es por si se ejecuta desde CD...
  except
  end;
  RdGrpTipo.ItemIndex := 0;
  EdtNombre.Clear;
  CmBxTipoDevuelto.Text := 'Seleccionar...';
  MmoComentario.Lines.Clear;
  LstVwArgumentos.Clear;
  EdtNombreArg.Clear;
  CmBxESArg.Text := 'Seleccionar...';
  CmBxTipoArg.Text := 'Seleccionar...';
  SpdBtnEliminar.Enabled := false;
end;

procedure TFrmVisualProcFuncs.EdtNombreArgChange(Sender: TObject);
begin
  with LstVwArgumentos do
  begin
    if Assigned(Selected) then
    begin
      if EdtNombreArg.Text <> '' then
        Selected.SubItems[0] := EdtNombreArg.Text;

      if (CmBxESArg.Text <> 'Seleccionar...') then
        Selected.SubItems[1] := CmBxESArg.Text;
      if (CmBxTipoArg.Text <> 'Seleccionar...') then
        Selected.SubItems[2] := CmBxTipoArg.Text;
    end;
  end;
end;

procedure TFrmVisualProcFuncs.BitBtnOkClick(Sender: TObject);
var
  Error : Boolean;
  i, Temp : Integer;
  Maximo  : Integer;
  Long    : Integer;
begin
  if EdtNombre.Text = '' then
    ShowMessage('Debe ingresar un nombre para la rutina')
  else if (RdGrpTipo.ItemIndex = 1) and (CmBxTipoDevuelto.Text = 'Seleccionar...') then
    ShowMessage('Debe seleccionar el valor devuelto por la funcin')
  else begin
    i := 0;
    Error := false;
    while (not Error) and (i <= LstVwArgumentos.Items.Count - 1) do
    begin
      Error := (LstVwArgumentos.Items[i].SubItems[0] = '') or
               (LstVwArgumentos.Items[i].SubItems[1] = '') or
               (LstVwArgumentos.Items[i].SubItems[2] = '');
      inc(i);
    end;
    if Error then
      ShowMessage('Por favor revise los argumentos. La lnea ' + IntToStr(i) + ' contiene campos en blanco')
    else begin
      with TFrmEditor.Create(nil) do
      begin
        // COMENTARIOS
        SynEdit.Lines.Add('-- Cabecera generada automticamente por Medusa');
        for i := 0 to FrmVisualProcFuncs.MmoComentario.Lines.Count - 1 do
        begin
          SynEdit.Lines.Add('-- ' + FrmVisualProcFuncs.MmoComentario.Lines[i]);
        end;
      
        // CABECERA
        if FrmVisualProcFuncs.RdGrpTipo.ItemIndex = 0 then
          SynEdit.Lines.Add('CREATE OR REPLACE PROCEDURE ' + FrmVisualProcFuncs.EdtNombre.Text + ' (')
        else
          SynEdit.Lines.Add('CREATE OR REPLACE FUNCTION ' + FrmVisualProcFuncs.EdtNombre.Text + ' (');

        Maximo := 0;
        for i := 0 to FrmVisualProcFuncs.LstVwArgumentos.Items.Count - 1 do
        begin
          Temp := Length(FrmVisualProcFuncs.LstVwArgumentos.Items[i].SubItems[0]);
          if Temp > Maximo then
            Maximo := Temp;
        end;

        for i := 0 to FrmVisualProcFuncs.LstVwArgumentos.Items.Count - 1 do
        begin
          Temp := Length(FrmVisualProcFuncs.LstVwArgumentos.Items[i].SubItems[0]);
          Long := Length(FrmVisualProcFuncs.LstVwArgumentos.Items[i].SubItems[1]);
          SynEdit.Lines.Add(
            StringOfChar(' ', FrmConfiguracion.SpnEdtTab.Value) +
            FrmVisualProcFuncs.LstVwArgumentos.Items[i].SubItems[0] +
            StringOfChar(' ', Maximo - Temp + 1) +
            FrmVisualProcFuncs.LstVwArgumentos.Items[i].SubItems[1] +
            StringOfChar(' ', 6 - Long + 1) +
            FrmVisualProcFuncs.LstVwArgumentos.Items[i].SubItems[2]
          )
        end;
        SynEdit.Lines[SynEdit.Lines.Count - 1] := SynEdit.Lines[SynEdit.Lines.Count - 1] + ')';
        if FrmVisualProcFuncs.RdGrpTipo.ItemIndex = 1 then
          SynEdit.Lines.Add(' RETURN ' + FrmVisualProcFuncs.CmBxTipoDevuelto.Text + ' IS');

        // CUERPO
        SynEdit.Lines.Add('BEGIN');

        // CUERPO (CONTINUACIN)
        SynEdit.Lines.Add(StringOfChar(' ', FrmConfiguracion.SpnEdtTab.Value));
        SynEdit.CaretY := SynEdit.Lines.Count;
        SynEdit.CaretX := Length(SynEdit.Lines[SynEdit.Lines.Count - 1]) + 1;
        SynEdit.Lines.Add('END ' + FrmVisualProcFuncs.EdtNombre.Text + ';');
        SynEdit.Lines.Add('/');
      end; // with
    end; // if Error (else)
    Close
  end; // else
end;

procedure TFrmVisualProcFuncs.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
    GuardarEstadoForm(Self);
  except
  end;
end;

end.

// 262
