////////////////////////////////////////////////////////////////////////////////
//
// Proyecto Medusa v3.0
//
//////////////////////////////////// INFO //////////////////////////////////////
//
//  Nombre del programa : Medusa.exe
//  Fecha               : Septiembre del 2003.
//  Componentes         : DOA 3.4.6.4, SynEdit 1.1 (CVS).
//  Version compilador  : Delphi 6.0 Enterprise.
//  Descripcin         : Un cliente avanzado de Oracle
//  Autor               : Albert Philippe De La Fuente Vigliotti.
//  Tutor               : Jos Galindo Gmez.
//
////////////////////////////////////////////////////////////////////////////////

unit UVisualProfile;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons;

type
  TFrmVisualProfiles = class(TForm)
    EdtNombre: TEdit;
    Label1: TLabel;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    BitBtnOk: TBitBtn;
    BitBtnCancelar: TBitBtn;
    CmBxSesionesUsuario: TComboBox;
    Label2: TLabel;
    CmBxCPUSesion: TComboBox;
    Label3: TLabel;
    CmBxCPULlamada: TComboBox;
    Label4: TLabel;
    CmBxTConexion: TComboBox;
    Label5: TLabel;
    CmBxTInactividad: TComboBox;
    Label6: TLabel;
    CmBxLecturasSesion: TComboBox;
    Label7: TLabel;
    CmBxLecturasLlamada: TComboBox;
    Label8: TLabel;
    CmBxLimCombinados: TComboBox;
    Label9: TLabel;
    CmBxSGAPrivado: TComboBox;
    Label10: TLabel;
    CmBxIniciosFallidos: TComboBox;
    Label11: TLabel;
    CmBxTVidaPass: TComboBox;
    Label12: TLabel;
    CmBxTUsoPass: TComboBox;
    Label13: TLabel;
    CmBxTUsoMaxPass: TComboBox;
    Label14: TLabel;
    CmBxTBloqPass: TComboBox;
    Label15: TLabel;
    CmBxTGraciaPass: TComboBox;
    Label16: TLabel;
    CmBxFVerifPass: TComboBox;
    Label17: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtnOkClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmVisualProfiles: TFrmVisualProfiles;

implementation

uses UGlobal, UEditor, UConfiguracion;

{$R *.dfm}

procedure TFrmVisualProfiles.FormActivate(Sender: TObject);
var
  i : Integer;
begin
  try
    CargarEstadoForm(Self);
  except
  end;
  EdtNombre.Clear;
  for i := 0 to ControlCount - 1 do
    if Controls[i] is TComboBox then
      TComboBox(Controls[i]).ItemIndex := 0;
end;

procedure TFrmVisualProfiles.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
    GuardarEstadoForm(Self);
  except
  end;
end;

function ObtenerElemento(CmBx: TComboBox): String;
begin
  if CmBx.ItemIndex = 0 then
    Result := ''
  else if CmBx.ItemIndex = 1 then
    Result := 'UNLIMITED'
  else
    Result := CmBx.Text;
end;

procedure TFrmVisualProfiles.BitBtnOkClick(Sender: TObject);
var
  S   : String;
  Tab : String;
  Editor  : TFrmEditor;
begin
  if EdtNombre.Text = '' then
    ShowMessage('Debe ingresar el nombre')
  else begin
    Editor := TFrmEditor.Create(nil);
    with Editor.SynEdit.Lines, Editor.SynEdit do
    begin
      Add('-- Perfil generado automticamente por Medusa');
      Add('');
      Add('CREATE PROFILE ' + EdtNombre.Text + ' LIMIT');

      Tab := StringOfChar(' ', FrmConfiguracion.SpnEdtTab.Value);

      S := ObtenerElemento(CmBxSesionesUsuario);
      if S <> '' then
        Add(Tab + 'SESSIONS_PER_USER          ' + S);

      S := ObtenerElemento(CmBxCPUSesion);
      if S <> '' then
        Add(Tab + 'CPU_PER_SESSION            ' + S);

      S := ObtenerElemento(CmBxCPULlamada);
      if S <> '' then
        Add(Tab + 'CPU_PER_CALL               ' + S);

      S := ObtenerElemento(CmBxTConexion);
      if S <> '' then
        Add(Tab + 'CONNECT_TIME               ' + S);

      S := ObtenerElemento(CmBxTInactividad);
      if S <> '' then
        Add(Tab + 'IDLE_TIME                  ' + S);

      S := ObtenerElemento(CmBxLecturasSesion);
      if S <> '' then
        Add(Tab + 'LOGICAL_READS_PER_SESSION  ' + S);

      S := ObtenerElemento(CmBxLecturasLlamada);
      if S <> '' then
        Add(Tab + 'LOGICAL_READS_PER_CALL     ' + S);

      S := ObtenerElemento(CmBxLimCombinados);
      if S <> '' then
        Add(Tab + 'COMPOSITE_LIMIT            ' + S);

      S := ObtenerElemento(CmBxSGAPrivado);
      if S <> '' then
        Add(Tab + 'PRIVATE_SGA                ' + S);

      S := ObtenerElemento(CmBxIniciosFallidos);
      if S <> '' then
        Add(Tab + 'FAILED_LOGIN_ATTEMPTS      ' + S);

      S := ObtenerElemento(CmBxTVidaPass);
      if S <> '' then
        Add(Tab + 'PASSWORD_LIFE_TIME         ' + S);

      S := ObtenerElemento(CmBxTUsoPass);
      if S <> '' then
        Add(Tab + 'PASSWORD_REUSE_TIME        ' + S);

      S := ObtenerElemento(CmBxTUsoMaxPass);
      if S <> '' then
        Add(Tab + 'PASSWORD_REUSE_MAX         ' + S);

      S := ObtenerElemento(CmBxTBloqPass);
      if S <> '' then
        Add(Tab + 'PASSWORD_LOCK_TIME         ' + S);

      S := ObtenerElemento(CmBxTGraciaPass);
      if S <> '' then
        Add(Tab + 'PASSWORD_GRACE_TIME        ' + S);

      if CmBxFVerifPass.ItemIndex = 0 then
        S := ''
      else if CmBxFVerifPass.ItemIndex = 1 then
        S := 'NULL'
      else
        S := CmBxFVerifPass.Text;
      if S <> '' then
        Add(Tab + 'PASSWORD_VERIFY_FUNCTION   ' + S);

      Lines[Lines.Count - 1] := Lines[Lines.Count - 1] + ';';
    end;
    Close;
  end;
end;

end.

// 211
