////////////////////////////////////////////////////////////////////////////////
//
// Proyecto Medusa v3.0
//
//////////////////////////////////// INFO //////////////////////////////////////
//
//  Nombre del programa : Medusa.exe
//  Fecha               : Septiembre del 2003.
//  Componentes         : DOA 3.4.6.4, SynEdit 1.1 (CVS).
//  Version compilador  : Delphi 6.0 Enterprise.
//  Descripcin         : Un cliente avanzado de Oracle
//  Autor               : Albert Philippe De La Fuente Vigliotti.
//  Tutor               : Jos Galindo Gmez.
//
////////////////////////////////////////////////////////////////////////////////

unit UVisualSeqs;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, Buttons;

type
  TFrmVisualSeqs = class(TForm)
    EdtPropietario: TEdit;
    Label1: TLabel;
    EdtNombre: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    SpnEdtMin: TSpinEdit;
    SpnEdtMax: TSpinEdit;
    Label4: TLabel;
    SpnEdtIni: TSpinEdit;
    Label5: TLabel;
    SpnEdtInc: TSpinEdit;
    Label6: TLabel;
    SpnEdtCache: TSpinEdit;
    Label7: TLabel;
    ChkBxCiclica: TCheckBox;
    ChkBxOrdenada: TCheckBox;
    BitBtnCancelar: TBitBtn;
    BitBtnOk: TBitBtn;
    MmoComentario: TMemo;
    Label8: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtnOkClick(Sender: TObject);
    procedure SpnEdtCacheChange(Sender: TObject);
    procedure SpnEdtMinExit(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmVisualSeqs: TFrmVisualSeqs;

implementation

uses UGlobal, UEditor, UConfiguracion;

{$R *.dfm}

procedure TFrmVisualSeqs.FormActivate(Sender: TObject);
begin
  try
    CargarEstadoForm(Self);
  except
  end;
  EdtPropietario.Clear;
  EdtNombre.Clear;
  SpnEdtMin.Value   := -1;
  SpnEdtMax.Value   := -1;
  SpnEdtIni.Value   :=  0;
  SpnEdtInc.Value   :=  1;
  SpnEdtCache.Value := -1;
  MmoComentario.Clear;
  ChkBxOrdenada.Checked := false;
  ChkBxCiclica.Checked  := false;
end;

procedure TFrmVisualSeqs.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
    GuardarEstadoForm(Self);
  except
  end;
end;

procedure TFrmVisualSeqs.BitBtnOkClick(Sender: TObject);
var
  Ventana : TFrmEditor;
  i       : Integer;
  Tab     : String;
begin
  if EdtNombre.Text = '' then
    ShowMessage('Debe ingresar un nombre')
  else if (SpnEdtIni.Value > SpnEdtMax.Value) and (SpnEdtMin.Value <> -1) and (SpnEdtMax.Value <> -1) then
    ShowMessage('El valor de comienzo debe ser MENOR O IGUAL que el valor de fin')
  else begin
    Ventana := TFrmEditor.Create(nil);
    with Ventana.SynEdit.Lines do
    begin
      Tab := StringOfChar(' ', FrmConfiguracion.SpnEdtTab.Value);
      Add('-- Secuencia generada por Medusa');
      Add('');
      for i := 0 to MmoComentario.Lines.Count -1 do
        Ventana.SynEdit.Lines.Add('-- ' + MmoComentario.Lines[i]);
      Add('');

      if EdtPropietario.Text = '' then
        Add('CREATE SEQUENCE ' + EdtNombre.Text)
      else
        Add('CREATE SEQUENCE ' + EdtPropietario.Text + '.' + EdtNombre.Text);

      if SpnEdtMin.Value <> -1 then
        Add(Tab + 'MINVALUE ' + IntToStr(SpnEdtMin.Value))
      else
        Add(Tab + 'MINVALUE NOMINVALUE');

      if SpnEdtMax.Value <> -1 then
        Add(Tab + 'MAXVALUE ' + IntToStr(SpnEdtMax.Value))
      else
        Add(Tab + 'MAXVALUE NOMAXVALUE');

      Add(Tab + 'START WITH ' + IntToStr(SpnEdtIni.Value));
      Add(Tab + 'INCREMENT BY ' + IntToStr(SpnEdtInc.Value));

      if SpnEdtCache.Value <> -1 then
        Add(Tab + 'CACHE ' + IntToStr(SpnEdtCache.Value));

      if ChkBxCiclica.Checked then
        Add(Tab + 'CYCLE')
      else
        Add(Tab + 'NOCYCLE');

      if ChkBxOrdenada.Checked then
        Add(Tab + 'ORDER');

      Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1] :=
        Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1] + ';';
    end;
    Close;
  end;
end;

procedure TFrmVisualSeqs.SpnEdtCacheChange(Sender: TObject);
begin
  if TSpinEdit(Sender).Value < -1 then
    TSpinEdit(Sender).Value := -1;
end;

procedure TFrmVisualSeqs.SpnEdtMinExit(Sender: TObject);
begin
  if TEdit(Sender).Text = '' then
  begin
    ShowMessage('No pueden haber campos vacos.' + #13 + 'Se reemplazar por el valor por defecto');
    ActiveControl := TWinControl(Sender);
    TSpinEdit(Sender).Value := TSpinEdit(Sender).Tag;
  end;
end;

end.

// 169
