////////////////////////////////////////////////////////////////////////////////
//
// Proyecto Medusa v3.0
//
//////////////////////////////////// INFO //////////////////////////////////////
//
//  Nombre del programa : Medusa.exe
//  Fecha               : Septiembre del 2003.
//  Componentes         : DOA 3.4.6.4, SynEdit 1.1 (CVS).
//  Version compilador  : Delphi 6.0 Enterprise.
//  Descripcin         : Un cliente avanzado de Oracle
//  Autor               : Albert Philippe De La Fuente Vigliotti.
//  Tutor               : Jos Galindo Gmez.
//
////////////////////////////////////////////////////////////////////////////////

unit UVisualSynonyms;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons;

type
  TFrmVisualSynonyms = class(TForm)
    EdtPropietarioSinonimo: TEdit;
    Label1: TLabel;
    ChkBxPublico: TCheckBox;
    EdtNombre: TEdit;
    Label2: TLabel;
    EdtPropietarioObjeto: TEdit;
    Label3: TLabel;
    EdtObjeto: TEdit;
    Label4: TLabel;
    EdtEnlaceBD: TEdit;
    Label5: TLabel;
    BitBtnCancelar: TBitBtn;
    BitBtnOk: TBitBtn;
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ChkBxPublicoClick(Sender: TObject);
    procedure BitBtnOkClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmVisualSynonyms: TFrmVisualSynonyms;

implementation

uses UGlobal, UEditor, UConfiguracion;

{$R *.dfm}

procedure TFrmVisualSynonyms.FormActivate(Sender: TObject);
begin
  try
    CargarEstadoForm(Self);
  except
  end;
  EdtPropietarioSinonimo.Clear;
  ChkBxPublico.Checked := false;
  EdtNombre.Clear;
  EdtPropietarioObjeto.Clear;
  EdtObjeto.Clear;
  EdtEnlaceBD.Clear;
end;

procedure TFrmVisualSynonyms.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
    GuardarEstadoForm(Self);
  except
  end;
end;

procedure TFrmVisualSynonyms.ChkBxPublicoClick(Sender: TObject);
begin
  if ChkBxPublico.Checked then
  begin
    EdtPropietarioSinonimo.Text := 'PUBLIC';
    EdtPropietarioSinonimo.ReadOnly := true;
  end
  else
    EdtPropietarioSinonimo.Clear;
end;

procedure TFrmVisualSynonyms.BitBtnOkClick(Sender: TObject);
var
  Editor   : TFrmEditor;
  Str, Tab : String;
begin
  if EdtPropietarioSinonimo.Text = '' then
    ShowMessage('Debe ingresar el propietario del sinnimo')
  else if EdtNombre.Text = '' then
    ShowMessage('Debe ingresar el nombre del sinnimo')
  else if EdtObjeto.Text = '' then
    ShowMessage('Debe ingresar el nombre del objeto')
  else begin
    Editor := TFrmEditor.Create(nil);
    with Editor.SynEdit.Lines do
    begin
      Tab := StringOfChar(' ', FrmConfiguracion.SpnEdtTab.Value);
      Add('-- Sinnimo generado automticamente por Medusa');
      Add('');
      if ChkBxPublico.Checked then
        Add('CREATE ' + EdtPropietarioSinonimo.Text + ' SYNONYM ' + EdtNombre.Text)
      else
        Add('CREATE SYNONYM ' + EdtPropietarioSinonimo.Text + '.' + EdtNombre.Text);
      if EdtPropietarioObjeto.Text <> '' then
        Str := EdtPropietarioObjeto.Text + '.';
      Str := Str + EdtObjeto.Text;
      if EdtEnlaceBD.Text <> '' then
        Str := Str + '@' + EdtEnlaceBD.Text;

      Add(Tab + 'FOR ' + Str + ';');
    end;
    Close;
  end;
end;

end.

// 129
