////////////////////////////////////////////////////////////////////////////////
//
// Proyecto Medusa v3.0
//
//////////////////////////////////// INFO //////////////////////////////////////
//
//  Nombre del programa : Medusa.exe
//  Fecha               : Septiembre del 2003.
//  Componentes         : DOA 3.4.6.4, SynEdit 1.1 (CVS).
//  Version compilador  : Delphi 6.0 Enterprise.
//  Descripcin         : Un cliente avanzado de Oracle
//  Autor               : Albert Philippe De La Fuente Vigliotti.
//  Tutor               : Jos Galindo Gmez.
//
////////////////////////////////////////////////////////////////////////////////

unit UVisualTablespaces;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Spin, Buttons;

type
  TFrmVisualTablespaces = class(TForm)
    EdtNombre: TEdit;
    Label1: TLabel;
    RdGrpTipo: TRadioGroup;
    EdtFichero: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    SpnEdtTamanio: TSpinEdit;
    SpnEdtInicial: TSpinEdit;
    Label5: TLabel;
    SpnEdtSiguiente: TSpinEdit;
    Label6: TLabel;
    SpnEdtNumMinExt: TSpinEdit;
    Label7: TLabel;
    SpnEdtNumMaxExt: TSpinEdit;
    Label8: TLabel;
    SpnEdtTamMax: TSpinEdit;
    Label9: TLabel;
    SpnEdtExtMin: TSpinEdit;
    BitBtnOk: TBitBtn;
    BitBtnCancelar: TBitBtn;
    Label10: TLabel;
    SpnEdtUniforme: TSpinEdit;
    CmBxUdTamanio: TComboBox;
    CmBxUdInicial: TComboBox;
    CmBxUdSiguiente: TComboBox;
    CmBxUdTamMax: TComboBox;
    CmBxUdExtMin: TComboBox;
    CmBxUdExtUniforme: TComboBox;
    ChkBxLoggin: TCheckBox;
    ChkBxOnline: TCheckBox;
    ChkBxPermanent: TCheckBox;
    procedure FormActivate(Sender: TObject);
    procedure SpnEdtTamanioChange(Sender: TObject);
    procedure BitBtnOkClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RdGrpTipoClick(Sender: TObject);
    procedure SpnEdtTamanioExit(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmVisualTablespaces: TFrmVisualTablespaces;

implementation

uses UGlobal, UEditor, UConfiguracion;

{$R *.dfm}

procedure TFrmVisualTablespaces.FormActivate(Sender: TObject);
begin
  try
    CargarEstadoForm(Self);
  except
  end;
  RdGrpTipo.ItemIndex := 0;
  RdGrpTipoClick(nil);
  EdtNombre.Clear;
  EdtFichero.Clear;
  SpnEdtTamanio.Value     := 500;
  CmBxUdTamanio.ItemIndex := 0;
  SpnEdtInicial.Value     := 10;
  CmBxUdInicial.ItemIndex := 0;
  SpnEdtSiguiente.Value   := 50;
  CmBxUdSiguiente.ItemIndex := 0;
  SpnEdtTamMax.Value      := 10;
  CmBxUdTamMax.ItemIndex  := 1;
  SpnEdtExtMin.Value      := 64;
  CmBxUdExtMin.ItemIndex  := 0;
  SpnEdtUniforme.Value    := 128;
  CmBxUdExtUniforme.ItemIndex := 0;
  ChkBxLoggin.Checked     := false;
  ChkBxOnline.Checked     := true;
  ChkBxPermanent.Checked  := true;
end;

procedure TFrmVisualTablespaces.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
    GuardarEstadoForm(Self);
  except
  end;
end;

procedure TFrmVisualTablespaces.SpnEdtTamanioChange(Sender: TObject);
begin
  if TEdit(Sender).Text <> '' then
    if TSpinEdit(Sender).Value < 0 then
      TSpinEdit(Sender).Value := 0;
end;

procedure TFrmVisualTablespaces.RdGrpTipoClick(Sender: TObject);
begin
  // Por defecto todos deshabilitados
  SpnEdtTamanio.Enabled   := false;
  SpnEdtInicial.Enabled   := false;
  SpnEdtSiguiente.Enabled := false;
  SpnEdtNumMinExt.Enabled := false;
  SpnEdtNumMaxExt.Enabled := false;
  SpnEdtTamMax.Enabled    := false;
  SpnEdtExtMin.Enabled    := false;
  SpnEdtUniforme.Enabled  := false;
  CmBxUdTamanio.Enabled   := false;
  CmBxUdInicial.Enabled   := false;
  CmBxUdSiguiente.Enabled := false;
  CmBxUdTamMax.Enabled    := false;
  CmBxUdExtMin.Enabled    := false;
  CmBxUdExtUniforme.Enabled := false;

  ChkBxLoggin.Enabled     := true;
  ChkBxOnline.Enabled     := true;
  ChkBxPermanent.Enabled  := true;

  // Y ahora segun el tipo, vamos habilitando
  case RdGrpTipo.ItemIndex of
    0:  begin
          SpnEdtTamanio.Enabled   := true;
          SpnEdtInicial.Enabled   := true;
          SpnEdtSiguiente.Enabled := true;
          SpnEdtNumMinExt.Enabled := true;
          SpnEdtNumMaxExt.Enabled := true;

          CmBxUdTamanio.Enabled   := true;
          CmBxUdInicial.Enabled   := true;
          CmBxUdSiguiente.Enabled := true;
        end;
    1:  begin
          SpnEdtTamanio.Enabled   := true;
          SpnEdtSiguiente.Enabled := true;
          SpnEdtTamMax.Enabled    := true;

          CmBxUdTamanio.Enabled   := true;
          CmBxUdSiguiente.Enabled := true;
          CmBxUdTamMax.Enabled    := true;
        end;
    2:  begin
          SpnEdtTamanio.Enabled   := true;
          SpnEdtInicial.Enabled   := true;
          SpnEdtSiguiente.Enabled := true;
          SpnEdtExtMin.Enabled    := true;

          CmBxUdTamanio.Enabled   := true;
          CmBxUdInicial.Enabled   := true;
          CmBxUdSiguiente.Enabled := true;
          CmBxUdExtMin.Enabled    := true;
        end;
    3:  begin
          SpnEdtTamanio.Enabled   := true;
          SpnEdtUniforme.Enabled  := true;

          CmBxUdTamanio.Enabled   := true;
          CmBxUdExtUniforme.Enabled := true;
        end;
    4:  begin
          SpnEdtUniforme.Enabled  := true;

          CmBxUdExtUniforme.Enabled := true;

          ChkBxLoggin.Enabled     := false;
          ChkBxOnline.Enabled     := false;
          ChkBxPermanent.Enabled  := false;
{          ChkBxPermanent.Checked  := false;
          ChkBxPermanent.Enabled  := false;}
        end;
  end;
end;

procedure TFrmVisualTablespaces.BitBtnOkClick(Sender: TObject);
var
  Tab     : String;
  Editor  : TFrmEditor;
begin
  if EdtNombre.Text = '' then
    ShowMessage('Debe ingresar el nombre del tablespace')
  else if EdtFichero.Text = '' then
    ShowMessage('Debe ingresar el nombre del fichero')
  else begin
    Tab := StringOfChar(' ', FrmConfiguracion.SpnEdtTab.Value);

    Editor := TFrmEditor.Create(nil);
    with Editor.SynEdit.Lines, Editor.SynEdit do
    begin
      case RdGrpTipo.ItemIndex of
        0:  begin
              Add('CREATE TABLESPACE ' + EdtNombre.Text);
              Add(Tab + 'DATAFILE ''' + EdtFichero.Text + ''' SIZE ' +
                  IntToStr(SpnEdtTamanio.Value) + CmBxUdTamanio.Text[1]);
              if ChkBxLoggin.Enabled then
                Add(Tab + 'LOGGING')
              else
                Add(Tab + 'NOLOGGIN');
              Add(Tab + 'DEFAULT STORAGE (' +
                  'INITIAL ' + IntToStr(SpnEdtInicial.Value) + CmBxUdInicial.Text[1] +
                  ' NEXT ' + IntToStr(SpnEdtSiguiente.Value) + CmBxUdSiguiente.Text[1] + ')');
              Add(Tab + 'MINEXTENTS ' + IntToStr(SpnEdtNumMinExt.Value) +
                  ' MAXEXTENTS ' + IntToStr(SpnEdtNumMaxExt.Value));
            end;
        1:  begin
              Add('CREATE TABLESPACE ' + EdtNombre.Text);
              Add(Tab + 'DATAFILE ''' + EdtFichero.Text + ''' SIZE ' +
                  IntToStr(SpnEdtTamanio.Value) + CmBxUdTamanio.Text[1] + ' REUSE');
              Add(Tab + 'AUTOEXTEND ON NEXT ' +
                  IntToStr(SpnEdtSiguiente.Value) + CmBxUdSiguiente.Text[1] +
                  ' MAXSIZE ' + IntToStr(SpnEdtTamMax.Value) + CmBxUdTamMax.Text[1]);
            end;
        2:  begin
              Add('CREATE TABLESPACE ' + EdtNombre.Text);
              Add(Tab + 'DATAFILE ''' + EdtFichero.Text + ''' SIZE ' +
                  IntToStr(SpnEdtTamanio.Value) + CmBxUdTamanio.Text[1]);
              Add(Tab + 'MINIMUM EXTENT ' + IntToStr(SpnEdtExtMin.Value) + CmBxUdExtMin.Text[1]);
              if ChkBxLoggin.Enabled then
                Add(Tab + 'LOGGING')
              else
                Add(Tab + 'NOLOGGIN');
              Add(Tab + 'DEFAULT STORAGE (' +
                  'INITIAL ' + IntToStr(SpnEdtInicial.Value) + CmBxUdInicial.Text[1] +
                  ' NEXT ' + IntToStr(SpnEdtSiguiente.Value) + CmBxUdSiguiente.Text[1] + ')');
            end;
        3:  begin
              Add('CREATE TABLESPACE ' + EdtNombre.Text +
                  ' DATAFILE ''' + EdtFichero.Text + ''' SIZE ' +
                  IntToStr(SpnEdtTamanio.Value) + CmBxUdTamanio.Text[1]);
                  
              if ChkBxOnline.Checked then
                Add(Tab + 'ONLINE')
              else
                Add(Tab + 'OFFLINE');

              if ChkBxPermanent.Checked then
                Add(Tab + 'PERMANENT')
              else
                Add(Tab + 'TEMPORARY');

              Add(Tab + 'EXTENT MANAGEMENT LOCAL UNIFORM SIZE ' +
                  IntToStr(SpnEdtUniforme.Value) + CmBxUdExtUniforme.Text[1]);
            end;
        4:  begin
              Add('CREATE TEMPORARY TABLESPACE ' + EdtNombre.Text +
                  ' TEMPFILE ''' + EdtFichero.Text + '''');
              Add(Tab + 'EXTENT MANAGEMENT LOCAL UNIFORM SIZE ' +
                  IntToStr(SpnEdtUniforme.Value) + CmBxUdExtUniforme.Text[1]);
            end;
        5:  begin
              Add('CREATE TABLESPACE ' + EdtNombre.Text);
              Add(Tab + 'DATAFILE ''' + EdtFichero.Text + '''');
            end;
      end;
      if (ChkBxLoggin.Enabled) and (not (RdGrpTipo.ItemIndex in [0, 2, 4])) then
        Add(Tab + 'LOGGING')
      else if not RdGrpTipo.ItemIndex in [0, 2, 4] then
        Add(Tab + 'NOLOGGIN');

      if ChkBxOnline.Checked and (not (RdGrpTipo.ItemIndex in [3, 4])) then
        Add(Tab + 'ONLINE')
      else if not RdGrpTipo.ItemIndex in [3, 4] then
        Add(Tab + 'OFFLINE');

      if ChkBxPermanent.Checked and (not (RdGrpTipo.ItemIndex in [3, 4])) then
        Add(Tab + 'PERMANENT')
      else if not RdGrpTipo.ItemIndex in [3, 4] then
        Add(Tab + 'TEMPORARY');

      Lines[Lines.Count - 1] := Lines[Lines.Count - 1] + ';'
    end;

    Close;
  end;
end;


procedure TFrmVisualTablespaces.SpnEdtTamanioExit(Sender: TObject);
begin
  if TEdit(Sender).Text = '' then
  begin
    ShowMessage('No pueden haber campos vacos.' + #13 + 'Se reemplazar por el valor por defecto');
    ActiveControl := TWinControl(Sender);
    TSpinEdit(Sender).Value := TSpinEdit(Sender).Tag;
  end;
end;

end.

// 314
