////////////////////////////////////////////////////////////////////////////////
//
// Proyecto Medusa v3.0
//
//////////////////////////////////// INFO //////////////////////////////////////
//
//  Nombre del programa : Medusa.exe
//  Fecha               : Septiembre del 2003.
//  Componentes         : DOA 3.4.6.4, SynEdit 1.1 (CVS).
//  Version compilador  : Delphi 6.0 Enterprise.
//  Descripcin         : Un cliente avanzado de Oracle
//  Autor               : Albert Philippe De La Fuente Vigliotti.
//  Tutor               : Jos Galindo Gmez.
//
////////////////////////////////////////////////////////////////////////////////

unit UVisualTriggers;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons;

type
  TFrmVisualTriggers = class(TForm)
    RdGrpLanzamiento: TRadioGroup;
    GrpBxSentencia: TGroupBox;
    ChkBxInsert: TCheckBox;
    ChkBxDelete: TCheckBox;
    ChkBxUpdate: TCheckBox;
    ChkBxForEachRow: TCheckBox;
    GrpBxCabecera: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    EdtNombre: TEdit;
    EdtTabla: TEdit;
    MmoComentario: TMemo;
    Label3: TLabel;
    BitBtnOk: TBitBtn;
    BitBtnCancelar: TBitBtn;
    ChkBxUpdateColumna: TCheckBox;
    EdtColumna: TEdit;
    procedure FormActivate(Sender: TObject);
    procedure RdGrpLanzamientoClick(Sender: TObject);
    procedure ChkBxUpdateClick(Sender: TObject);
    procedure BitBtnOkClick(Sender: TObject);
    procedure ChkBxUpdateColumnaClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    ModalResult : Integer;
    { Public declarations }
  end;

var
  FrmVisualTriggers: TFrmVisualTriggers;

implementation

uses UGlobal, UConfiguracion, UEditor;

{$R *.dfm}

procedure TFrmVisualTriggers.FormActivate(Sender: TObject);
begin
  try
    CargarEstadoForm(Self);   // Esto es por si se ejecuta desde CD...
  except
  end;
  EdtNombre.Clear;
  EdtTabla.Clear;
  MmoComentario.Clear;
  RdGrpLanzamiento.ItemIndex := 0;
  ChkBxInsert.Checked := false;
  ChkBxDelete.Checked := false;
  ChkBxUpdate.Checked := false;
  ChkBxForEachRow.Checked := false;
end;

procedure TFrmVisualTriggers.RdGrpLanzamientoClick(Sender: TObject);
begin
  if RdGrpLanzamiento.ItemIndex = 2 then
    ChkBxForEachRow.Checked := true;
end;

procedure TFrmVisualTriggers.ChkBxUpdateClick(Sender: TObject);
begin
  if (ChkBxUpdate.Checked) {and (not ChkBxInsert.Checked and not ChkBxDelete.Checked)} then
  begin
    ChkBxUpdateColumna.Enabled := true;
//    EdtColumna.Enabled         := true
  end
  else begin
    ChkBxUpdateColumna.Enabled := false;
//    EdtColumna.Enabled         := false;
  end;
end;

procedure TFrmVisualTriggers.BitBtnOkClick(Sender: TObject);
var
  Ventana : TFrmEditor;
  Str     : String;
  i       : Integer;
begin
  if EdtNombre.Text = '' then
    ShowMessage('Debe introducir un nombre')
  else if EdtTabla.Text = '' then
    ShowMessage('Debe ingresar el nombre de la tabla')
  else if (RdGrpLanzamiento.ItemIndex in [0, 1]) and
          (not ChkBxInsert.Checked and not ChkBxDelete.Checked and not ChkBxUpdate.Checked) then
    ShowMessage('Debe seleccionar la sentencia de disparo')
  else begin
    Ventana := TFrmEditor.Create(nil);

    // CABECERA
    Ventana.SynEdit.Lines.Add('CREATE OR REPLACE TRIGGER ' + EdtNombre.Text);
    Str := StringOfChar(' ', FrmConfiguracion.SpnEdtTab.Value);
    if RdGrpLanzamiento.ItemIndex = 0 then
      Str := Str + 'BEFORE '
    else if RdGrpLanzamiento.ItemIndex = 1 then
      Str := Str + 'AFTER '
    else if RdGrpLanzamiento.ItemIndex = 2 then
      Str := Str + 'INSTEAD OF ';

    if (ChkBxInsert.Checked) and (ChkBxDelete.Checked) and (ChkBxUpdate.Checked) then
    begin
      Str := Str + 'INSERT OR DELETE OR UPDATE ';
    end
    else if (ChkBxInsert.Checked) and (ChkBxDelete.Checked) then
    begin
      Str := Str + 'INSERT OR DELETE ';
    end
    else if (ChkBxInsert.Checked) and (ChkBxUpdate.Checked) then
    begin
      Str := Str + 'INSERT OR UPDATE ';
    end
    else if (ChkBxDelete.Checked) and (ChkBxUpdate.Checked) then
    begin
      Str := Str + 'DELETE OR UPDATE ';
    end
    else if ChkBxInsert.Checked then
    begin
      Str := Str + 'INSERT ';
    end
    else if ChkBxDelete.Checked then
    begin
      Str := Str + 'DELETE ';
    end
    else if ChkBxUpdate.Checked then
    begin
      Str := Str + 'UPDATE ';
    end;

    if ChkBxUpdate.Checked and ChkBxUpdateColumna.Checked then
      Str := Str + 'OF ' + EdtColumna.Text + ' ';

    Str := Str + 'ON ' + EdtTabla.Text;

    if ChkBxForEachRow.Checked then
      Str := Str + ' FOR EACH ROW';
    Ventana.SynEdit.Lines.Add(Str);

    // CUERPO
    Ventana.SynEdit.Lines.Add('BEGIN');

    // COMENTARIOS
    Ventana.SynEdit.Lines.Add('-- Bloque generado automticamente por Medusa');
    for i := 0 to MmoComentario.Lines.Count - 1 do
    begin
      Ventana.SynEdit.Lines.Add('-- ' + MmoComentario.Lines[i]);
    end;

    // CUERPO (CONTINUACIN)
    Ventana.SynEdit.Lines.Add(StringOfChar(' ', FrmConfiguracion.SpnEdtTab.Value));
    Ventana.SynEdit.CaretY := Ventana.SynEdit.Lines.Count;
    Ventana.SynEdit.CaretX := Length(Ventana.SynEdit.Lines[Ventana.SynEdit.Lines.Count - 1]) + 1;
    Ventana.SynEdit.Lines.Add('END ' + EdtNombre.Text + ';');
    Ventana.SynEdit.Lines.Add('/');
    Close;
  end;
end;

procedure TFrmVisualTriggers.ChkBxUpdateColumnaClick(Sender: TObject);
begin
  EdtColumna.Enabled := ChkBxUpdateColumna.Checked;
end;

procedure TFrmVisualTriggers.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
    GuardarEstadoForm(Self);
  except
  end;
end;

end.

// 201
