////////////////////////////////////////////////////////////////////////////////
//
// Proyecto Medusa v3.0
//
//////////////////////////////////// INFO //////////////////////////////////////
//
//  Nombre del programa : Medusa.exe
//  Fecha               : Septiembre del 2003.
//  Componentes         : DOA 3.4.6.4, SynEdit 1.1 (CVS).
//  Version compilador  : Delphi 6.0 Enterprise.
//  Descripcin         : Un cliente avanzado de Oracle
//  Autor               : Albert Philippe De La Fuente Vigliotti.
//  Tutor               : Jos Galindo Gmez.
//
////////////////////////////////////////////////////////////////////////////////

unit UVisualUsers;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Oracle;

type
  TFrmVisualUsers = class(TForm)
    EdtNombre: TEdit;
    Label1: TLabel;
    EdtPassword: TEdit;
    Label2: TLabel;
    CmBxTablespace: TComboBox;
    CmBxTablespaceTemp: TComboBox;
    CmBxPerfil: TComboBox;
    ChkBxExpira: TCheckBox;
    ChkBxBloqueada: TCheckBox;
    ChkBxIdentifExt: TCheckBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    BitBtnOk: TBitBtn;
    BitBtnCancelar: TBitBtn;
    OracleQry: TOracleQuery;
    EdtPerfil: TEdit;
    ChkBxCuotaTablespace: TCheckBox;
    EdtCuotaTablespace: TEdit;
    EdtCuotaTablespaceTemp: TEdit;
    ChkBxCuotaTablespaceTemp: TCheckBox;
    EdtRePassword: TEdit;
    Label6: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtnOkClick(Sender: TObject);
    procedure ChkBxCuotaTablespaceClick(Sender: TObject);
    procedure ChkBxCuotaTablespaceTempClick(Sender: TObject);
    procedure ChkBxIdentifExtClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmVisualUsers: TFrmVisualUsers;

implementation

uses UGlobal, UPrincipal, UEditor, UConfiguracion;

{$R *.dfm}

procedure TFrmVisualUsers.FormActivate(Sender: TObject);
begin
  try
    CargarEstadoForm(Self);
  except
  end;
  EdtNombre.Clear;
  EdtPassword.Clear;
  EdtRePassword.Clear;
  CmBxTablespace.Clear;
  CmBxTablespaceTemp.Clear;
  EdtCuotaTablespace.Clear;
  EdtCuotaTablespaceTemp.Clear;
//  CmBxPerfil.Clear;
  ChkBxIdentifExt.Checked := false;
  CmBxTablespace.Text     := 'Seleccionar...';
  CmBxTablespaceTemp.Text := 'Seleccionar...';
//  CmBxPerfil.Text         := 'Seleccionar...';
  EdtPerfil.Clear;
  ChkBxCuotaTablespace.Checked     := false;
  ChkBxCuotaTablespaceTemp.Checked := false;
  ChkBxExpira.Checked     := false;
  ChkBxBloqueada.Checked  := false;
  OracleQry.Session := TFrmEditor(FrmPrincipal.ActiveMDIChild).OracleSession;
  with OracleQry, OracleQry.SQL do
  begin
    // Cargo los tablespaces
    Clear;
    Close;
    Add('SELECT TABLESPACE_NAME');
    Add('FROM USER_TABLESPACES');
    Execute;
    while not Eof do
    begin
      CmBxTablespace.Items.Add(Field('TABLESPACE_NAME'));
      CmBxTablespaceTemp.Items.Add(Field('TABLESPACE_NAME'));
      OracleQry.Next;
    end;

    // Cargo los perfiles
{    Clear;
    Close;
    Add('SELECT ???');
    Add('FROM ???');
    Execute;
    while not Eof do
    begin
      CmBxPerfil.Items.Add(Field('???'));
      OracleQry.Next;
    end;}
  end;
end;

procedure TFrmVisualUsers.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
    GuardarEstadoForm(Self);
  except
  end;
end;

procedure TFrmVisualUsers.BitBtnOkClick(Sender: TObject);
var
  Tab : String;
  Editor  : TFrmEditor;
begin
  if EdtNombre.Text = '' then
    ShowMessage('Debe indicar un nombre')
  else if CmBxTablespace.Text = 'Seleccionar...' then
    ShowMessage('Debe seleccionar un tablespace por defecto')
  else if CmBxTablespaceTemp.Text = 'Seleccionar...' then
    ShowMessage('Debe seleccionar un tablespace temporal')
  else if ChkBxCuotaTablespace.Checked and (EdtCuotaTablespace.Text = '') then
    ShowMessage('Debe indicar la cuota para el tablespace')
  else if ChkBxCuotaTablespaceTemp.Checked and (EdtCuotaTablespaceTemp.Text = '') then
    ShowMessage('Debe indicar la cuota para el tablespace temporal')
  else if (not ChkBxIdentifExt.Checked) and (EdtPassword.Text <> EdtRePassword.Text) then
    ShowMessage('ERROR: Las contraseas no coinciden')
  else begin
    Editor := TFrmEditor.Create(nil);
    with Editor.SynEdit.Lines, Editor.SynEdit do
    begin
      Add('-- Usuario generado por Medusa');
      Add('');

      Tab := StringOfChar(' ', FrmConfiguracion.SpnEdtTab.Value);

      Add('CREATE USER ' + EdtNombre.Text);
      if ChkBxIdentifExt.Checked then
        Add(Tab + 'IDENTIFIED EXTERNALLY')
      else
        Add(Tab + 'IDENTIFIED BY ' + EdtPassword.Text);

      Add(Tab + 'DEFAULT TABLESPACE ' + CmBxTablespace.Text);
      Add(Tab + 'TEMPORARY TABLESPACE ' + CmBxTablespaceTemp.Text);

      if ChkBxCuotaTablespace.Checked then
        Add(Tab + 'QUOTA ' + EdtCuotaTablespace.Text + ' ON ' + CmBxTablespace.Text);

      if ChkBxCuotaTablespaceTemp.Checked then
        Add(Tab + 'QUOTA ' + EdtCuotaTablespaceTemp.Text + ' ON ' + CmBxTablespaceTemp.Text);

      if EdtPerfil.Text <> '' then
        Add(Tab + 'PROFILE ' + EdtPerfil.Text);

      if ChkBxExpira.Checked then
        Add(Tab + 'PASSWORD EXPIRE');
      if ChkBxBloqueada.Checked then
        Add(Tab + 'ACCOUNT LOCK');

      Lines[Lines.Count - 1] := Lines[Lines.Count - 1] + ';';
    end;
    Close;
  end;
end;

procedure TFrmVisualUsers.ChkBxCuotaTablespaceClick(Sender: TObject);
begin
  EdtCuotaTablespace.Enabled := ChkBxCuotaTablespace.Checked;
end;

procedure TFrmVisualUsers.ChkBxCuotaTablespaceTempClick(Sender: TObject);
begin
  EdtCuotaTablespaceTemp.Enabled := ChkBxCuotaTablespaceTemp.Checked;
end;

procedure TFrmVisualUsers.ChkBxIdentifExtClick(Sender: TObject);
begin
  if not ChkBxIdentifExt.Checked then
  begin
    EdtPassword.Enabled   := true;
    EdtRePassword.Enabled := true;
  end
  else begin
    EdtPassword.Enabled   := false;
    EdtRePassword.Enabled := false;
  end;
end;

end.

// 213
