////////////////////////////////////////////////////////////////////////////////
//
// Proyecto Medusa v3.0
//
//////////////////////////////////// INFO //////////////////////////////////////
//
//  Nombre del programa : Medusa.exe
//  Fecha               : Septiembre del 2003.
//  Componentes         : DOA 3.4.6.4, SynEdit 1.1 (CVS).
//  Version compilador  : Delphi 6.0 Enterprise.
//  Descripcin         : Un cliente avanzado de Oracle
//  Autor               : Albert Philippe De La Fuente Vigliotti.
//  Tutor               : Jos Galindo Gmez.
//
////////////////////////////////////////////////////////////////////////////////

unit UVisualViews;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, SynEdit, StdCtrls, ExtCtrls, Buttons;

type
  TFrmVisualViews = class(TForm)
    SynEdtConsulta: TSynEdit;
    RdGrpTipoVista: TRadioGroup;
    RdGrpTipoRefresco: TRadioGroup;
    GrpBxRefresco: TGroupBox;
    EdtRefresco: TEdit;
    LblRefresco: TLabel;
    RdGrpUnidadRefresco: TRadioGroup;
    BitBtnOk: TBitBtn;
    BitBtnCancelar: TBitBtn;
    MmoComentario: TMemo;
    Label2: TLabel;
    Label3: TLabel;
    EdtNombre: TEdit;
    Label4: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtnOkClick(Sender: TObject);
    procedure RdGrpTipoVistaClick(Sender: TObject);
    procedure RdGrpTipoRefrescoClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmVisualViews: TFrmVisualViews;

implementation

uses UGlobal, UEditor, UConfiguracion, UDMGlobal;

{$R *.dfm}

procedure TFrmVisualViews.FormActivate(Sender: TObject);
begin
  try
    CargarEstadoForm(Self);
  except
  end;
  EdtNombre.Clear;
  RdGrpTipoVista.ItemIndex := 0;
  RdGrpTipoRefresco.ItemIndex := 3;
  EdtRefresco.Clear;
  RdGrpUnidadRefresco.ItemIndex := 1;
  MmoComentario.Clear;
  ConfigSynEditDefecto(SynEdtConsulta);
end;

procedure TFrmVisualViews.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
    GuardarEstadoForm(Self);
  except
  end;
end;

procedure TFrmVisualViews.BitBtnOkClick(Sender: TObject);
var
  Tab : String;
  i   : Integer;
  Str : String;
begin
  if EdtNombre.Text = '' then
    ShowMessage('Debe introducir un nombre')
  else if (RdGrpTipoVista.ItemIndex = 1) and (EdtRefresco.Text = '') then
    ShowMessage('Debe indicar la periodicidad del refresco')
  else if SynEdtConsulta.Lines.Count = 0 then
    ShowMessage('Debe indicar la consulta asociada a la vista')  
  else begin
    with TFrmEditor.Create(nil).SynEdit.Lines do
    begin
      Add('-- Vista generada automticamente por Medusa');
      Add('');

      // COMENTARIOS
      for i := 0 to MmoComentario.Lines.Count - 1 do
      begin
        Add('-- ' + MmoComentario.Lines[i]);
      end;

      if RdGrpTipoRefresco.ItemIndex = 1 then
      begin
        Add('');
        Add('-- Vista materializada LOG para refresco RPIDO');
        Add(Tab + 'CREATE MATERIALIZED VIEW <LOG> ON <Tabla>');
        Add(Tab + 'INCLUDING NEW VALUES;');
      end;

      Tab := StringOfChar(' ', FrmConfiguracion.SpnEdtTab.Value);
      Add('');
      if RdGrpTipoVista.ItemIndex = 0 then
        Add('CREATE OR REPLACE VIEW ' + EdtNombre.Text)
      else begin
        Add('CREATE OR REPLACE MATERIALIZED VIEW ' + EdtNombre.Text);

        case RdGrpTipoRefresco.ItemIndex of
          0: Add(Tab + 'REFRESH NEVER');
          1: Add(Tab + 'REFRESH FAST');
          2: Add(Tab + 'REFRESH COMPLETE');
          3: Add(Tab + 'REFRESH FORCE');
        end;

        Add(Tab + 'START WITH SYSDATE');
        Str := 'NEXT SYSDATE';

        case RdGrpUnidadRefresco.ItemIndex of
          0: Str := Str + ' + ' + EdtRefresco.Text + ' / ' + '(24 * 60)';
          1: Str := Str + ' + ' + EdtRefresco.Text;
          2: Str := Str + ' + ' + EdtRefresco.Text + ' * 30';
          3: Str := Str + ' + ' + EdtRefresco.Text + ' * 30 * 12';
        end;
        Add(Tab + Str);
      end;

      Add(Tab + 'AS');
      for i := 0 to SynEdtConsulta.Lines.Count - 1 do
      begin
        Add(Tab + SynEdtConsulta.Lines[i]);
      end;

      Close;
    end;
  end;
end;

procedure TFrmVisualViews.RdGrpTipoVistaClick(Sender: TObject);
begin
  if RdGrpTipoVista.ItemIndex = 0 then
  begin
    RdGrpTipoRefresco.Enabled   := false;
    RdGrpUnidadRefresco.Enabled := false;
    EdtRefresco.Enabled         := false;
    LblRefresco.Enabled         := false;
  end
  else begin
    RdGrpTipoRefresco.Enabled   := true;
    RdGrpUnidadRefresco.Enabled := true;
    EdtRefresco.Enabled         := true;
    LblRefresco.Enabled         := true;
  end;
end;

procedure TFrmVisualViews.RdGrpTipoRefrescoClick(Sender: TObject);
begin
  if RdGrpTipoRefresco.ItemIndex = 0 then
  begin
    RdGrpUnidadRefresco.Enabled := false;
    EdtRefresco.Enabled         := false;
    LblRefresco.Enabled         := false;
  end
  else begin
    RdGrpUnidadRefresco.Enabled := true;
    EdtRefresco.Enabled         := true;
    LblRefresco.Enabled         := true;
  end;
end;

end.

// 188

// 12158 (hasta aqu)
